string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture BaseSampler <string UIWidget = "None"; string SasBindAddress = "Decal.BaseTexture";>; // 2
sampler2D BaseSamplerSampler <string Texture = "BaseSampler"; string UIWidget = "None"; string SasBindAddress = "Decal.BaseTexture";> =
sampler_state
{
    Texture = <BaseSampler>; // 5
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
texture MaskSampler <string UIWidget = "None"; string SasBindAddress = "Decal.MaskTexture";>; // 9
sampler2D MaskSamplerSampler <string Texture = "MaskSampler"; string UIWidget = "None"; string SasBindAddress = "Decal.MaskTexture";> =
sampler_state
{
    Texture = <MaskSampler>; // 12
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
column_major float4x4 WorldViewProjection : WorldViewProjection : register(vs_2_0, c11);
row_major float4x3 World : World;
float Time : Time;
// MergeCombinePass_PixelShader1 Pixel_2_0 Has PRES False
struct MergeCombinePass_PixelShader1_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 MergeCombinePass_PixelShader1(MergeCombinePass_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// MergeCombinePass_VertexShader2 Vertex_2_0 Has PRES False
struct MergeCombinePass_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct MergeCombinePass_VertexShader2_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

MergeCombinePass_VertexShader2_Output MergeCombinePass_VertexShader2(MergeCombinePass_VertexShader2_Input i)
{
    MergeCombinePass_VertexShader2_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// MergeStencilPass_PixelShader3 Pixel_2_0 Has PRES False
struct MergeStencilPass_PixelShader3_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 MergeStencilPass_PixelShader3(MergeStencilPass_PixelShader3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(MaskSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// MergeStencilPass_VertexShader4 Vertex_2_0 Has PRES False
struct MergeStencilPass_VertexShader4_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct MergeStencilPass_VertexShader4_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

MergeStencilPass_VertexShader4_Output MergeStencilPass_VertexShader4(MergeStencilPass_VertexShader4_Input i)
{
    MergeStencilPass_VertexShader4_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Multiply_PixelShader5 Pixel_2_0 Has PRES False
struct Multiply_PixelShader5_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Multiply_PixelShader5(Multiply_PixelShader5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Multiply_VertexShader6 Vertex_2_0 Has PRES False
struct Multiply_VertexShader6_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Multiply_VertexShader6_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Multiply_VertexShader6_Output Multiply_VertexShader6(Multiply_VertexShader6_Input i)
{
    Multiply_VertexShader6_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Add_PixelShader7 Pixel_2_0 Has PRES False
struct Add_PixelShader7_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Add_PixelShader7(Add_PixelShader7_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Add_VertexShader8 Vertex_2_0 Has PRES False
struct Add_VertexShader8_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Add_VertexShader8_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Add_VertexShader8_Output Add_VertexShader8(Add_VertexShader8_Input i)
{
    Add_VertexShader8_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Alpha_PixelShader9 Pixel_2_0 Has PRES False
struct Alpha_PixelShader9_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Alpha_PixelShader9(Alpha_PixelShader9_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Alpha_VertexShader10 Vertex_2_0 Has PRES False
struct Alpha_VertexShader10_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha_VertexShader10_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Alpha_VertexShader10_Output Alpha_VertexShader10(Alpha_VertexShader10_Input i)
{
    Alpha_VertexShader10_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

technique Alpha
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha_VertexShader10(); // 16
        PixelShader = compile ps_2_0 Alpha_PixelShader9(); // 17
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
        DepthBias = -0.0001;
    }
}

technique Add
{
    pass P0
    {
        VertexShader = compile vs_2_0 Add_VertexShader8(); // 18
        PixelShader = compile ps_2_0 Add_PixelShader7(); // 19
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
        DepthBias = -0.0001;
    }
}

technique Multiply
{
    pass P0
    {
        VertexShader = compile vs_2_0 Multiply_VertexShader6(); // 20
        PixelShader = compile ps_2_0 Multiply_PixelShader5(); // 21
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 2;
        AlphaBlendEnable = 1;
        SrcBlend = 1;
        DestBlend = 3;
        AlphaTestEnable = 0;
        DepthBias = -0.0001;
    }
}

technique MergeStencilPass
{
    pass P0
    {
        VertexShader = compile vs_2_0 MergeStencilPass_VertexShader4(); // 22
        PixelShader = compile ps_2_0 MergeStencilPass_PixelShader3(); // 23
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 2;
        ColorWriteEnable = 0;
        AlphaBlendEnable = 1;
        SrcBlend = 1;
        DestBlend = 2;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
        StencilFunc = 8;
        StencilPass = 3;
        StencilEnable = 1;
        StencilRef = 255;
        StencilMask = 4;
        StencilWriteMask = 4;
        StencilZFail = 1;
        StencilFail = 1;
        DepthBias = -0.0001;
    }
}

technique MergeCombinePass
{
    pass P0
    {
        VertexShader = compile vs_2_0 MergeCombinePass_VertexShader2(); // 24
        PixelShader = compile ps_2_0 MergeCombinePass_PixelShader1(); // 25
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 2;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        ColorWriteEnable = 15;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
        StencilFunc = 6;
        StencilPass = 1;
        StencilEnable = 1;
        StencilRef = 255;
        StencilMask = 4;
        StencilWriteMask = 4;
        StencilZFail = 1;
        StencilFail = 1;
        DepthBias = -0.0001;
    }
}

