string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
struct
{
    float4 VideoTex_NumPerRow_LastFrame_SingleRow_isRand;
    float4 ColorAnimationFunctions[6];
    float4 TimeKeys;
    int ShaderType;
    float SpeedMultiplier;
    float2 ColorScaleRange;
} Draw : register(vs_2_0, c40) <string UIWidget = "None"; string SasBindAddress = "Particle.Draw";> = { 4, 15, -1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, -0.1, 0.2 };
struct
{
    float3 Gravity;
    float3 DriftVelocity;
    float2 VelocityDampingRange;
} Physics : register(vs_2_0, c72) <string UIWidget = "None"; string SasBindAddress = "Particle.Physics";> = { 0, 0, 0, 0, 0, 0, 1, 0 };
struct
{
    float3 Size_Rate_Damping__Min;
    float3 Size_Rate_Damping__Spread;
    float3 XYRotation_Rate_Damping__Min;
    float3 XYRotation_Rate_Damping__Spread;
    float3 ZRotation_Rate_Damping__Min;
    float3 ZRotation_Rate_Damping__Spread;
} Update : register(vs_2_0, c58) <string UIWidget = "None"; string SasBindAddress = "Particle.Update";> = { 0, 0, 1, 10, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0 };
int _SasGlobal : SasGlobal <string UIWidget = "None"; int3 SasVersion = int3(1, 0, 0); string RenderBin = "Distorter";>;
texture NormalTexture <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 10
sampler2D NormalTextureSampler : register(ps_2_0, s0) <string Texture = "NormalTexture"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <NormalTexture>; // 13
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture DepthTexture <string SasBindAddress = "WW3D.DepthTexture";>; // 17
sampler2D DepthTextureSampler : register(ps_2_0, s1) <string Texture = "DepthTexture"; string SasBindAddress = "WW3D.DepthTexture";> =
sampler_state
{
    Texture = <DepthTexture>; // 19
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
bool ShouldDrawParticleSoft <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.ShouldDrawParticleSoft";>;
column_major float4x4 WorldView : WorldView : register(vs_2_0, c64);
column_major float4x4 Projection : Projection : register(vs_2_0, c68);
row_major float4x4 WorldViewProjection : WorldViewProjection;
column_major float4x3 View : View : register(vs_2_0, c75);
row_major float4x3 World : World;
row_major float4x4 ProjectionI : ProjectionInverse;
float Time : Time;
// PS_Array_H_Shader_0 Pixel_2_0 Has PRES False
struct PS_Array_H_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
};

float4 PS_Array_H_Shader_0(PS_Array_H_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2, -1, 0.5, 0
    // dcl t0.xy
    // dcl t1
    // dcl t2.xyz
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(NormalTextureSampler, i.texcoord.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r1.w, r0.w, t1.w
    temp1.w = temp0.w * i.texcoord1.w;
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r2, t2
    temp0.x = dot(temp2.xyz, i.texcoord2.xyz);
    // dp3 r0.y, r2, t3
    temp0.y = dot(temp2.xyz, i.texcoord3.xyz);
    // dp3 r0.z, r2, t4
    temp0.z = dot(temp2.xyz, i.texcoord4.xyz);
    // mul r0.xyz, r0, t1
    temp0.xyz = temp0.xyz * i.texcoord1.xyz;
    // mad r1.xyz, r0, c0.z, c0.z
    temp1.xyz = temp0.xyz * float3(0.5, 0.5, 0.5) + float3(0.5, 0.5, 0.5);
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_Array_H_Shader_1 Pixel_2_0 Has PRES False
struct PS_Array_H_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float4 texcoord5 : TEXCOORD5;
    float2 texcoord6 : TEXCOORD6;
};

float4 PS_Array_H_Shader_1(PS_Array_H_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, -1, 0.5, -0.5
    // dcl t0.xy
    // dcl t1
    // dcl t2.xyz
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl t5
    // dcl t6.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(NormalTextureSampler, i.texcoord.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r0.w, r0.w, t1.w
    temp0.w = temp0.w * i.texcoord1.w;
    // nrm r1.xyz, r0
    temp1.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r1, t2
    temp0.x = dot(temp1.xyz, i.texcoord2.xyz);
    // dp3 r0.y, r1, t3
    temp0.y = dot(temp1.xyz, i.texcoord3.xyz);
    // dp3 r0.z, r1, t4
    temp0.z = dot(temp1.xyz, i.texcoord4.xyz);
    // mul r0.xyz, r0, t1
    temp0.xyz = temp0.xyz * i.texcoord1.xyz;
    // mad r1.xyz, r0, c0.z, c0.z
    temp1.xyz = temp0.xyz * float3(0.5, 0.5, 0.5) + float3(0.5, 0.5, 0.5);
    // rcp r0.x, t5.w
    temp0.x = 1.0f / i.texcoord5.w;
    // mul r0.xy, r0.x, t5
    temp0.xy = temp0.xx * i.texcoord5.xy;
    // mad r0.xy, r0, -c0.wzyx, -c0.w
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r2, r0, s1
    temp2 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r2.x, -t6.y, t6.x
    temp0.x = saturate(temp2.x * -i.texcoord6.y + i.texcoord6.x);
    // mul r1.w, r0.w, r0.x
    temp1.w = temp0.w * temp0.x;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

PixelShader PS_Array_H[2] = {
    compile ps_2_0 PS_Array_H_Shader_0(), // 24
    compile ps_2_0 PS_Array_H_Shader_1(), // 25
};
// Default_M_PixelShader3 Pixel_2_0 Has PRES False
struct Default_M_PixelShader3_Input
{
    float2 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
};

float4 Default_M_PixelShader3(Default_M_PixelShader3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2, -1, 0.5, 0
    // dcl t0.xy
    // dcl t1
    // dcl t2.xyz
    // dcl t3.xyz
    // dcl t4.xyz
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(NormalTextureSampler, i.texcoord.xy);
    // mad r0.xyz, r0, c0.x, c0.y
    temp0.xyz = temp0.xyz * float3(2, 2, 2) + float3(-1, -1, -1);
    // mul r1.w, r0.w, t1.w
    temp1.w = temp0.w * i.texcoord1.w;
    // nrm r2.xyz, r0
    temp2.xyz = normalize(temp0.xyz).xyz;
    // dp3 r0.x, r2, t2
    temp0.x = dot(temp2.xyz, i.texcoord2.xyz);
    // dp3 r0.y, r2, t3
    temp0.y = dot(temp2.xyz, i.texcoord3.xyz);
    // dp3 r0.z, r2, t4
    temp0.z = dot(temp2.xyz, i.texcoord4.xyz);
    // mul r0.xyz, r0, t1
    temp0.xyz = temp0.xyz * i.texcoord1.xyz;
    // mad r1.xyz, r0, c0.z, c0.z
    temp1.xyz = temp0.xyz * float3(0.5, 0.5, 0.5) + float3(0.5, 0.5, 0.5);
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// Default_M_VertexShader4 Vertex_2_0 Has PRES True
struct Default_M_VertexShader4_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_M_VertexShader4_Output
{
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float2 texcoord : TEXCOORD;
    float2 texcoord6 : TEXCOORD6;
    float4 position : POSITION;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord1 : TEXCOORD1;
};

Default_M_VertexShader4_Output Default_M_VertexShader4(Default_M_VertexShader4_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 51
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 7
      Unknown3: 0
      Unknown4: 0
      Unknown5: 51
      Unknown6: 1
      Mappings: 2
        0 - ConstOutput: 53 ConstInput 5
        1 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    float4 expr57;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c51.x, c7.x, (30)
        expr51.x = Time.x * (30);
        // mul r0.x, c0.z, c1.y
        temp0.x = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).y;
        // mul r0.y, c0.x, c1.z
        temp0.y = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).z;
        // mul r0.z, c0.y, c1.x
        temp0.z = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).x;
        // neg r1.xyz, r0.xyz
        temp1.xyz = -temp0.xyz;
        // mul r0.x, c0.y, c1.z
        temp0.x = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).z;
        // mul r0.y, c0.z, c1.x
        temp0.y = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).x;
        // mul r0.z, c0.x, c1.y
        temp0.z = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).y;
        // add r2.xyz, r1.xyz, r0.xyz
        temp2.xyz = temp1.xyz + temp0.xyz;
        // dot r0.xyz, r2.xyz, c3.xyz
        temp0.xyz = dot(temp2.xyz, (World._m00_m10_m20_m30).xyz);
        // dot r0.yzw, r2.xyz, c4.xyz
        temp0.yzw = dot(temp2.xyz, (World._m01_m11_m21_m31).xyz);
        // dot r0.zwx, r2.xyz, c5.xyz
        temp0.zwx = dot(temp2.xyz, (World._m02_m12_m22_m32).xyz);
        // dot r1.xyz, r0.xyz, r0.xyz
        temp1.xyz = dot(temp0.xyz, temp0.xyz);
        // rsq r0.w, r1.x
        temp0.w = 1.0f / sqrt(temp1.x);
        // mul r1.xyz, r0.w, r0.xyz
        temp1.xyz = temp0.w * temp0.xyz;
        // dot c55.xyz, r1.xyz, c0.xyz
        expr55.xyz = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
        // dot c56.xyz, r1.xyz, c1.xyz
        expr56.xyz = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
        // dot c57.xyz, r1.xyz, c2.xyz
        expr57.xyz = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
        // rcp c53.x, c6.y
        expr53.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // rcp c54.x, c6.x
        expr54.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
    }

    Default_M_VertexShader4_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float4 addr0;
    float3 temp6;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c38, 1, -1, 0.5, 0
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0.2
    // def c31, 0, 0, 6.283185, -3.141593
    // def c37, 0.1875, 4.8125, 2.75, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c39, 2, 1, -1, 0
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c63
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.xyz, r1, r2, c62
    temp1.xyz = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // add r0.w, r1.z, c28.w
    temp0.w = temp1.z + float1(-1);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // sge r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w >= temp0.w) ? 1 : 0;
    // lrp r2.x, r0.w, c29.z, r1.z
    temp2.x = lerp(temp1.z, float1(1.0001), temp0.w);
    // log r0.w, r2.x
    temp0.w = log2(temp2.x);
    // mul r1.z, r0.w, c29.w
    temp1.z = temp0.w * float1(0.6931472);
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // add r1.w, -v1.w, c51.x
    temp1.w = -i.texcoord.w + expr51.x;
    // mul r0.w, r0.w, r1.w
    temp0.w = temp0.w * temp1.w;
    // exp r0.w, r0.w
    temp0.w = exp2(temp0.w);
    // add r0.w, r0.w, c28.w
    temp0.w = temp0.w + float1(-1);
    // mul r0.w, r1.z, r0.w
    temp0.w = temp1.z * temp0.w;
    // mad r0.w, r1.y, r0.w, r1.x
    temp0.w = temp1.y * temp0.w + temp1.x;
    // mad r0.w, r0.w, c30.z, c30.y
    temp0.w = temp0.w * float1(0.15915494) + float1(0.5);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mad r0.w, r0.w, c31.z, c31.w
    temp0.w = temp0.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r0.w, c0, c1
    temp2.xy = float2(cos(temp0.w), sin(temp0.w));
    // mul r1.xyz, r2.y, c76
    temp1.xyz = temp2.yyy * (View._m01_m11_m21_m31).xyz;
    // mad r1.xyz, r2.x, c75, r1
    temp1.xyz = temp2.xxx * (View._m00_m10_m20_m30).xyz + temp1.xyz;
    // dp3 oT2.x, r1, c75
    o.texcoord2.x = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.x, r1, c76
    o.texcoord3.x = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.x, r1, c77
    o.texcoord4.x = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // mul r1.xyz, r2.x, c76
    temp1.xyz = temp2.xxx * (View._m01_m11_m21_m31).xyz;
    // mad r1.xyz, -r2.y, c75, r1
    temp1.xyz = -temp2.yyy * (View._m00_m10_m20_m30).xyz + temp1.xyz;
    // dp3 oT2.y, r1, c75
    o.texcoord2.y = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.y, r1, c76
    o.texcoord3.y = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.y, r1, c77
    o.texcoord4.y = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // mad r1.xy, v2.x, c37.x, c37.yzzw
    temp1.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r1.xy, r1
    temp1.xy = frac(temp1.xy);
    // mul r1.xy, r1, c28.z
    temp1.xy = temp1.xy * float2(16, 16);
    // frc r2.zw, r1.xyxy
    temp2.zw = frac(temp1.xy);
    // add r1.xy, r1, -r2.zwzw
    temp1.xy = temp1.xy + -temp2.zw;
    // mov r3.y, c40.y
    temp3.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mova a0.w, r1.x
    addr0.w = temp1.x;
    // mul r0.w, r3.y, c11[a0.w].x
    temp0.w = temp3.y * float1(0.957897);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mova a0.w, r1.x
    addr0.w = temp1.x;
    // mad r0.w, c11[a0.w].x, r3.y, -r0.w
    temp0.w = float1(0.957897) * temp3.y + -temp0.w;
    // mov r3.xy, c50
    temp3.xy = Draw.ColorScaleRange.xy;
    // mova a0.w, r1.y
    addr0.w = temp1.y;
    // mad r1.x, c11[a0.w].x, r3.y, r3.x
    temp1.x = float1(0.957897) * temp3.y + temp3.x;
    // mad r0.w, r1.w, c49.x, r0.w
    temp0.w = temp1.w * Draw.SpeedMultiplier.x + temp0.w;
    // mul r0.w, r0.w, c53.x
    temp0.w = temp0.w * expr53.x;
    // abs r1.y, r0.w
    temp1.y = abs(temp0.w);
    // sge r0.w, r0.w, -r0.w
    temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // lrp r2.z, r0.w, r1.y, -r1.y
    temp2.z = lerp(-temp1.y, temp1.y, temp0.w);
    // mul r0.w, r2.z, c40.y
    temp0.w = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.z, r0.w, c54.x
    temp1.z = temp0.w * expr54.x;
    // abs r0.w, r1.z
    temp0.w = abs(temp1.z);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r2.z, r1.z, -r1.z
    temp2.z = (temp1.z >= -temp1.z) ? 1 : 0;
    // lrp r3.x, r2.z, r0.w, -r0.w
    temp3.x = lerp(-temp0.w, temp0.w, temp2.z);
    // mul r1.y, r3.x, c40.x
    temp1.y = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r1.xyyz
    temp2.zw = frac(temp1.yz);
    // add r1.yz, r1, -r2.xzww
    temp1.yz = temp1.yz + -temp2.zw;
    // slt r0.w, v0.w, r1.w
    temp0.w = (i.position.w < temp1.w) ? 1 : 0;
    // mad r0.w, r0.w, -v2.y, v2.y
    temp0.w = temp0.w * -i.texcoord1.y + i.texcoord1.y;
    // frc r2.z, r0.w
    temp2.z = frac(temp0.w);
    // add r0.w, r0.w, -r2.z
    temp0.w = temp0.w + -temp2.z;
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mov r3.xy, c27[a0.w]
    temp3.xy = float2(-0.5, -0.5);
    // mad r2.zw, r3.xyxy, c38.xyxy, c38.z
    temp2.zw = temp3.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r1.yz, r1, r2.xzww
    temp1.yz = temp1.yz + temp2.zw;
    // mul oT0.xy, r1.yzzw, c54.x
    o.texcoord = temp1.yzzw * expr54.x;
    // mov r3.xy, c74
    temp3.xy = Physics.VelocityDampingRange.xy;
    // mova a0.w, r0.y
    addr0.w = temp0.y;
    // mad r0.y, c11[a0.w].x, r3.y, r3.x
    temp0.y = float1(0.957897) * temp3.y + temp3.x;
    // add r1.y, r0.y, c28.w
    temp1.y = temp0.y + float1(-1);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // sge r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y >= temp1.y) ? 1 : 0;
    // lrp r2.z, r1.y, c29.z, r0.y
    temp2.z = lerp(temp0.y, float1(1.0001), temp1.y);
    // log r0.y, r2.z
    temp0.y = log2(temp2.z);
    // mul r1.y, r0.y, c29.w
    temp1.y = temp0.y * float1(0.6931472);
    // mul r0.y, r1.w, r0.y
    temp0.y = temp1.w * temp0.y;
    // rcp r1.y, r1.y
    temp1.y = 1.0f / temp1.y;
    // exp r0.y, r0.y
    temp0.y = exp2(temp0.y);
    // add r0.y, r0.y, c28.w
    temp0.y = temp0.y + float1(-1);
    // mul r0.y, r1.y, r0.y
    temp0.y = temp1.y * temp0.y;
    // mov r3.xyz, v0
    temp3.xyz = i.position.xyz;
    // mad r3.xyz, v1, r0.y, r3
    temp3.xyz = i.texcoord.xyz * temp0.yyy + temp3.xyz;
    // mul r0.y, r1.w, -c27.x
    temp0.y = temp1.w * float1(0.5);
    // mov r4.xyz, c72
    temp4.xyz = Physics.Gravity.xyz;
    // mad r4.xyz, r0.y, r4, c73
    temp4.xyz = temp0.yyy * temp4.xyz + Physics.DriftVelocity.xyz;
    // mad r3.xyz, r4, r1.w, r3
    temp3.xyz = temp4.xyz * temp1.www + temp3.xyz;
    // add r4.xyz, r3.xyyw, -v0.xyyw
    temp4.xyz = temp3.xyy + -i.position.xyy;
    // mova a0.w, r0.z
    addr0.w = temp0.z;
    // mov r5.xyz, c11[a0.w]
    temp5.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r6.xyz, c61
    temp6.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r5.xyz, r5, r6, c60
    temp5.xyz = temp5.xyz * temp6.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // mova a0.w, r0.x
    addr0.w = temp0.x;
    // mov r0.xyz, c11[a0.w]
    temp0.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r6.xyz, c59
    temp6.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r0.xyz, r0, r6, c58
    temp0.xyz = temp0.xyz * temp6.xyz + Update.Size_Rate_Damping__Min.xyz;
    // add r1.y, r5.z, c28.w
    temp1.y = temp5.z + float1(-1);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // sge r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y >= temp1.y) ? 1 : 0;
    // lrp r2.z, r1.y, c29.z, r5.z
    temp2.z = lerp(temp5.z, float1(1.0001), temp1.y);
    // log r1.y, r2.z
    temp1.y = log2(temp2.z);
    // mul r1.z, r1.y, c29.w
    temp1.z = temp1.y * float1(0.6931472);
    // mul r1.y, r1.w, r1.y
    temp1.y = temp1.w * temp1.y;
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // exp r1.y, r1.y
    temp1.y = exp2(temp1.y);
    // add r1.y, r1.y, c28.w
    temp1.y = temp1.y + float1(-1);
    // mul r1.y, r1.z, r1.y
    temp1.y = temp1.z * temp1.y;
    // mad r1.y, r5.y, r1.y, r5.x
    temp1.y = temp5.y * temp1.y + temp5.x;
    // mad r1.y, r1.y, c30.z, c30.y
    temp1.y = temp1.y * float1(0.15915494) + float1(0.5);
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // mad r1.y, r1.y, c31.z, c31.w
    temp1.y = temp1.y * float1(6.2831855) + float1(-3.1415927);
    // sincos r5.xy, r1.y, c0, c1
    temp5.xy = float2(cos(temp1.y), sin(temp1.y));
    // mul r4.yzw, r4.xxyz, r5.xxyx
    temp4.yzw = temp4.xyz * temp5.xyx;
    // mad r1.z, r4.x, -r5.y, r4.w
    temp1.z = temp4.x * -temp5.y + temp4.w;
    // add r1.y, r4.z, r4.y
    temp1.y = temp4.z + temp4.y;
    // add r3.xy, r1.yzzw, v0
    temp3.xy = temp1.yz + i.position.xy;
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mul r2.xzw, r2.xyyx, c27[a0.w].xyyy
    temp2.xzw = temp2.xyx * float3(-0.5, -0.5, -0.5);
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mad r0.w, c27[a0.w].x, -r2.y, r2.w
    temp0.w = float1(-0.5) * -temp2.y + temp2.w;
    // add r1.y, r2.z, r2.x
    temp1.y = temp2.z + temp2.x;
    // mul r2.xyz, r0.w, c76
    temp2.xyz = temp0.www * (View._m01_m11_m21_m31).xyz;
    // mad r2.xyz, r1.y, c75, r2
    temp2.xyz = temp1.yyy * (View._m00_m10_m20_m30).xyz + temp2.xyz;
    // add r0.w, r0.z, c28.w
    temp0.w = temp0.z + float1(-1);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // sge r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w >= temp0.w) ? 1 : 0;
    // lrp r1.y, r0.w, c29.z, r0.z
    temp1.y = lerp(temp0.z, float1(1.0001), temp0.w);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // mul r0.w, r1.w, r0.z
    temp0.w = temp1.w * temp0.z;
    // mul r0.z, r0.z, c29.w
    temp0.z = temp0.z * float1(0.6931472);
    // exp r0.w, r0.w
    temp0.w = exp2(temp0.w);
    // add r0.w, r0.w, c28.w
    temp0.w = temp0.w + float1(-1);
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // mul r0.z, r0.w, r0.z
    temp0.z = temp0.w * temp0.z;
    // mad r0.x, r0.y, r0.z, r0.x
    temp0.x = temp0.y * temp0.z + temp0.x;
    // mad r2.xyz, r0.x, r2, r3
    temp2.xyz = temp0.xxx * temp2.xyz + temp3.xyz;
    // mul r0.x, r0.x, c30.w
    temp0.x = temp0.x * float1(0.2);
    // mov r2.w, -c28.w
    temp2.w = float1(1);
    // dp4 r3.z, r2, c66
    temp3.z = dot(temp2, (WorldView._m02_m12_m22_m32));
    // rcp r0.x, r0.x
    temp0.x = 1.0f / temp0.x;
    // mul oT6.x, r3.z, r0.x
    o.texcoord6.x = temp3.z * temp0.x;
    // mov oT6.y, r0.x
    o.texcoord6.y = temp0.x;
    // dp4 r3.x, r2, c64
    temp3.x = dot(temp2, (WorldView._m00_m10_m20_m30));
    // dp4 r3.y, r2, c65
    temp3.y = dot(temp2, (WorldView._m01_m11_m21_m31));
    // dp4 r3.w, r2, c67
    temp3.w = dot(temp2, (WorldView._m03_m13_m23_m33));
    // dp4 r0.x, r3, c68
    temp0.x = dot(temp3, (Projection._m00_m10_m20_m30));
    // dp4 r0.y, r3, c69
    temp0.y = dot(temp3, (Projection._m01_m11_m21_m31));
    // dp4 r0.z, r3, c70
    temp0.z = dot(temp3, (Projection._m02_m12_m22_m32));
    // dp4 r0.w, r3, c71
    temp0.w = dot(temp3, (Projection._m03_m13_m23_m33));
    // mov oPos, r0
    o.position = temp0;
    // mov oT5, r0
    o.texcoord5 = temp0;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r1.w, r0.x
    temp0.x = temp1.w * temp0.x;
    // mov r2, c43
    temp2 = Draw.ColorAnimationFunctions[2];
    // mad r2, r2, r0.x, c44
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r3, c45
    temp3 = Draw.ColorAnimationFunctions[4];
    // mad r3, r3, r0.x, c46
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c47
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r4, c41
    temp4 = Draw.ColorAnimationFunctions[0];
    // mad r4, r4, r0.x, c42
    temp4 = temp4 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r5, r0.z, r2, r3
    temp5 = lerp(temp3, temp2, temp0.z);
    // lrp r2, r0.y, r4, r5
    temp2 = lerp(temp5, temp4, temp0.y);
    // mul r0, r1.x, r2
    temp0 = temp1.x * temp2;
    // mad oT1, r0, c39.xxxy, c39.zzzw
    o.texcoord1 = temp0 * float4(2, 2, 2, 1) + float4(-1, -1, -1, 0);
    // mov oT2.z, c55.x
    o.texcoord2.z = expr55.x;
    // mov oT3.z, c56.x
    o.texcoord3.z = expr56.x;
    // mov oT4.z, c57.x
    o.texcoord4.z = expr57.x;
    // 

    return o;
}

// Default_Expression5 Expression_2_0 Has PRES False
float Default_Expression5()
{
    float1 expr0;
    // mov c0.x, c0.x
    expr0.x = ShouldDrawParticleSoft.x;
    return expr0;
}

// Default_VertexShader6 Vertex_2_0 Has PRES True
struct Default_VertexShader6_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_VertexShader6_Output
{
    float3 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float3 texcoord4 : TEXCOORD4;
    float2 texcoord : TEXCOORD;
    float2 texcoord6 : TEXCOORD6;
    float4 position : POSITION;
    float4 texcoord5 : TEXCOORD5;
    float4 texcoord1 : TEXCOORD1;
};

Default_VertexShader6_Output Default_VertexShader6(Default_VertexShader6_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 51
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 7
      Unknown3: 0
      Unknown4: 0
      Unknown5: 51
      Unknown6: 1
      Mappings: 2
        0 - ConstOutput: 53 ConstInput 5
        1 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    float4 expr57;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c51.x, c7.x, (30)
        expr51.x = Time.x * (30);
        // mul r0.x, c0.z, c1.y
        temp0.x = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).y;
        // mul r0.y, c0.x, c1.z
        temp0.y = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).z;
        // mul r0.z, c0.y, c1.x
        temp0.z = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).x;
        // neg r1.xyz, r0.xyz
        temp1.xyz = -temp0.xyz;
        // mul r0.x, c0.y, c1.z
        temp0.x = (View._m00_m10_m20_m30).y * (View._m01_m11_m21_m31).z;
        // mul r0.y, c0.z, c1.x
        temp0.y = (View._m00_m10_m20_m30).z * (View._m01_m11_m21_m31).x;
        // mul r0.z, c0.x, c1.y
        temp0.z = (View._m00_m10_m20_m30).x * (View._m01_m11_m21_m31).y;
        // add r2.xyz, r1.xyz, r0.xyz
        temp2.xyz = temp1.xyz + temp0.xyz;
        // dot r0.xyz, r2.xyz, c3.xyz
        temp0.xyz = dot(temp2.xyz, (World._m00_m10_m20_m30).xyz);
        // dot r0.yzw, r2.xyz, c4.xyz
        temp0.yzw = dot(temp2.xyz, (World._m01_m11_m21_m31).xyz);
        // dot r0.zwx, r2.xyz, c5.xyz
        temp0.zwx = dot(temp2.xyz, (World._m02_m12_m22_m32).xyz);
        // dot r1.xyz, r0.xyz, r0.xyz
        temp1.xyz = dot(temp0.xyz, temp0.xyz);
        // rsq r0.w, r1.x
        temp0.w = 1.0f / sqrt(temp1.x);
        // mul r1.xyz, r0.w, r0.xyz
        temp1.xyz = temp0.w * temp0.xyz;
        // dot c55.xyz, r1.xyz, c0.xyz
        expr55.xyz = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
        // dot c56.xyz, r1.xyz, c1.xyz
        expr56.xyz = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
        // dot c57.xyz, r1.xyz, c2.xyz
        expr57.xyz = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
        // rcp c53.x, c6.y
        expr53.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // rcp c54.x, c6.x
        expr54.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
    }

    Default_VertexShader6_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float4 addr0;
    float3 temp6;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c38, 1, -1, 0.5, 0
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0.2
    // def c31, 0, 0, 6.283185, -3.141593
    // def c37, 0.1875, 4.8125, 2.75, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c39, 2, 1, -1, 0
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c63
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.xyz, r1, r2, c62
    temp1.xyz = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // add r0.w, r1.z, c28.w
    temp0.w = temp1.z + float1(-1);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // sge r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w >= temp0.w) ? 1 : 0;
    // lrp r2.x, r0.w, c29.z, r1.z
    temp2.x = lerp(temp1.z, float1(1.0001), temp0.w);
    // log r0.w, r2.x
    temp0.w = log2(temp2.x);
    // mul r1.z, r0.w, c29.w
    temp1.z = temp0.w * float1(0.6931472);
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // add r1.w, -v1.w, c51.x
    temp1.w = -i.texcoord.w + expr51.x;
    // mul r0.w, r0.w, r1.w
    temp0.w = temp0.w * temp1.w;
    // exp r0.w, r0.w
    temp0.w = exp2(temp0.w);
    // add r0.w, r0.w, c28.w
    temp0.w = temp0.w + float1(-1);
    // mul r0.w, r1.z, r0.w
    temp0.w = temp1.z * temp0.w;
    // mad r0.w, r1.y, r0.w, r1.x
    temp0.w = temp1.y * temp0.w + temp1.x;
    // mad r0.w, r0.w, c30.z, c30.y
    temp0.w = temp0.w * float1(0.15915494) + float1(0.5);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mad r0.w, r0.w, c31.z, c31.w
    temp0.w = temp0.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r0.w, c0, c1
    temp2.xy = float2(cos(temp0.w), sin(temp0.w));
    // mul r1.xyz, r2.y, c76
    temp1.xyz = temp2.yyy * (View._m01_m11_m21_m31).xyz;
    // mad r1.xyz, r2.x, c75, r1
    temp1.xyz = temp2.xxx * (View._m00_m10_m20_m30).xyz + temp1.xyz;
    // dp3 oT2.x, r1, c75
    o.texcoord2.x = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.x, r1, c76
    o.texcoord3.x = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.x, r1, c77
    o.texcoord4.x = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // mul r1.xyz, r2.x, c76
    temp1.xyz = temp2.xxx * (View._m01_m11_m21_m31).xyz;
    // mad r1.xyz, -r2.y, c75, r1
    temp1.xyz = -temp2.yyy * (View._m00_m10_m20_m30).xyz + temp1.xyz;
    // dp3 oT2.y, r1, c75
    o.texcoord2.y = dot(temp1.xyz, (View._m00_m10_m20_m30).xyz);
    // dp3 oT3.y, r1, c76
    o.texcoord3.y = dot(temp1.xyz, (View._m01_m11_m21_m31).xyz);
    // dp3 oT4.y, r1, c77
    o.texcoord4.y = dot(temp1.xyz, (View._m02_m12_m22_m32).xyz);
    // mad r1.xy, v2.x, c37.x, c37.yzzw
    temp1.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r1.xy, r1
    temp1.xy = frac(temp1.xy);
    // mul r1.xy, r1, c28.z
    temp1.xy = temp1.xy * float2(16, 16);
    // frc r2.zw, r1.xyxy
    temp2.zw = frac(temp1.xy);
    // add r1.xy, r1, -r2.zwzw
    temp1.xy = temp1.xy + -temp2.zw;
    // mov r3.y, c40.y
    temp3.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mova a0.w, r1.x
    addr0.w = temp1.x;
    // mul r0.w, r3.y, c11[a0.w].x
    temp0.w = temp3.y * float1(0.957897);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // mova a0.w, r1.x
    addr0.w = temp1.x;
    // mad r0.w, c11[a0.w].x, r3.y, -r0.w
    temp0.w = float1(0.957897) * temp3.y + -temp0.w;
    // mov r3.xy, c50
    temp3.xy = Draw.ColorScaleRange.xy;
    // mova a0.w, r1.y
    addr0.w = temp1.y;
    // mad r1.x, c11[a0.w].x, r3.y, r3.x
    temp1.x = float1(0.957897) * temp3.y + temp3.x;
    // mad r0.w, r1.w, c49.x, r0.w
    temp0.w = temp1.w * Draw.SpeedMultiplier.x + temp0.w;
    // mul r0.w, r0.w, c53.x
    temp0.w = temp0.w * expr53.x;
    // abs r1.y, r0.w
    temp1.y = abs(temp0.w);
    // sge r0.w, r0.w, -r0.w
    temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // lrp r2.z, r0.w, r1.y, -r1.y
    temp2.z = lerp(-temp1.y, temp1.y, temp0.w);
    // mul r0.w, r2.z, c40.y
    temp0.w = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.z, r0.w, c54.x
    temp1.z = temp0.w * expr54.x;
    // abs r0.w, r1.z
    temp0.w = abs(temp1.z);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r2.z, r1.z, -r1.z
    temp2.z = (temp1.z >= -temp1.z) ? 1 : 0;
    // lrp r3.x, r2.z, r0.w, -r0.w
    temp3.x = lerp(-temp0.w, temp0.w, temp2.z);
    // mul r1.y, r3.x, c40.x
    temp1.y = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r1.xyyz
    temp2.zw = frac(temp1.yz);
    // add r1.yz, r1, -r2.xzww
    temp1.yz = temp1.yz + -temp2.zw;
    // slt r0.w, v0.w, r1.w
    temp0.w = (i.position.w < temp1.w) ? 1 : 0;
    // mad r0.w, r0.w, -v2.y, v2.y
    temp0.w = temp0.w * -i.texcoord1.y + i.texcoord1.y;
    // frc r2.z, r0.w
    temp2.z = frac(temp0.w);
    // add r0.w, r0.w, -r2.z
    temp0.w = temp0.w + -temp2.z;
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mov r3.xy, c27[a0.w]
    temp3.xy = float2(-0.5, -0.5);
    // mad r2.zw, r3.xyxy, c38.xyxy, c38.z
    temp2.zw = temp3.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r1.yz, r1, r2.xzww
    temp1.yz = temp1.yz + temp2.zw;
    // mul oT0.xy, r1.yzzw, c54.x
    o.texcoord = temp1.yzzw * expr54.x;
    // mov r3.xy, c74
    temp3.xy = Physics.VelocityDampingRange.xy;
    // mova a0.w, r0.y
    addr0.w = temp0.y;
    // mad r0.y, c11[a0.w].x, r3.y, r3.x
    temp0.y = float1(0.957897) * temp3.y + temp3.x;
    // add r1.y, r0.y, c28.w
    temp1.y = temp0.y + float1(-1);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // sge r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y >= temp1.y) ? 1 : 0;
    // lrp r2.z, r1.y, c29.z, r0.y
    temp2.z = lerp(temp0.y, float1(1.0001), temp1.y);
    // log r0.y, r2.z
    temp0.y = log2(temp2.z);
    // mul r1.y, r0.y, c29.w
    temp1.y = temp0.y * float1(0.6931472);
    // mul r0.y, r1.w, r0.y
    temp0.y = temp1.w * temp0.y;
    // rcp r1.y, r1.y
    temp1.y = 1.0f / temp1.y;
    // exp r0.y, r0.y
    temp0.y = exp2(temp0.y);
    // add r0.y, r0.y, c28.w
    temp0.y = temp0.y + float1(-1);
    // mul r0.y, r1.y, r0.y
    temp0.y = temp1.y * temp0.y;
    // mov r3.xyz, v0
    temp3.xyz = i.position.xyz;
    // mad r3.xyz, v1, r0.y, r3
    temp3.xyz = i.texcoord.xyz * temp0.yyy + temp3.xyz;
    // mul r0.y, r1.w, -c27.x
    temp0.y = temp1.w * float1(0.5);
    // mov r4.xyz, c72
    temp4.xyz = Physics.Gravity.xyz;
    // mad r4.xyz, r0.y, r4, c73
    temp4.xyz = temp0.yyy * temp4.xyz + Physics.DriftVelocity.xyz;
    // mad r3.xyz, r4, r1.w, r3
    temp3.xyz = temp4.xyz * temp1.www + temp3.xyz;
    // add r4.xyz, r3.xyyw, -v0.xyyw
    temp4.xyz = temp3.xyy + -i.position.xyy;
    // mova a0.w, r0.z
    addr0.w = temp0.z;
    // mov r5.xyz, c11[a0.w]
    temp5.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r6.xyz, c61
    temp6.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r5.xyz, r5, r6, c60
    temp5.xyz = temp5.xyz * temp6.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // mova a0.w, r0.x
    addr0.w = temp0.x;
    // mov r0.xyz, c11[a0.w]
    temp0.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r6.xyz, c59
    temp6.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r0.xyz, r0, r6, c58
    temp0.xyz = temp0.xyz * temp6.xyz + Update.Size_Rate_Damping__Min.xyz;
    // add r1.y, r5.z, c28.w
    temp1.y = temp5.z + float1(-1);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // sge r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y >= temp1.y) ? 1 : 0;
    // lrp r2.z, r1.y, c29.z, r5.z
    temp2.z = lerp(temp5.z, float1(1.0001), temp1.y);
    // log r1.y, r2.z
    temp1.y = log2(temp2.z);
    // mul r1.z, r1.y, c29.w
    temp1.z = temp1.y * float1(0.6931472);
    // mul r1.y, r1.w, r1.y
    temp1.y = temp1.w * temp1.y;
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // exp r1.y, r1.y
    temp1.y = exp2(temp1.y);
    // add r1.y, r1.y, c28.w
    temp1.y = temp1.y + float1(-1);
    // mul r1.y, r1.z, r1.y
    temp1.y = temp1.z * temp1.y;
    // mad r1.y, r5.y, r1.y, r5.x
    temp1.y = temp5.y * temp1.y + temp5.x;
    // mad r1.y, r1.y, c30.z, c30.y
    temp1.y = temp1.y * float1(0.15915494) + float1(0.5);
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // mad r1.y, r1.y, c31.z, c31.w
    temp1.y = temp1.y * float1(6.2831855) + float1(-3.1415927);
    // sincos r5.xy, r1.y, c0, c1
    temp5.xy = float2(cos(temp1.y), sin(temp1.y));
    // mul r4.yzw, r4.xxyz, r5.xxyx
    temp4.yzw = temp4.xyz * temp5.xyx;
    // mad r1.z, r4.x, -r5.y, r4.w
    temp1.z = temp4.x * -temp5.y + temp4.w;
    // add r1.y, r4.z, r4.y
    temp1.y = temp4.z + temp4.y;
    // add r3.xy, r1.yzzw, v0
    temp3.xy = temp1.yz + i.position.xy;
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mul r2.xzw, r2.xyyx, c27[a0.w].xyyy
    temp2.xzw = temp2.xyx * float3(-0.5, -0.5, -0.5);
    // mova a0.w, r0.w
    addr0.w = temp0.w;
    // mad r0.w, c27[a0.w].x, -r2.y, r2.w
    temp0.w = float1(-0.5) * -temp2.y + temp2.w;
    // add r1.y, r2.z, r2.x
    temp1.y = temp2.z + temp2.x;
    // mul r2.xyz, r0.w, c76
    temp2.xyz = temp0.www * (View._m01_m11_m21_m31).xyz;
    // mad r2.xyz, r1.y, c75, r2
    temp2.xyz = temp1.yyy * (View._m00_m10_m20_m30).xyz + temp2.xyz;
    // add r0.w, r0.z, c28.w
    temp0.w = temp0.z + float1(-1);
    // mul r0.w, r0.w, r0.w
    temp0.w = temp0.w * temp0.w;
    // sge r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w >= temp0.w) ? 1 : 0;
    // lrp r1.y, r0.w, c29.z, r0.z
    temp1.y = lerp(temp0.z, float1(1.0001), temp0.w);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // mul r0.w, r1.w, r0.z
    temp0.w = temp1.w * temp0.z;
    // mul r0.z, r0.z, c29.w
    temp0.z = temp0.z * float1(0.6931472);
    // exp r0.w, r0.w
    temp0.w = exp2(temp0.w);
    // add r0.w, r0.w, c28.w
    temp0.w = temp0.w + float1(-1);
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // mul r0.z, r0.w, r0.z
    temp0.z = temp0.w * temp0.z;
    // mad r0.x, r0.y, r0.z, r0.x
    temp0.x = temp0.y * temp0.z + temp0.x;
    // mad r2.xyz, r0.x, r2, r3
    temp2.xyz = temp0.xxx * temp2.xyz + temp3.xyz;
    // mul r0.x, r0.x, c30.w
    temp0.x = temp0.x * float1(0.2);
    // mov r2.w, -c28.w
    temp2.w = float1(1);
    // dp4 r3.z, r2, c66
    temp3.z = dot(temp2, (WorldView._m02_m12_m22_m32));
    // rcp r0.x, r0.x
    temp0.x = 1.0f / temp0.x;
    // mul oT6.x, r3.z, r0.x
    o.texcoord6.x = temp3.z * temp0.x;
    // mov oT6.y, r0.x
    o.texcoord6.y = temp0.x;
    // dp4 r3.x, r2, c64
    temp3.x = dot(temp2, (WorldView._m00_m10_m20_m30));
    // dp4 r3.y, r2, c65
    temp3.y = dot(temp2, (WorldView._m01_m11_m21_m31));
    // dp4 r3.w, r2, c67
    temp3.w = dot(temp2, (WorldView._m03_m13_m23_m33));
    // dp4 r0.x, r3, c68
    temp0.x = dot(temp3, (Projection._m00_m10_m20_m30));
    // dp4 r0.y, r3, c69
    temp0.y = dot(temp3, (Projection._m01_m11_m21_m31));
    // dp4 r0.z, r3, c70
    temp0.z = dot(temp3, (Projection._m02_m12_m22_m32));
    // dp4 r0.w, r3, c71
    temp0.w = dot(temp3, (Projection._m03_m13_m23_m33));
    // mov oPos, r0
    o.position = temp0;
    // mov oT5, r0
    o.texcoord5 = temp0;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r1.w, r0.x
    temp0.x = temp1.w * temp0.x;
    // mov r2, c43
    temp2 = Draw.ColorAnimationFunctions[2];
    // mad r2, r2, r0.x, c44
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r3, c45
    temp3 = Draw.ColorAnimationFunctions[4];
    // mad r3, r3, r0.x, c46
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c47
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r4, c41
    temp4 = Draw.ColorAnimationFunctions[0];
    // mad r4, r4, r0.x, c42
    temp4 = temp4 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r5, r0.z, r2, r3
    temp5 = lerp(temp3, temp2, temp0.z);
    // lrp r2, r0.y, r4, r5
    temp2 = lerp(temp5, temp4, temp0.y);
    // mul r0, r1.x, r2
    temp0 = temp1.x * temp2;
    // mad oT1, r0, c39.xxxy, c39.zzzw
    o.texcoord1 = temp0 * float4(2, 2, 2, 1) + float4(-1, -1, -1, 0);
    // mov oT2.z, c55.x
    o.texcoord2.z = expr55.x;
    // mov oT3.z, c56.x
    o.texcoord3.z = expr56.x;
    // mov oT4.z, c57.x
    o.texcoord4.z = expr57.x;
    // 

    return o;
}

technique Default
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_2_0 Default_VertexShader6(); // 27
        PixelShader = PS_Array_H[Default_Expression5()]; // 28
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_M
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = compile vs_2_0 Default_M_VertexShader4(); // 30
        PixelShader = compile ps_2_0 Default_M_PixelShader3(); // 31
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_L
{
}

