string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
bool IsHdrEnabled <string SasBindAddress = "WW3D.IsHdrEnabled";>;
texture FrameBufferSampler <string SasBindAddress = "PostEffect.FrameBufferTexture"; int WW3DDynamicSet = 2;>; // 3
sampler2D FrameBufferSamplerSampler <string Texture = "FrameBufferSampler"; string SasBindAddress = "PostEffect.FrameBufferTexture"; int WW3DDynamicSet = 2;> =
sampler_state
{
    Texture = <FrameBufferSampler>; // 5
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
texture SourceTexture <string SasBindAddress = "PostEffect.Bloom.SourceTexture"; int WW3DDynamicSet = 2;>; // 8
sampler2D SourceTextureSampler : register(ps_3_0, s0) <string Texture = "SourceTexture"; string SasBindAddress = "PostEffect.Bloom.SourceTexture"; int WW3DDynamicSet = 2;> =
sampler_state
{
    Texture = <SourceTexture>; // 10
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
float2 SourceTextureSize <string SasBindAddress = "PostEffect.Bloom.SourceTextureSize";> = { 1024, 768 };
float2 TargetTextureSize <string SasBindAddress = "PostEffect.Bloom.TargetTextureSize";> = { 1024, 768 };
float BloomIntensity : register(ps_2_0, c11) <string SasBindAddress = "PostEffect.Bloom.Intensity";> = { 0.5 };
float3 ExposureLevel : register(ps_3_0, c11) <string SasBindAddress = "PostEffect.LookupTable.ExposureLevel";> = { 1, 1, 1 };
float2 TextureSizeHigh <string SasBindAddress = "PostEffect.Bloom.TextureSizeHigh";>;
float2 TextureSizeMedium <string SasBindAddress = "PostEffect.Bloom.TextureSizeMedium";>;
float2 TextureSizeLow <string SasBindAddress = "PostEffect.Bloom.TextureSizeLow";>;
int SurfaceFormat <string SasBindAddress = "PostEffect.Bloom.SurfaceFormat";> = { 1 };
int TextureFormat <string SasBindAddress = "PostEffect.Bloom.TextureFormat";> = { 1 };
// DownsampleInitialPS_Array_Shader_0 Pixel_3_0 Has PRES False
float4 DownsampleInitialPS_Array_Shader_0(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0;
    float3 temp1;
    // def c0, 0.3, 0.11, -0.11, 0.0001
    // def c1, 0, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_2d s0
    // texld r0, v0, s0
    temp0 = tex2D(SourceTextureSampler, texcoord.xy);
    // dp3 r1.x, r0, c0.x
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, -r1.x, c0.y
    temp1.y = -temp1.x + float1(0.11);
    // add r1.xz, r1.x, c0.zyww
    temp1.xz = temp1.xx + float2(-0.11, 0.0001);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // rcp r1.z, r1.z
    temp1.z = 1.0f / temp1.z;
    // cmp r1.x, r1.y, c1.x, r1.x
    temp1.x = (temp1.y >= 0) ? float1(0) : temp1.x;
    // mul r1.x, r1.z, r1.x
    temp1.x = temp1.z * temp1.x;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // mul oC0.xyz, r0, c11
    out_color.xyz = temp0.xyz * ExposureLevel.xyz;
    // 

    return out_color;
}

// DownsampleInitialPS_Array_Shader_1 Pixel_3_0 Has PRES True
float4 DownsampleInitialPS_Array_Shader_1(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // rcp c12.x, c0.x
        expr12.x = 1.0f / (SourceTextureSize.x);
        // rcp c12.y, c0.y
        expr12.y = 1.0f / (SourceTextureSize.y);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 2, 0, -1, 0.25
    // def c1, 0.3, 0.11, -0.11, 0.0001
    // defi i0, 2, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_2d s0
    // mov r0, c0.y
    temp0 = float4(0, 0, 0, 0);
    // mov r1.x, c0.z
    temp1.x = float1(-1);
    // rep i0
    for (int it0 = 0; it0 < int1(2); ++it0) {
        // mov r1.z, r1.x
        temp1.z = temp1.x;
        // mov r1.w, c0.z
        temp1.w = float1(-1);
        // rep i0
        for (int it1 = 0; it1 < int1(2); ++it1) {
            // mov r1.y, r1.w
            temp1.y = temp1.w;
            // mad r2.xy, r1.yzzw, c12, v0
            temp2.xy = temp1.yz * expr12.xy + texcoord.xy;
            // texld r2, r2, s0
            temp2 = tex2D(SourceTextureSampler, temp2.xy);
            // add r0, r0, r2
            temp0 = temp0 + temp2;
            // add r1.w, r1.w, c0.x
            temp1.w = temp1.w + float1(2);
            // endrep
        }
        // add r1.x, r1.x, c0.x
        temp1.x = temp1.x + float1(2);
        // endrep
    }
    // mul r0, r0, c0.w
    temp0 = temp0 * float4(0.25, 0.25, 0.25, 0.25);
    // dp3 r1.x, r0, c1.x
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, -r1.x, c1.y
    temp1.y = -temp1.x + float1(0.11);
    // add r1.xz, r1.x, c1.zyww
    temp1.xz = temp1.xx + float2(-0.11, 0.0001);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // cmp r1.x, r1.y, c0.y, r1.x
    temp1.x = (temp1.y >= 0) ? float1(0) : temp1.x;
    // rcp r1.y, r1.z
    temp1.y = 1.0f / temp1.z;
    // mul r1.x, r1.x, r1.y
    temp1.x = temp1.x * temp1.y;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mul oC0.xyz, r0, c11
    out_color.xyz = temp0.xyz * ExposureLevel.xyz;
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // 

    return out_color;
}

// DownsampleInitialPS_Array_Shader_2 Pixel_3_0 Has PRES True
float4 DownsampleInitialPS_Array_Shader_2(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // rcp c12.x, c0.x
        expr12.x = 1.0f / (SourceTextureSize.x);
        // rcp c12.y, c0.y
        expr12.y = 1.0f / (SourceTextureSize.y);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0, 0, -2, 2
    // def c1, 0.1111111, 0.3, 0.11, -0.0001
    // defi i0, 3, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_2d s0
    // mov r0, c0.y
    temp0 = float4(0, 0, 0, 0);
    // mov r1.x, c0.z
    temp1.x = float1(-2);
    // rep i0
    for (int it0 = 0; it0 < int1(3); ++it0) {
        // mov r1.z, r1.x
        temp1.z = temp1.x;
        // mov r1.w, c0.z
        temp1.w = float1(-2);
        // rep i0
        for (int it1 = 0; it1 < int1(3); ++it1) {
            // mov r1.y, r1.w
            temp1.y = temp1.w;
            // mad r2.xy, r1.yzzw, c12, v0
            temp2.xy = temp1.yz * expr12.xy + texcoord.xy;
            // texld r2, r2, s0
            temp2 = tex2D(SourceTextureSampler, temp2.xy);
            // add r0, r0, r2
            temp0 = temp0 + temp2;
            // add r1.w, r1.w, c0.w
            temp1.w = temp1.w + float1(2);
            // endrep
        }
        // add r1.x, r1.x, c0.w
        temp1.x = temp1.x + float1(2);
        // endrep
    }
    // mul r0, r0, c1.x
    temp0 = temp0 * float4(0.11111111, 0.11111111, 0.11111111, 0.11111111);
    // dp3 r1.x, r0, c1.y
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, -r1.x, c1.z
    temp1.y = -temp1.x + float1(0.11);
    // add r1.xz, r1.x, -c1.zyww
    temp1.xz = temp1.xx + float2(-0.11, 0.0001);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // cmp r1.x, r1.y, c0.y, r1.x
    temp1.x = (temp1.y >= 0) ? float1(0) : temp1.x;
    // rcp r1.y, r1.z
    temp1.y = 1.0f / temp1.z;
    // mul r1.x, r1.x, r1.y
    temp1.x = temp1.x * temp1.y;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mul oC0.xyz, r0, c11
    out_color.xyz = temp0.xyz * ExposureLevel.xyz;
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // 

    return out_color;
}

// DownsampleInitialPS_Array_Shader_3 Pixel_3_0 Has PRES True
float4 DownsampleInitialPS_Array_Shader_3(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // rcp c12.x, c0.x
        expr12.x = 1.0f / (SourceTextureSize.x);
        // rcp c12.y, c0.y
        expr12.y = 1.0f / (SourceTextureSize.y);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0, 0, -3, 2
    // def c1, 0.0625, 0.3, 0.11, -0.0001
    // defi i0, 4, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_2d s0
    // mov r0, c0.y
    temp0 = float4(0, 0, 0, 0);
    // mov r1.x, c0.z
    temp1.x = float1(-3);
    // rep i0
    for (int it0 = 0; it0 < int1(4); ++it0) {
        // mov r1.z, r1.x
        temp1.z = temp1.x;
        // mov r1.w, c0.z
        temp1.w = float1(-3);
        // rep i0
        for (int it1 = 0; it1 < int1(4); ++it1) {
            // mov r1.y, r1.w
            temp1.y = temp1.w;
            // mad r2.xy, r1.yzzw, c12, v0
            temp2.xy = temp1.yz * expr12.xy + texcoord.xy;
            // texld r2, r2, s0
            temp2 = tex2D(SourceTextureSampler, temp2.xy);
            // add r0, r0, r2
            temp0 = temp0 + temp2;
            // add r1.w, r1.w, c0.w
            temp1.w = temp1.w + float1(2);
            // endrep
        }
        // add r1.x, r1.x, c0.w
        temp1.x = temp1.x + float1(2);
        // endrep
    }
    // mul r0, r0, c1.x
    temp0 = temp0 * float4(0.0625, 0.0625, 0.0625, 0.0625);
    // dp3 r1.x, r0, c1.y
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, -r1.x, c1.z
    temp1.y = -temp1.x + float1(0.11);
    // add r1.xz, r1.x, -c1.zyww
    temp1.xz = temp1.xx + float2(-0.11, 0.0001);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // cmp r1.x, r1.y, c0.y, r1.x
    temp1.x = (temp1.y >= 0) ? float1(0) : temp1.x;
    // rcp r1.y, r1.z
    temp1.y = 1.0f / temp1.z;
    // mul r1.x, r1.x, r1.y
    temp1.x = temp1.x * temp1.y;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mul oC0.xyz, r0, c11
    out_color.xyz = temp0.xyz * ExposureLevel.xyz;
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // 

    return out_color;
}

// DownsampleInitialPS_Array_Shader_4 Pixel_3_0 Has PRES True
float4 DownsampleInitialPS_Array_Shader_4(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 12
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 12
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr12;
    {
        // Expression_2_1
        // rcp c12.x, c0.x
        expr12.x = 1.0f / (SourceTextureSize.x);
        // rcp c12.y, c0.y
        expr12.y = 1.0f / (SourceTextureSize.y);
    }

    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, 0, 0, -4, 2
    // def c1, 0.04, 0.3, 0.11, -0.0001
    // defi i0, 5, 0, 0, 0
    // dcl_texcoord v0.xy
    // dcl_2d s0
    // mov r0, c0.y
    temp0 = float4(0, 0, 0, 0);
    // mov r1.x, c0.z
    temp1.x = float1(-4);
    // rep i0
    for (int it0 = 0; it0 < int1(5); ++it0) {
        // mov r1.z, r1.x
        temp1.z = temp1.x;
        // mov r1.w, c0.z
        temp1.w = float1(-4);
        // rep i0
        for (int it1 = 0; it1 < int1(5); ++it1) {
            // mov r1.y, r1.w
            temp1.y = temp1.w;
            // mad r2.xy, r1.yzzw, c12, v0
            temp2.xy = temp1.yz * expr12.xy + texcoord.xy;
            // texld r2, r2, s0
            temp2 = tex2D(SourceTextureSampler, temp2.xy);
            // add r0, r0, r2
            temp0 = temp0 + temp2;
            // add r1.w, r1.w, c0.w
            temp1.w = temp1.w + float1(2);
            // endrep
        }
        // add r1.x, r1.x, c0.w
        temp1.x = temp1.x + float1(2);
        // endrep
    }
    // mul r0, r0, c1.x
    temp0 = temp0 * float4(0.04, 0.04, 0.04, 0.04);
    // dp3 r1.x, r0, c1.y
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, -r1.x, c1.z
    temp1.y = -temp1.x + float1(0.11);
    // add r1.xz, r1.x, -c1.zyww
    temp1.xz = temp1.xx + float2(-0.11, 0.0001);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // cmp r1.x, r1.y, c0.y, r1.x
    temp1.x = (temp1.y >= 0) ? float1(0) : temp1.x;
    // rcp r1.y, r1.z
    temp1.y = 1.0f / temp1.z;
    // mul r1.x, r1.x, r1.y
    temp1.x = temp1.x * temp1.y;
    // mul r0.xyz, r0, r1.x
    temp0.xyz = temp0.xyz * temp1.xxx;
    // mul oC0.xyz, r0, c11
    out_color.xyz = temp0.xyz * ExposureLevel.xyz;
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // 

    return out_color;
}

PixelShader DownsampleInitialPS_Array[5] = {
    compile ps_3_0 DownsampleInitialPS_Array_Shader_0(), // 22
    compile ps_3_0 DownsampleInitialPS_Array_Shader_1(), // 23
    compile ps_3_0 DownsampleInitialPS_Array_Shader_2(), // 24
    compile ps_3_0 DownsampleInitialPS_Array_Shader_3(), // 25
    compile ps_3_0 DownsampleInitialPS_Array_Shader_4(), // 26
};
// DownsampleInitialPS_L_Array_Shader_0 Pixel_2_0 Has PRES False
float4 DownsampleInitialPS_L_Array_Shader_0(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 0.3, 0.11, -0.11, 0
    // def c1, 0.0001, 0, 0, 0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(SourceTextureSampler, texcoord.xy);
    // dp3 r1.w, r0, c0.x
    temp1.w = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.x, r1.w, c0.z
    temp1.x = temp1.w + float1(-0.11);
    // mul r1.x, r1.x, r1.x
    temp1.x = temp1.x * temp1.x;
    // add r1.y, -r1.w, c0.y
    temp1.y = -temp1.w + float1(0.11);
    // add r1.z, r1.w, c1.x
    temp1.z = temp1.w + float1(0.0001);
    // cmp r1.x, r1.y, c0.w, r1.x
    temp1.x = (temp1.y >= 0) ? float1(0) : temp1.x;
    // rcp r1.y, r1.z
    temp1.y = 1.0f / temp1.z;
    // mul r1.x, r1.x, r1.y
    temp1.x = temp1.x * temp1.y;
    // mul r1.xyz, r0, r1.x
    temp1.xyz = temp0.xyz * temp1.xxx;
    // mul r0.xyz, r1, c11
    temp0.xyz = temp1.xyz * ExposureLevel.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// DownsampleInitialPS_L_Array_Shader_1 Pixel_2_0 Has PRES True
float4 DownsampleInitialPS_L_Array_Shader_1(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 3
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 3
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    {
        float4 temp0;
        // Expression_2_1
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (SourceTextureSize.x);
        // rcp r0.y, c0.y
        temp0.y = 1.0f / (SourceTextureSize.y);
        // mul c12.xy, r0.xy, (1, -1)
        expr12.xy = temp0.xy * float2(1, -1);
        // mul c13.x, r0.x, (-1)
        expr13.x = temp0.x * (-1);
        // mul c13.y, r0.y, (1)
        expr13.y = temp0.y * (1);
        // mov c11.xy, r0.xy
        expr11.xy = temp0.xy;
    }

    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0, 0.0001, 0, 0
    // def c1, 0.25, 0.3, 0.11, -0.11
    // dcl t0.xy
    // dcl_2d s0
    // add r0.xy, t0, -c11
    temp0.xy = texcoord.xy + -expr11.xy;
    // add r1.xy, t0, c12
    temp1.xy = texcoord.xy + expr12.xy;
    // add r2.xy, t0, c13
    temp2.xy = texcoord.xy + expr13.xy;
    // add r3.xy, t0, c11
    temp3.xy = texcoord.xy + expr11.xy;
    // texld r0, r0, s0
    temp0 = tex2D(SourceTextureSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // add r0, r2, r0
    temp0 = temp2 + temp0;
    // add r0, r3, r0
    temp0 = temp3 + temp0;
    // mul r0, r0, c1.x
    temp0 = temp0 * float4(0.25, 0.25, 0.25, 0.25);
    // dp3 r1.x, r0, c1.y
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, r1.x, c1.w
    temp1.y = temp1.x + float1(-0.11);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // add r1.z, -r1.x, c1.z
    temp1.z = -temp1.x + float1(0.11);
    // add r1.x, r1.x, c0.y
    temp1.x = temp1.x + float1(0.0001);
    // cmp r1.y, r1.z, c0.x, r1.y
    temp1.y = (temp1.z >= 0) ? float1(0) : temp1.y;
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // mul r1.x, r1.y, r1.x
    temp1.x = temp1.y * temp1.x;
    // mul r1.xyz, r0, r1.x
    temp1.xyz = temp0.xyz * temp1.xxx;
    // mul r0.xyz, r1, c14
    temp0.xyz = temp1.xyz * ExposureLevel.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// DownsampleInitialPS_L_Array_Shader_2 Pixel_2_0 Has PRES True
float4 DownsampleInitialPS_L_Array_Shader_2(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 8
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 8
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    float4 expr14;
    float4 expr15;
    float4 expr16;
    float4 expr17;
    float4 expr18;
    {
        float4 temp0;
        // Expression_2_1
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (SourceTextureSize.x);
        // rcp r0.y, c0.y
        temp0.y = 1.0f / (SourceTextureSize.y);
        // mul c11.xy, (-2, -2), r0.xy
        expr11.xy = float2(-2, -2) * temp0.xy;
        // mul c12.x, r0.x, (0)
        expr12.x = temp0.x * (0);
        // mul c12.y, r0.y, (-2)
        expr12.y = temp0.y * (-2);
        // mul c13.x, r0.x, (2)
        expr13.x = temp0.x * (2);
        // mul c13.y, r0.y, (-2)
        expr13.y = temp0.y * (-2);
        // mul c14.xy, r0.xy, (-2, 0)
        expr14.xy = temp0.xy * float2(-2, 0);
        // mul c15.x, r0.x, (2)
        expr15.x = temp0.x * (2);
        // mul c15.y, r0.y, (0)
        expr15.y = temp0.y * (0);
        // mul c16.x, r0.x, (-2)
        expr16.x = temp0.x * (-2);
        // mul c16.y, r0.y, (2)
        expr16.y = temp0.y * (2);
        // mul c17.xy, r0.xy, (0, 2)
        expr17.xy = temp0.xy * float2(0, 2);
        // add c18.xy, r0.xy, r0.xy
        expr18.xy = temp0.xy + temp0.xy;
    }

    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8;
    // def c0, 0, 0.0001, 0, 0
    // def c1, 0.1111111, 0.3, 0.11, -0.11
    // dcl t0.xy
    // dcl_2d s0
    // add r0.xy, t0, c11
    temp0.xy = texcoord.xy + expr11.xy;
    // add r1.xy, t0, c12
    temp1.xy = texcoord.xy + expr12.xy;
    // add r2.xy, t0, c13
    temp2.xy = texcoord.xy + expr13.xy;
    // add r3.xy, t0, c14
    temp3.xy = texcoord.xy + expr14.xy;
    // add r4.xy, t0, c15
    temp4.xy = texcoord.xy + expr15.xy;
    // add r5.xy, t0, c16
    temp5.xy = texcoord.xy + expr16.xy;
    // add r6.xy, t0, c17
    temp6.xy = texcoord.xy + expr17.xy;
    // add r7.xy, t0, c18
    temp7.xy = texcoord.xy + expr18.xy;
    // texld r0, r0, s0
    temp0 = tex2D(SourceTextureSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // texld r8, t0, s0
    temp8 = tex2D(SourceTextureSampler, texcoord.xy);
    // texld r4, r4, s0
    temp4 = tex2D(SourceTextureSampler, temp4.xy);
    // texld r5, r5, s0
    temp5 = tex2D(SourceTextureSampler, temp5.xy);
    // texld r6, r6, s0
    temp6 = tex2D(SourceTextureSampler, temp6.xy);
    // texld r7, r7, s0
    temp7 = tex2D(SourceTextureSampler, temp7.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // add r0, r2, r0
    temp0 = temp2 + temp0;
    // add r0, r3, r0
    temp0 = temp3 + temp0;
    // add r0, r8, r0
    temp0 = temp8 + temp0;
    // add r0, r4, r0
    temp0 = temp4 + temp0;
    // add r0, r5, r0
    temp0 = temp5 + temp0;
    // add r0, r6, r0
    temp0 = temp6 + temp0;
    // add r0, r7, r0
    temp0 = temp7 + temp0;
    // mul r0, r0, c1.x
    temp0 = temp0 * float4(0.11111111, 0.11111111, 0.11111111, 0.11111111);
    // dp3 r1.x, r0, c1.y
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, r1.x, c1.w
    temp1.y = temp1.x + float1(-0.11);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // add r1.z, -r1.x, c1.z
    temp1.z = -temp1.x + float1(0.11);
    // add r1.x, r1.x, c0.y
    temp1.x = temp1.x + float1(0.0001);
    // cmp r1.y, r1.z, c0.x, r1.y
    temp1.y = (temp1.z >= 0) ? float1(0) : temp1.y;
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // mul r1.x, r1.y, r1.x
    temp1.x = temp1.y * temp1.x;
    // mul r1.xyz, r0, r1.x
    temp1.xyz = temp0.xyz * temp1.xxx;
    // mul r0.xyz, r1, c19
    temp0.xyz = temp1.xyz * ExposureLevel.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// DownsampleInitialPS_L_Array_Shader_3 Pixel_2_0 Has PRES True
float4 DownsampleInitialPS_L_Array_Shader_3(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 15
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 15
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    float4 expr14;
    float4 expr15;
    float4 expr16;
    float4 expr17;
    float4 expr18;
    float4 expr19;
    float4 expr20;
    float4 expr21;
    float4 expr22;
    float4 expr23;
    float4 expr24;
    float4 expr25;
    {
        float4 temp0;
        // Expression_2_1
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (SourceTextureSize.x);
        // rcp r0.y, c0.y
        temp0.y = 1.0f / (SourceTextureSize.y);
        // mul c11.xy, (-3, -3), r0.xy
        expr11.xy = float2(-3, -3) * temp0.xy;
        // mul c12.x, r0.x, (-1)
        expr12.x = temp0.x * (-1);
        // mul c12.y, r0.y, (-3)
        expr12.y = temp0.y * (-3);
        // mul c13.x, r0.x, (1)
        expr13.x = temp0.x * (1);
        // mul c13.y, r0.y, (-3)
        expr13.y = temp0.y * (-3);
        // mul c14.x, r0.x, (3)
        expr14.x = temp0.x * (3);
        // mul c14.y, r0.y, (-3)
        expr14.y = temp0.y * (-3);
        // mul c15.xy, r0.xy, (-3, -1)
        expr15.xy = temp0.xy * float2(-3, -1);
        // mul c17.x, r0.x, (1)
        expr17.x = temp0.x * (1);
        // mul c17.y, r0.y, (-1)
        expr17.y = temp0.y * (-1);
        // mul c18.x, r0.x, (3)
        expr18.x = temp0.x * (3);
        // mul c18.y, r0.y, (-1)
        expr18.y = temp0.y * (-1);
        // mul c19.x, r0.x, (-3)
        expr19.x = temp0.x * (-3);
        // mul c19.y, r0.y, (1)
        expr19.y = temp0.y * (1);
        // mul c20.xy, r0.xy, (-1, 1)
        expr20.xy = temp0.xy * float2(-1, 1);
        // mul c21.x, r0.x, (3)
        expr21.x = temp0.x * (3);
        // mul c21.y, r0.y, (1)
        expr21.y = temp0.y * (1);
        // mul c22.x, r0.x, (-3)
        expr22.x = temp0.x * (-3);
        // mul c22.y, r0.y, (3)
        expr22.y = temp0.y * (3);
        // mul c23.x, r0.x, (-1)
        expr23.x = temp0.x * (-1);
        // mul c23.y, r0.y, (3)
        expr23.y = temp0.y * (3);
        // mul c24.xy, r0.xy, (1, 3)
        expr24.xy = temp0.xy * float2(1, 3);
        // mul c25.xy, (3, 3), r0.xy
        expr25.xy = float2(3, 3) * temp0.xy;
        // mov c16.xy, r0.xy
        expr16.xy = temp0.xy;
    }

    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4, temp5, temp6, temp7, temp8, temp9;
    // def c0, 0.0625, 0.3, 0.11, -0.11
    // def c1, 0, 0.0001, 0, 0
    // dcl t0.xy
    // dcl_2d s0
    // add r0.xy, t0, c11
    temp0.xy = texcoord.xy + expr11.xy;
    // add r1.xy, t0, c12
    temp1.xy = texcoord.xy + expr12.xy;
    // add r2.xy, t0, c13
    temp2.xy = texcoord.xy + expr13.xy;
    // add r3.xy, t0, c14
    temp3.xy = texcoord.xy + expr14.xy;
    // add r4.xy, t0, c15
    temp4.xy = texcoord.xy + expr15.xy;
    // add r5.xy, t0, -c16
    temp5.xy = texcoord.xy + -expr16.xy;
    // add r6.xy, t0, c17
    temp6.xy = texcoord.xy + expr17.xy;
    // add r7.xy, t0, c18
    temp7.xy = texcoord.xy + expr18.xy;
    // add r8.xy, t0, c19
    temp8.xy = texcoord.xy + expr19.xy;
    // add r9.xy, t0, c20
    temp9.xy = texcoord.xy + expr20.xy;
    // texld r0, r0, s0
    temp0 = tex2D(SourceTextureSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // texld r4, r4, s0
    temp4 = tex2D(SourceTextureSampler, temp4.xy);
    // texld r5, r5, s0
    temp5 = tex2D(SourceTextureSampler, temp5.xy);
    // texld r6, r6, s0
    temp6 = tex2D(SourceTextureSampler, temp6.xy);
    // texld r7, r7, s0
    temp7 = tex2D(SourceTextureSampler, temp7.xy);
    // texld r8, r8, s0
    temp8 = tex2D(SourceTextureSampler, temp8.xy);
    // texld r9, r9, s0
    temp9 = tex2D(SourceTextureSampler, temp9.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // add r0, r2, r0
    temp0 = temp2 + temp0;
    // add r0, r3, r0
    temp0 = temp3 + temp0;
    // add r0, r4, r0
    temp0 = temp4 + temp0;
    // add r0, r5, r0
    temp0 = temp5 + temp0;
    // add r0, r6, r0
    temp0 = temp6 + temp0;
    // add r0, r7, r0
    temp0 = temp7 + temp0;
    // add r0, r8, r0
    temp0 = temp8 + temp0;
    // add r0, r9, r0
    temp0 = temp9 + temp0;
    // add r1.xy, t0, c16
    temp1.xy = texcoord.xy + expr16.xy;
    // add r2.xy, t0, c21
    temp2.xy = texcoord.xy + expr21.xy;
    // add r3.xy, t0, c22
    temp3.xy = texcoord.xy + expr22.xy;
    // add r4.xy, t0, c23
    temp4.xy = texcoord.xy + expr23.xy;
    // add r5.xy, t0, c24
    temp5.xy = texcoord.xy + expr24.xy;
    // add r6.xy, t0, c25
    temp6.xy = texcoord.xy + expr25.xy;
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // texld r4, r4, s0
    temp4 = tex2D(SourceTextureSampler, temp4.xy);
    // texld r5, r5, s0
    temp5 = tex2D(SourceTextureSampler, temp5.xy);
    // texld r6, r6, s0
    temp6 = tex2D(SourceTextureSampler, temp6.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // add r0, r2, r0
    temp0 = temp2 + temp0;
    // add r0, r3, r0
    temp0 = temp3 + temp0;
    // add r0, r4, r0
    temp0 = temp4 + temp0;
    // add r0, r5, r0
    temp0 = temp5 + temp0;
    // add r0, r6, r0
    temp0 = temp6 + temp0;
    // mul r0, r0, c0.x
    temp0 = temp0 * float4(0.0625, 0.0625, 0.0625, 0.0625);
    // dp3 r1.x, r0, c0.y
    temp1.x = dot(temp0.xyz, float3(0.3, 0.3, 0.3));
    // add r1.y, r1.x, c0.w
    temp1.y = temp1.x + float1(-0.11);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // add r1.z, -r1.x, c0.z
    temp1.z = -temp1.x + float1(0.11);
    // add r1.x, r1.x, c1.y
    temp1.x = temp1.x + float1(0.0001);
    // cmp r1.y, r1.z, c1.x, r1.y
    temp1.y = (temp1.z >= 0) ? float1(0) : temp1.y;
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // mul r1.x, r1.y, r1.x
    temp1.x = temp1.y * temp1.x;
    // mul r1.xyz, r0, r1.x
    temp1.xyz = temp0.xyz * temp1.xxx;
    // mul r0.xyz, r1, c26
    temp0.xyz = temp1.xyz * ExposureLevel.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader DownsampleInitialPS_L_Array[4] = {
    compile ps_2_0 DownsampleInitialPS_L_Array_Shader_0(), // 29
    compile ps_2_0 DownsampleInitialPS_L_Array_Shader_1(), // 30
    compile ps_2_0 DownsampleInitialPS_L_Array_Shader_2(), // 31
    compile ps_2_0 DownsampleInitialPS_L_Array_Shader_3(), // 32
};
texture DebugTextureSampler <string SasBindAddress = "PostEffect.FrameBufferTexture"; int WW3DDynamicSet = 2;>; // 51
sampler2D DebugTextureSamplerSampler <string Texture = "DebugTextureSampler"; string SasBindAddress = "PostEffect.FrameBufferTexture"; int WW3DDynamicSet = 2;> =
sampler_state
{
    Texture = <DebugTextureSampler>; // 53
    MinFilter = 1;
    MagFilter = 1;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
// DebugPattern_PixelShader10 Pixel_2_0 Has PRES False
float4 DebugPattern_PixelShader10(float texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 2.2, 0, 0, 0
    // dcl t0.x
    // log r0.w, t0.x
    temp0.w = log2(texcoord.x);
    // mul r0.x, r0.w, c0.x
    temp0.x = temp0.w * float1(2.2);
    // exp r0, r0.x
    temp0 = exp2(temp0.x);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// DebugPattern_VertexShader11 Vertex_2_0 Has PRES False
struct DebugPattern_VertexShader11_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct DebugPattern_VertexShader11_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
};

DebugPattern_VertexShader11_Output DebugPattern_VertexShader11(DebugPattern_VertexShader11_Input i)
{
    DebugPattern_VertexShader11_Output o;
    // def c0, 1, 0.25, 0, 0.75
    // dcl_position v0
    // dcl_texcoord v1
    // mul oT0.xy, v1, c0
    o.texcoord = i.texcoord * float4(1, 0.25, 0, 0.75);
    // mad oPos.xy, v0, c0, c0.zwzw
    o.position.xy = i.position.xy * float2(1, 0.25) + float2(0, 0.75);
    // mov oPos.zw, c0.xyzx
    o.position.zw = float2(0, 1);
    // 

    return o;
}

// DebugDisplay_PixelShader12 Pixel_2_0 Has PRES False
float4 DebugDisplay_PixelShader12(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(DebugTextureSamplerSampler, texcoord.xy);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// DebugDisplay_VertexShader13 Vertex_2_0 Has PRES False
struct DebugDisplay_VertexShader13_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct DebugDisplay_VertexShader13_Output
{
    float2 texcoord : TEXCOORD;
    float4 position : POSITION;
};

DebugDisplay_VertexShader13_Output DebugDisplay_VertexShader13(DebugDisplay_VertexShader13_Input i)
{
    DebugDisplay_VertexShader13_Output o;
    // def c0, 0.5, 1, -0.5, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mul oT0.xy, v1, c0
    o.texcoord = i.texcoord * float4(0.5, 1, -0.5, 0);
    // mad oPos.xy, v0, c0, c0.zwzw
    o.position.xy = i.position.xy * float2(0.5, 1) + float2(-0.5, 0);
    // mov oPos.zw, c0.xywy
    o.position.zw = float2(0, 1);
    // 

    return o;
}

// Copy_PixelShader14 Pixel_2_0 Has PRES False
float4 Copy_PixelShader14(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(FrameBufferSamplerSampler, texcoord.xy);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Copy_VertexShader15 Vertex_2_0 Has PRES False
struct Copy_VertexShader15_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct Copy_VertexShader15_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

Copy_VertexShader15_Output Copy_VertexShader15(Copy_VertexShader15_Input i)
{
    Copy_VertexShader15_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// AccumulateFinal_M_PixelShader16 Pixel_2_0 Has PRES False
float4 AccumulateFinal_M_PixelShader16(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2.2, 0.4545455, 0, 0
    // dcl t0.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(FrameBufferSamplerSampler, texcoord.xy);
    // texld r1, t0, s1
    temp1 = tex2D(SourceTextureSampler, texcoord.xy);
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mul r2.xyz, r2, c0.x
    temp2.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r2.x
    temp0.x = exp2(temp2.x);
    // exp r0.y, r2.y
    temp0.y = exp2(temp2.y);
    // exp r0.z, r2.z
    temp0.z = exp2(temp2.z);
    // log r2.x, r1.x
    temp2.x = log2(temp1.x);
    // log r2.y, r1.y
    temp2.y = log2(temp1.y);
    // log r2.z, r1.z
    temp2.z = log2(temp1.z);
    // mul r2.xyz, r2, c0.x
    temp2.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r2.x
    temp1.x = exp2(temp2.x);
    // exp r1.y, r2.y
    temp1.y = exp2(temp2.y);
    // exp r1.z, r2.z
    temp1.z = exp2(temp2.z);
    // mad r0, r1, c11.x, r0
    temp0 = temp1 * BloomIntensity.x + temp0;
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.y
    temp1.xyz = temp1.xyz * float3(0.45454547, 0.45454547, 0.45454547);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AccumulateFinal_M_VertexShader17 Vertex_2_0 Has PRES False
struct AccumulateFinal_M_VertexShader17_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct AccumulateFinal_M_VertexShader17_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

AccumulateFinal_M_VertexShader17_Output AccumulateFinal_M_VertexShader17(AccumulateFinal_M_VertexShader17_Input i)
{
    AccumulateFinal_M_VertexShader17_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// AccumulateFinal_PixelShader18 Pixel_2_0 Has PRES False
float4 AccumulateFinal_PixelShader18(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // dcl t0.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(FrameBufferSamplerSampler, texcoord.xy);
    // texld r1, t0, s1
    temp1 = tex2D(SourceTextureSampler, texcoord.xy);
    // mad r0, r1, c11.x, r0
    temp0 = temp1 * BloomIntensity.x + temp0;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AccumulateFinal_VertexShader19 Vertex_2_0 Has PRES False
struct AccumulateFinal_VertexShader19_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct AccumulateFinal_VertexShader19_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

AccumulateFinal_VertexShader19_Output AccumulateFinal_VertexShader19(AccumulateFinal_VertexShader19_Input i)
{
    AccumulateFinal_VertexShader19_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Accumulate_M_PixelShader20 Pixel_2_0 Has PRES False
float4 Accumulate_M_PixelShader20(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float3 temp2;
    // def c0, 2.2, 0.4545455, 0, 0
    // dcl t0.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(FrameBufferSamplerSampler, texcoord.xy);
    // texld r1, t0, s1
    temp1 = tex2D(SourceTextureSampler, texcoord.xy);
    // log r2.x, r0.x
    temp2.x = log2(temp0.x);
    // log r2.y, r0.y
    temp2.y = log2(temp0.y);
    // log r2.z, r0.z
    temp2.z = log2(temp0.z);
    // mul r2.xyz, r2, c0.x
    temp2.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r0.x, r2.x
    temp0.x = exp2(temp2.x);
    // exp r0.y, r2.y
    temp0.y = exp2(temp2.y);
    // exp r0.z, r2.z
    temp0.z = exp2(temp2.z);
    // log r2.x, r1.x
    temp2.x = log2(temp1.x);
    // log r2.y, r1.y
    temp2.y = log2(temp1.y);
    // log r2.z, r1.z
    temp2.z = log2(temp1.z);
    // mul r2.xyz, r2, c0.x
    temp2.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r2.x
    temp1.x = exp2(temp2.x);
    // exp r1.y, r2.y
    temp1.y = exp2(temp2.y);
    // exp r1.z, r2.z
    temp1.z = exp2(temp2.z);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // log r1.x, r0.x
    temp1.x = log2(temp0.x);
    // log r1.y, r0.y
    temp1.y = log2(temp0.y);
    // log r1.z, r0.z
    temp1.z = log2(temp0.z);
    // mul r1.xyz, r1, c0.y
    temp1.xyz = temp1.xyz * float3(0.45454547, 0.45454547, 0.45454547);
    // exp r0.x, r1.x
    temp0.x = exp2(temp1.x);
    // exp r0.y, r1.y
    temp0.y = exp2(temp1.y);
    // exp r0.z, r1.z
    temp0.z = exp2(temp1.z);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Accumulate_M_VertexShader21 Vertex_2_0 Has PRES False
struct Accumulate_M_VertexShader21_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct Accumulate_M_VertexShader21_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

Accumulate_M_VertexShader21_Output Accumulate_M_VertexShader21(Accumulate_M_VertexShader21_Input i)
{
    Accumulate_M_VertexShader21_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Accumulate_PixelShader22 Pixel_2_0 Has PRES False
float4 Accumulate_PixelShader22(float2 texcoord : TEXCOORD) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // dcl t0.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(FrameBufferSamplerSampler, texcoord.xy);
    // texld r1, t0, s1
    temp1 = tex2D(SourceTextureSampler, texcoord.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Accumulate_VertexShader23 Vertex_2_0 Has PRES False
struct Accumulate_VertexShader23_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct Accumulate_VertexShader23_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

Accumulate_VertexShader23_Output Accumulate_VertexShader23(Accumulate_VertexShader23_Input i)
{
    Accumulate_VertexShader23_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// BlurGaussian11x11V_PixelShader24 Pixel_2_0 Has PRES True
float4 BlurGaussian11x11V_PixelShader24(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 3
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 3
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    {
        float4 temp0;
        // Expression_2_1
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (SourceTextureSize.x);
        // rcp r0.y, c0.y
        temp0.y = 1.0f / (SourceTextureSize.y);
        // mul c11.xy, r0.xy, (0.5, -0.5)
        expr11.xy = temp0.xy * float2(0.5, -0.5);
        // mul c12.xy, r0.xy, (0, 3.55)
        expr12.xy = temp0.xy * float2(0, 3.55);
        // mul c13.xy, r0.xy, (0, 1.65)
        expr13.xy = temp0.xy * float2(0, 1.65);
    }

    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4;
    // def c0, 120, 10, 252, 0.001953125
    // dcl t0.xy
    // dcl_2d s0
    // add r0.xy, t0, c11
    temp0.xy = texcoord.xy + expr11.xy;
    // add r1.xy, r0, -c13
    temp1.xy = temp0.xy + -expr13.xy;
    // add r2.xy, r0, -c12
    temp2.xy = temp0.xy + -expr12.xy;
    // add r3.xy, r0, c13
    temp3.xy = temp0.xy + expr13.xy;
    // add r4.xy, r0, c12
    temp4.xy = temp0.xy + expr12.xy;
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r0, r0, s0
    temp0 = tex2D(SourceTextureSampler, temp0.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // texld r4, r4, s0
    temp4 = tex2D(SourceTextureSampler, temp4.xy);
    // mul r1, r1, c0.x
    temp1 = temp1 * float4(120, 120, 120, 120);
    // mad r1, r2, c0.y, r1
    temp1 = temp2 * float4(10, 10, 10, 10) + temp1;
    // mad r0, r0, c0.z, r1
    temp0 = temp0 * float4(252, 252, 252, 252) + temp1;
    // mad r0, r3, c0.x, r0
    temp0 = temp3 * float4(120, 120, 120, 120) + temp0;
    // mad r0, r4, c0.y, r0
    temp0 = temp4 * float4(10, 10, 10, 10) + temp0;
    // mul r0, r0, c0.w
    temp0 = temp0 * float4(0.001953125, 0.001953125, 0.001953125, 0.001953125);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// BlurGaussian11x11V_VertexShader25 Vertex_2_0 Has PRES False
struct BlurGaussian11x11V_VertexShader25_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct BlurGaussian11x11V_VertexShader25_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

BlurGaussian11x11V_VertexShader25_Output BlurGaussian11x11V_VertexShader25(BlurGaussian11x11V_VertexShader25_Input i)
{
    BlurGaussian11x11V_VertexShader25_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// BlurGaussian11x11U_PixelShader26 Pixel_2_0 Has PRES True
float4 BlurGaussian11x11U_PixelShader26(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 3
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 3
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    {
        float4 temp0;
        // Expression_2_1
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (SourceTextureSize.x);
        // rcp r0.y, c0.y
        temp0.y = 1.0f / (SourceTextureSize.y);
        // mul c11.xy, r0.xy, (-0.5, 0.5)
        expr11.xy = temp0.xy * float2(-0.5, 0.5);
        // mul c12.xy, r0.xy, (3.55, 0)
        expr12.xy = temp0.xy * float2(3.55, 0);
        // mul c13.xy, r0.xy, (1.65, 0)
        expr13.xy = temp0.xy * float2(1.65, 0);
    }

    float4 out_color;
    float4 temp0, temp1, temp2, temp3, temp4;
    // def c0, 120, 10, 252, 0.001953125
    // dcl t0.xy
    // dcl_2d s0
    // add r0.xy, t0, c11
    temp0.xy = texcoord.xy + expr11.xy;
    // add r1.xy, r0, -c13
    temp1.xy = temp0.xy + -expr13.xy;
    // add r2.xy, r0, -c12
    temp2.xy = temp0.xy + -expr12.xy;
    // add r3.xy, r0, c13
    temp3.xy = temp0.xy + expr13.xy;
    // add r4.xy, r0, c12
    temp4.xy = temp0.xy + expr12.xy;
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r0, r0, s0
    temp0 = tex2D(SourceTextureSampler, temp0.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // texld r4, r4, s0
    temp4 = tex2D(SourceTextureSampler, temp4.xy);
    // mul r1, r1, c0.x
    temp1 = temp1 * float4(120, 120, 120, 120);
    // mad r1, r2, c0.y, r1
    temp1 = temp2 * float4(10, 10, 10, 10) + temp1;
    // mad r0, r0, c0.z, r1
    temp0 = temp0 * float4(252, 252, 252, 252) + temp1;
    // mad r0, r3, c0.x, r0
    temp0 = temp3 * float4(120, 120, 120, 120) + temp0;
    // mad r0, r4, c0.y, r0
    temp0 = temp4 * float4(10, 10, 10, 10) + temp0;
    // mul r0, r0, c0.w
    temp0 = temp0 * float4(0.001953125, 0.001953125, 0.001953125, 0.001953125);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// BlurGaussian11x11U_VertexShader27 Vertex_2_0 Has PRES False
struct BlurGaussian11x11U_VertexShader27_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct BlurGaussian11x11U_VertexShader27_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

BlurGaussian11x11U_VertexShader27_Output BlurGaussian11x11U_VertexShader27(BlurGaussian11x11U_VertexShader27_Input i)
{
    BlurGaussian11x11U_VertexShader27_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Downsample4x4_PixelShader28 Pixel_2_0 Has PRES True
float4 Downsample4x4_PixelShader28(float2 texcoord : TEXCOORD) : COLOR
{
    /*
    PRSI
      OutputRegisterOffset: 11
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 3
      Unknown3: 0
      Unknown4: 0
      Unknown5: 11
      Unknown6: 3
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr11;
    float4 expr12;
    float4 expr13;
    {
        float4 temp0;
        // Expression_2_1
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (SourceTextureSize.x);
        // rcp r0.y, c0.y
        temp0.y = 1.0f / (SourceTextureSize.y);
        // mul c12.xy, r0.xy, (1, -1)
        expr12.xy = temp0.xy * float2(1, -1);
        // mul c13.x, r0.x, (-1)
        expr13.x = temp0.x * (-1);
        // mul c13.y, r0.y, (1)
        expr13.y = temp0.y * (1);
        // mov c11.xy, r0.xy
        expr11.xy = temp0.xy;
    }

    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.25, 0, 0, 0
    // dcl t0.xy
    // dcl_2d s0
    // add r0.xy, t0, -c11
    temp0.xy = texcoord.xy + -expr11.xy;
    // add r1.xy, t0, c12
    temp1.xy = texcoord.xy + expr12.xy;
    // add r2.xy, t0, c13
    temp2.xy = texcoord.xy + expr13.xy;
    // add r3.xy, t0, c11
    temp3.xy = texcoord.xy + expr11.xy;
    // texld r0, r0, s0
    temp0 = tex2D(SourceTextureSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(SourceTextureSampler, temp1.xy);
    // texld r2, r2, s0
    temp2 = tex2D(SourceTextureSampler, temp2.xy);
    // texld r3, r3, s0
    temp3 = tex2D(SourceTextureSampler, temp3.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // add r0, r2, r0
    temp0 = temp2 + temp0;
    // add r0, r3, r0
    temp0 = temp3 + temp0;
    // mul r0, r0, c0.x
    temp0 = temp0 * float4(0.25, 0.25, 0.25, 0.25);
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Downsample4x4_VertexShader29 Vertex_2_0 Has PRES False
struct Downsample4x4_VertexShader29_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct Downsample4x4_VertexShader29_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

Downsample4x4_VertexShader29_Output Downsample4x4_VertexShader29(Downsample4x4_VertexShader29_Input i)
{
    Downsample4x4_VertexShader29_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// DownsampleInitial_L_Expression30 Expression_2_0 Has PRES False
float DownsampleInitial_L_Expression30()
{
    float4 temp0;
    float4 temp1;
    float4 temp2;
    float1 expr0;
    // rcp r0.x, c1.x
    temp0.x = 1.0f / (TargetTextureSize.x);
    // mul r1.x, r0.x, c0.x
    temp1.x = temp0.x * SourceTextureSize.x;
    // mul r0.x, r1.x, (0.5)
    temp0.x = temp1.x * (0.5);
    // add r1.x, r0.x, (-0.5)
    temp1.x = temp0.x + (-0.5);
    // neg r0.x, r1.x
    temp0.x = -temp1.x;
    // lt r2.x, r1.x, r0.x
    temp2.x = temp1.x < temp0.x;
    // frc r0.x, r1.x
    temp0.x = frac(temp1.x);
    // neg r1.y, r0.x
    temp1.y = -temp0.x;
    // lt r2.y, r1.y, r0.x
    temp2.y = temp1.y < temp0.x;
    // add r0.x, r1.x, r1.y
    temp0.x = temp1.x + temp1.y;
    // mul r0.y, r2.x, r2.y
    temp0.y = temp2.x * temp2.y;
    // add r1.x, r0.x, r0.y
    temp1.x = temp0.x + temp0.y;
    // max r0.x, r1.x, (0)
    temp0.x = max(temp1.x, (0));
    // min c0.x, r0.x, (3)
    expr0.x = min(temp0.x, (3));
    return expr0;
}

// DownsampleInitial_L_VertexShader31 Vertex_2_0 Has PRES False
struct DownsampleInitial_L_VertexShader31_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct DownsampleInitial_L_VertexShader31_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

DownsampleInitial_L_VertexShader31_Output DownsampleInitial_L_VertexShader31(DownsampleInitial_L_VertexShader31_Input i)
{
    DownsampleInitial_L_VertexShader31_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // mov oPos.xy, v0
    o.position.xy = i.position.xy;
    // mov oPos.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// DownsampleInitial_Expression32 Expression_2_0 Has PRES False
float DownsampleInitial_Expression32()
{
    float4 temp0;
    float4 temp1;
    float4 temp2;
    float1 expr0;
    // rcp r0.x, c1.x
    temp0.x = 1.0f / (TargetTextureSize.x);
    // mul r1.x, r0.x, c0.x
    temp1.x = temp0.x * SourceTextureSize.x;
    // mul r0.x, r1.x, (0.5)
    temp0.x = temp1.x * (0.5);
    // add r1.x, r0.x, (-0.5)
    temp1.x = temp0.x + (-0.5);
    // neg r0.x, r1.x
    temp0.x = -temp1.x;
    // lt r2.x, r1.x, r0.x
    temp2.x = temp1.x < temp0.x;
    // frc r0.x, r1.x
    temp0.x = frac(temp1.x);
    // neg r1.y, r0.x
    temp1.y = -temp0.x;
    // lt r2.y, r1.y, r0.x
    temp2.y = temp1.y < temp0.x;
    // add r0.x, r1.x, r1.y
    temp0.x = temp1.x + temp1.y;
    // mul r0.y, r2.x, r2.y
    temp0.y = temp2.x * temp2.y;
    // add r1.x, r0.x, r0.y
    temp1.x = temp0.x + temp0.y;
    // max r0.x, r1.x, (0)
    temp0.x = max(temp1.x, (0));
    // min c0.x, r0.x, (4)
    expr0.x = min(temp0.x, (4));
    return expr0;
}

// DownsampleInitial_VertexShader33 Vertex_3_0 Has PRES False
struct DownsampleInitial_VertexShader33_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
};

struct DownsampleInitial_VertexShader33_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
};

DownsampleInitial_VertexShader33_Output DownsampleInitial_VertexShader33(DownsampleInitial_VertexShader33_Input i)
{
    DownsampleInitial_VertexShader33_Output o;
    // def c0, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_position o0
    // dcl_texcoord o1.xy
    // mov o0.xy, v0
    o.position.xy = i.position.xy;
    // mov o0.zw, c0.xyxy
    o.position.zw = float2(0, 1);
    // mov o1.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

technique DownsampleInitial
{
    pass p0
    {
        VertexShader = compile vs_3_0 DownsampleInitial_VertexShader33(); // 27
        PixelShader = DownsampleInitialPS_Array[DownsampleInitial_Expression32()]; // 28
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique DownsampleInitial_L
{
    pass p0
    {
        VertexShader = compile vs_2_0 DownsampleInitial_L_VertexShader31(); // 33
        PixelShader = DownsampleInitialPS_L_Array[DownsampleInitial_L_Expression30()]; // 34
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique Downsample4x4
{
    pass p0
    {
        VertexShader = compile vs_2_0 Downsample4x4_VertexShader29(); // 35
        PixelShader = compile ps_2_0 Downsample4x4_PixelShader28(); // 36
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique BlurGaussian11x11U
{
    pass p0
    {
        VertexShader = compile vs_2_0 BlurGaussian11x11U_VertexShader27(); // 37
        PixelShader = compile ps_2_0 BlurGaussian11x11U_PixelShader26(); // 38
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique BlurGaussian11x11V
{
    pass p0
    {
        VertexShader = compile vs_2_0 BlurGaussian11x11V_VertexShader25(); // 39
        PixelShader = compile ps_2_0 BlurGaussian11x11V_PixelShader24(); // 40
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique Accumulate
{
    pass p0
    {
        VertexShader = compile vs_2_0 Accumulate_VertexShader23(); // 41
        PixelShader = compile ps_2_0 Accumulate_PixelShader22(); // 42
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique Accumulate_M
{
    pass p0
    {
        VertexShader = compile vs_2_0 Accumulate_M_VertexShader21(); // 43
        PixelShader = compile ps_2_0 Accumulate_M_PixelShader20(); // 44
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique AccumulateFinal
{
    pass p0
    {
        VertexShader = compile vs_2_0 AccumulateFinal_VertexShader19(); // 45
        PixelShader = compile ps_2_0 AccumulateFinal_PixelShader18(); // 46
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique AccumulateFinal_M
{
    pass p0
    {
        VertexShader = compile vs_2_0 AccumulateFinal_M_VertexShader17(); // 47
        PixelShader = compile ps_2_0 AccumulateFinal_M_PixelShader16(); // 48
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique Copy
{
    pass p0
    {
        VertexShader = compile vs_2_0 Copy_VertexShader15(); // 49
        PixelShader = compile ps_2_0 Copy_PixelShader14(); // 50
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique DebugDisplay
{
    pass p0
    {
        VertexShader = compile vs_2_0 DebugDisplay_VertexShader13(); // 56
        PixelShader = compile ps_2_0 DebugDisplay_PixelShader12(); // 57
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique DebugPattern
{
    pass p0
    {
        VertexShader = compile vs_2_0 DebugPattern_VertexShader11(); // 58
        PixelShader = compile ps_2_0 DebugPattern_PixelShader10(); // 59
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

