string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture BaseTexture <string SasBindAddress = "WW3D.MiscTexture"; int WW3DDynamicSet = 2;>; // 2
sampler2D BaseTextureSampler : register(ps_2_0, s0) <string Texture = "BaseTexture"; string SasBindAddress = "WW3D.MiscTexture"; int WW3DDynamicSet = 2;> =
sampler_state
{
    Texture = <BaseTexture>; // 4
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
column_major float4x4 World : World : register(vs_2_0, c11);
// AptRenderer_PixelShader1 Pixel_2_0 Has PRES False
struct AptRenderer_PixelShader1_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AptRenderer_PixelShader1(AptRenderer_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AptRenderer_VertexShader2 Vertex_2_0 Has PRES False
struct AptRenderer_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AptRenderer_VertexShader2_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

AptRenderer_VertexShader2_Output AptRenderer_VertexShader2(AptRenderer_VertexShader2_Input i)
{
    AptRenderer_VertexShader2_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// AlphaWithSolidTexture_PixelShader3 Pixel_2_0 Has PRES False
struct AlphaWithSolidTexture_PixelShader3_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaWithSolidTexture_PixelShader3(AlphaWithSolidTexture_PixelShader3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // mov r0.w, v0.w
    temp0.w = i.color.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaWithSolidTexture_VertexShader4 Vertex_2_0 Has PRES False
struct AlphaWithSolidTexture_VertexShader4_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaWithSolidTexture_VertexShader4_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

AlphaWithSolidTexture_VertexShader4_Output AlphaWithSolidTexture_VertexShader4(AlphaWithSolidTexture_VertexShader4_Input i)
{
    AlphaWithSolidTexture_VertexShader4_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// AlphaTestCopy_PixelShader5 Pixel_2_0 Has PRES False
struct AlphaTestCopy_PixelShader5_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaTestCopy_PixelShader5(AlphaTestCopy_PixelShader5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaTestCopy_VertexShader6 Vertex_2_0 Has PRES False
struct AlphaTestCopy_VertexShader6_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaTestCopy_VertexShader6_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

AlphaTestCopy_VertexShader6_Output AlphaTestCopy_VertexShader6(AlphaTestCopy_VertexShader6_Input i)
{
    AlphaTestCopy_VertexShader6_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// GrayCopy_PixelShader7 Pixel_2_0 Has PRES False
struct GrayCopy_PixelShader7_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 GrayCopy_PixelShader7(GrayCopy_PixelShader7_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 0.3, 0.59, 0.11, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // dp3 r0.x, r0, c0
    temp0.x = dot(temp0.xyz, float3(0.3, 0.59, 0.11));
    // mul r1.w, r0.w, v0.w
    temp1.w = temp0.w * i.color.w;
    // mul r1.xyz, r0.x, v0
    temp1.xyz = temp0.xxx * i.color.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// GrayCopy_VertexShader8 Vertex_2_0 Has PRES False
struct GrayCopy_VertexShader8_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct GrayCopy_VertexShader8_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

GrayCopy_VertexShader8_Output GrayCopy_VertexShader8(GrayCopy_VertexShader8_Input i)
{
    GrayCopy_VertexShader8_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Gray_PixelShader9 Pixel_2_0 Has PRES False
struct Gray_PixelShader9_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Gray_PixelShader9(Gray_PixelShader9_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    // def c0, 0.3, 0.59, 0.11, 0
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // dp3 r0.x, r0, c0
    temp0.x = dot(temp0.xyz, float3(0.3, 0.59, 0.11));
    // mul r1.w, r0.w, v0.w
    temp1.w = temp0.w * i.color.w;
    // mul r1.xyz, r0.x, v0
    temp1.xyz = temp0.xxx * i.color.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// Gray_VertexShader10 Vertex_2_0 Has PRES False
struct Gray_VertexShader10_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Gray_VertexShader10_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Gray_VertexShader10_Output Gray_VertexShader10(Gray_VertexShader10_Input i)
{
    Gray_VertexShader10_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// AlphaBlend_PixelShader11 Pixel_2_0 Has PRES False
struct AlphaBlend_PixelShader11_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 AlphaBlend_PixelShader11(AlphaBlend_PixelShader11_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// AlphaBlend_VertexShader12 Vertex_2_0 Has PRES False
struct AlphaBlend_VertexShader12_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct AlphaBlend_VertexShader12_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

AlphaBlend_VertexShader12_Output AlphaBlend_VertexShader12(AlphaBlend_VertexShader12_Input i)
{
    AlphaBlend_VertexShader12_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Additive_PixelShader13 Pixel_2_0 Has PRES False
struct Additive_PixelShader13_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Additive_PixelShader13(Additive_PixelShader13_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Additive_VertexShader14 Vertex_2_0 Has PRES False
struct Additive_VertexShader14_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive_VertexShader14_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Additive_VertexShader14_Output Additive_VertexShader14(Additive_VertexShader14_Input i)
{
    Additive_VertexShader14_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

// Copy_PixelShader15 Pixel_2_0 Has PRES False
struct Copy_PixelShader15_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

float4 Copy_PixelShader15(Copy_PixelShader15_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl v0
    // dcl t0.xy
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(BaseTextureSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Copy_VertexShader16 Vertex_2_0 Has PRES False
struct Copy_VertexShader16_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Copy_VertexShader16_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
};

Copy_VertexShader16_Output Copy_VertexShader16(Copy_VertexShader16_Input i)
{
    Copy_VertexShader16_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (World._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (World._m03_m13_m23_m33));
    // mov oD0, v2
    o.color = i.color;
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // 

    return o;
}

technique Copy
{
    pass P0
    {
        VertexShader = compile vs_2_0 Copy_VertexShader16(); // 7
        PixelShader = compile ps_2_0 Copy_PixelShader15(); // 8
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique Additive
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive_VertexShader14(); // 9
        PixelShader = compile ps_2_0 Additive_PixelShader13(); // 10
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 2;
        DestBlend = 2;
        AlphaTestEnable = 0;
    }
}

technique AlphaBlend
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaBlend_VertexShader12(); // 11
        PixelShader = compile ps_2_0 AlphaBlend_PixelShader11(); // 12
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique Gray
{
    pass P0
    {
        VertexShader = compile vs_2_0 Gray_VertexShader10(); // 13
        PixelShader = compile ps_2_0 Gray_PixelShader9(); // 14
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique GrayCopy
{
    pass P0
    {
        VertexShader = compile vs_2_0 GrayCopy_VertexShader8(); // 15
        PixelShader = compile ps_2_0 GrayCopy_PixelShader7(); // 16
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

technique AlphaTestCopy
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaTestCopy_VertexShader6(); // 17
        PixelShader = compile ps_2_0 AlphaTestCopy_PixelShader5(); // 18
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique AlphaWithSolidTexture
{
    pass P0
    {
        VertexShader = compile vs_2_0 AlphaWithSolidTexture_VertexShader4(); // 19
        PixelShader = compile ps_2_0 AlphaWithSolidTexture_PixelShader3(); // 20
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 0;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

technique AptRenderer
{
    pass P0
    {
        VertexShader = compile vs_2_0 AptRenderer_VertexShader2(); // 21
        PixelShader = compile ps_2_0 AptRenderer_PixelShader1(); // 22
        ZEnable = 0;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        AlphaTestEnable = 0;
    }
}

