string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition : register(vs_2_0, c123) <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture RiverTexture <string UIName = "River Texture";>; // 2
sampler2D RiverTextureSampler : register(ps_2_0, s0) <string Texture = "RiverTexture"; string UIName = "River Texture";> =
sampler_state
{
    Texture = <RiverTexture>; // 4
    MipFilter = 2;
    MinFilter = 2;
    MagFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture NormalTexture <string UIName = "Normal Texture";>; // 7
sampler2D NormalTextureSampler : register(ps_2_0, s1) <string Texture = "NormalTexture"; string UIName = "Normal Texture";> =
sampler_state
{
    Texture = <NormalTexture>; // 9
    MipFilter = 2;
    MinFilter = 2;
    MagFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
float4 Opacity : register(vs_2_0, c21) <string UIName = "Opacity";> = { 1, 1, 1, 1 };
texture WaterReflectionTexture <string UIWidget = "None"; string SasBindAddress = "Water.ReflectionTexture";>; // 13
sampler2D WaterReflectionTextureSampler <string Texture = "WaterReflectionTexture"; string UIWidget = "None"; string SasBindAddress = "Water.ReflectionTexture";> =
sampler_state
{
    Texture = <WaterReflectionTexture>; // 16
    MipFilter = 1;
    MinFilter = 2;
    MagFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture EnvironmentTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.EnvironmentTexture"; string ResourceType = "Cube";>; // 20
samplerCUBE EnvironmentTextureSampler <string Texture = "EnvironmentTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.EnvironmentTexture"; string ResourceType = "Cube";> =
sampler_state
{
    Texture = <EnvironmentTexture>; // 24
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
    AddressW = 3;
};
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c22) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";>; // 31
sampler2D ShroudTextureSampler : register(ps_2_0, s3) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";> =
sampler_state
{
    Texture = <ShroudTexture>; // 35
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
column_major float4x4 WorldViewProjection : WorldViewProjection : register(vs_2_0, c11);
column_major float4x4 World : World;
float Time : Time;
// _Default_L_PixelShader1 Pixel_2_0 Has PRES False
struct _Default_L_PixelShader1_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord2 : TEXCOORD2;
};

float4 _Default_L_PixelShader1(_Default_L_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl t2.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(RiverTextureSampler, i.texcoord.xy);
    // texld r1, t1, s0
    temp1 = tex2D(RiverTextureSampler, i.texcoord1.xy);
    // texld r2, t2, s1
    temp2 = tex2D(ShroudTextureSampler, i.texcoord2.xy);
    // add r0, r0, r1
    temp0 = temp0 + temp1;
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mul r0.xyz, r2, r0
    temp0.xyz = temp2.xyz * temp0.xyz;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// _Default_L_VertexShader2 Vertex_2_0 Has PRES True
struct _Default_L_VertexShader2_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
    float4 texcoord1 : TEXCOORD1;
};

struct _Default_L_VertexShader2_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord2 : TEXCOORD2;
};

_Default_L_VertexShader2_Output _Default_L_VertexShader2(_Default_L_VertexShader2_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 17
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 2
      Unknown3: 0
      Unknown4: 0
      Unknown5: 17
      Unknown6: 2
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr17;
    float4 expr18;
    {
        // Expression_2_1
        // mul c17.x, c0.x, (-0.004)
        expr17.x = Time.x * (-0.004);
        // mul c18.x, c0.x, (-0.016)
        expr18.x = Time.x * (-0.016);
    }

    _Default_L_VertexShader2_Output o;
    float4 temp0, temp1;
    // def c0, 1, 0, 0.75, 0.95
    // def c1, 1, 0.5, 0, 0
    // dcl_position v0
    // dcl_color v1
    // dcl_texcoord1 v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov r1.x, c19.w
    temp1.x = Opacity.w;
    // mul r1.x, r1.x, v1.w
    temp1.x = temp1.x * i.color.w;
    // mul r1.x, r1.x, c0.z
    temp1.x = temp1.x * float1(0.75);
    // max r1.x, r1.x, c0.y
    temp1.x = max(temp1.x, float1(0));
    // min oD0.w, r1.x, c0.w
    o.color.w = min(temp1.x, float1(0.95));
    // mov r1.xy, c0
    temp1.xy = float2(1, 0);
    // mul r1.zw, r1.xyyx, c17.x
    temp1.zw = temp1.yx * expr17.xx;
    // mad oT0.xy, v2, c1, r1.zwzw
    o.texcoord = i.texcoord1 * float4(1, 0.5, 0, 0) + temp1.zwzw;
    // mad oT1.xy, c18.x, r1.yxzw, v2
    o.texcoord1 = expr18.x * temp1.yxzw + i.texcoord1;
    // dp4 r1.x, r0, c15
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c16
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // add r0.xy, r1, c20.zwzw
    temp0.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT2.xy, r0, c20
    o.texcoord2 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mul oD0.xyz, v1, c0.z
    o.color.xyz = i.color.xyz * float3(0.75, 0.75, 0.75);
    // 

    return o;
}

// _Default_M_PixelShader3 Pixel_2_0 Has PRES False
struct _Default_M_PixelShader3_Input
{
    float4 color : COLOR;
    float color1 : COLOR1;
    float4 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
};

float4 _Default_M_PixelShader3(_Default_M_PixelShader3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 2, -1, 0.5, 0
    // def c1, 0.75, 0, 0, 0
    // dcl v0
    // dcl v1.x
    // dcl t0
    // dcl t1.xy
    // dcl t2.xy
    // dcl t3.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_cube s2
    // dcl_2d s3
    // texld r0, t1, s1
    temp0 = tex2D(NormalTextureSampler, i.texcoord1.xy);
    // mad r0.xy, r0, c0.x, c0.y
    temp0.xy = temp0.xy * float2(2, 2) + float2(-1, -1);
    // mul r0.xy, r0, c0.z
    temp0.xy = temp0.xy * float2(0.5, 0.5);
    // mov r0.z, c0.w
    temp0.z = float1(0);
    // add r0.xyz, r0, t3
    temp0.xyz = temp0.xyz + i.texcoord3.xyz;
    // mov r1.xy, t0.wzyx
    temp1.xy = i.texcoord.wz;
    // texld r0, r0, s2
    temp0 = texCUBE(EnvironmentTextureSampler, temp0.xyz);
    // texld r1, r1, s0
    temp1 = tex2D(RiverTextureSampler, temp1.xy);
    // texld r2, t0, s0
    temp2 = tex2D(RiverTextureSampler, i.texcoord.xy);
    // texld r3, t2, s3
    temp3 = tex2D(ShroudTextureSampler, i.texcoord2.xy);
    // add r1, r1, r2
    temp1 = temp1 + temp2;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mad r0.xyz, r0, c1.x, r1
    temp0.xyz = temp0.xyz * float3(0.75, 0.75, 0.75) + temp1.xyz;
    // lrp r2.xyz, v1.x, r0, -c0.y
    temp2.xyz = lerp(float3(1, 1, 1), temp0.xyz, i.color1.xxx);
    // mul r1.xyz, r3, r2
    temp1.xyz = temp3.xyz * temp2.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// _Default_M_VertexShader4 Vertex_2_0 Has PRES True
struct _Default_M_VertexShader4_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
    float4 texcoord1 : TEXCOORD1;
};

struct _Default_M_VertexShader4_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float4 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float color1 : COLOR1;
};

_Default_M_VertexShader4_Output _Default_M_VertexShader4(_Default_M_VertexShader4_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 18
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 3
      Unknown3: 0
      Unknown4: 0
      Unknown5: 18
      Unknown6: 3
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr18;
    float4 expr19;
    float4 expr20;
    {
        // Expression_2_1
        // mul c18.x, c0.x, (-0.004)
        expr18.x = Time.x * (-0.004);
        // mul c19.x, c0.x, (-0.016)
        expr19.x = Time.x * (-0.016);
        // mul c20.x, c0.x, (0.03)
        expr20.x = Time.x * (0.03);
    }

    _Default_M_VertexShader4_Output o;
    float4 temp0, temp1;
    float2 temp2;
    // def c0, 1, 0, 0.75, 0.95
    // def c1, 1, 0.5, 0.9, 0
    // def c2, -0, -2, 0, 0
    // dcl_position v0
    // dcl_color v1
    // dcl_texcoord1 v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // mov r1.x, c21.w
    temp1.x = Opacity.w;
    // mul r1.x, r1.x, v1.w
    temp1.x = temp1.x * i.color.w;
    // mul r1.x, r1.x, c0.z
    temp1.x = temp1.x * float1(0.75);
    // max r1.x, r1.x, c0.y
    temp1.x = max(temp1.x, float1(0));
    // min oD0.w, r1.x, c0.w
    o.color.w = min(temp1.x, float1(0.95));
    // mul r1, v2.xyxy, c1.xyxz
    temp1 = i.texcoord1.xyxy * float4(1, 0.5, 1, 0.9);
    // mov r2.xy, c0
    temp2.xy = float2(1, 0);
    // mad oT0.xy, c18.x, r2.yxzw, r1
    o.texcoord.xy = expr18.xx * temp2.yx + temp1.xy;
    // mad oT1.xy, c20.x, r2.yxzw, r1.zwzw
    o.texcoord1 = expr20.x * temp2.yxzw + temp1.zwzw;
    // mad oT0.zw, c19.x, r2.xyxy, v2.xyyx
    o.texcoord.zw = expr19.xx * temp2.xy + i.texcoord1.yx;
    // dp4 r1.x, r0, c15
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c16
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // dp4 r1.z, r0, c17
    temp1.z = dot(temp0, (World._m02_m12_m22_m32));
    // add r0.xy, r1, c22.zwzw
    temp0.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // add r1.xyz, -r1, c123
    temp1.xyz = -temp1.xyz + EyePosition.xyz;
    // mul oT2.xy, r0, c22
    o.texcoord2 = temp0 * Shroud.ScaleUV_OffsetUV;
    // nrm r0.xyz, r1
    temp0.xyz = normalize(temp1.xyz).xyz;
    // mad r0.xyz, r0.z, c2.xxyw, r0
    temp0.xyz = temp0.zzz * float3(-0, -0, -2) + temp0.xyz;
    // mov oT3.xyz, -r0
    o.texcoord3 = -temp0;
    // mul oD0.xyz, v1, c0.z
    o.color.xyz = i.color.xyz * float3(0.75, 0.75, 0.75);
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// Default_PixelShader5 Pixel_2_0 Has PRES False
struct Default_PixelShader5_Input
{
    float4 color : COLOR;
    float color1 : COLOR1;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float2 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
};

float4 Default_PixelShader5(Default_PixelShader5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 2.2, 2, -1, 0.25
    // def c1, 0.75, 0, 0, 0
    // dcl v0
    // dcl v1.x
    // dcl t0
    // dcl t1
    // dcl t2.xy
    // dcl t3.xyz
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // dcl_2d s3
    // texld r0, t1, s1
    temp0 = tex2D(NormalTextureSampler, i.texcoord1.xy);
    // mad r0.xy, r0, c0.y, c0.z
    temp0.xy = temp0.xy * float2(2, 2) + float2(-1, -1);
    // mov r1.xy, t1.wzyx
    temp1.xy = i.texcoord1.wz;
    // texld r1, r1, s1
    temp1 = tex2D(NormalTextureSampler, temp1.xy);
    // mad r0.xy, r1, c0.y, r0
    temp0.xy = temp1.xy * float2(2, 2) + temp0.xy;
    // add r0.xy, r0, c0.z
    temp0.xy = temp0.xy + float2(-1, -1);
    // mul r0.xy, r0, c0.w
    temp0.xy = temp0.xy * float2(0.25, 0.25);
    // rcp r0.z, t3.z
    temp0.z = 1.0f / i.texcoord3.z;
    // mad r0.xy, t3, r0.z, r0
    temp0.xy = i.texcoord3.xy * temp0.zz + temp0.xy;
    // mov r1.xy, t0.wzyx
    temp1.xy = i.texcoord.wz;
    // texld r0, r0, s2
    temp0 = tex2D(WaterReflectionTextureSampler, temp0.xy);
    // texld r1, r1, s0
    temp1 = tex2D(RiverTextureSampler, temp1.xy);
    // texld r2, t0, s0
    temp2 = tex2D(RiverTextureSampler, i.texcoord.xy);
    // texld r3, t2, s3
    temp3 = tex2D(ShroudTextureSampler, i.texcoord2.xy);
    // add r1, r1, r2
    temp1 = temp1 + temp2;
    // log r2.x, r1.x
    temp2.x = log2(temp1.x);
    // log r2.y, r1.y
    temp2.y = log2(temp1.y);
    // log r2.z, r1.z
    temp2.z = log2(temp1.z);
    // mul r2.xyz, r2, c0.x
    temp2.xyz = temp2.xyz * float3(2.2, 2.2, 2.2);
    // exp r1.x, r2.x
    temp1.x = exp2(temp2.x);
    // exp r1.y, r2.y
    temp1.y = exp2(temp2.y);
    // exp r1.z, r2.z
    temp1.z = exp2(temp2.z);
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mad r0.xyz, r0, c1.x, r1
    temp0.xyz = temp0.xyz * float3(0.75, 0.75, 0.75) + temp1.xyz;
    // lrp r2.xyz, v1.x, r0, -c0.z
    temp2.xyz = lerp(float3(1, 1, 1), temp0.xyz, i.color1.xxx);
    // mul r1.xyz, r3, r2
    temp1.xyz = temp3.xyz * temp2.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// Default_VertexShader6 Vertex_2_0 Has PRES True
struct Default_VertexShader6_Input
{
    float4 position : POSITION;
    float4 color : COLOR;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_VertexShader6_Output
{
    float4 position : POSITION;
    float4 color : COLOR;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
    float2 texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float color1 : COLOR1;
};

Default_VertexShader6_Output Default_VertexShader6(Default_VertexShader6_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 15
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 4
      Unknown3: 0
      Unknown4: 0
      Unknown5: 15
      Unknown6: 4
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr15;
    float4 expr16;
    float4 expr17;
    float4 expr18;
    {
        // Expression_2_1
        // mul c15.x, c0.x, (-0.004)
        expr15.x = Time.x * (-0.004);
        // mul c16.x, c0.x, (-0.016)
        expr16.x = Time.x * (-0.016);
        // mul c17.x, c0.x, (0.03)
        expr17.x = Time.x * (0.03);
        // mul c18.x, c0.x, (-0.08)
        expr18.x = Time.x * (-0.08);
    }

    Default_VertexShader6_Output o;
    float4 temp0, temp1;
    float2 temp2;
    // def c0, 1, 0, 0.75, 0.95
    // def c1, 1, 0.5, 0.9, 2
    // dcl_position v0
    // dcl_color v1
    // dcl_texcoord1 v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // mov r1.x, c21.w
    temp1.x = Opacity.w;
    // mul r1.x, r1.x, v1.w
    temp1.x = temp1.x * i.color.w;
    // mul r1.x, r1.x, c0.z
    temp1.x = temp1.x * float1(0.75);
    // max r1.x, r1.x, c0.y
    temp1.x = max(temp1.x, float1(0));
    // min oD0.w, r1.x, c0.w
    o.color.w = min(temp1.x, float1(0.95));
    // mul r1, v2.xyxy, c1.xyxz
    temp1 = i.texcoord1.xyxy * float4(1, 0.5, 1, 0.9);
    // mov r2.xy, c0
    temp2.xy = float2(1, 0);
    // mad oT0.xy, c15.x, r2.yxzw, r1
    o.texcoord.xy = expr15.xx * temp2.yx + temp1.xy;
    // mad oT1.xy, c17.x, r2.yxzw, r1.zwzw
    o.texcoord1.xy = expr17.xx * temp2.yx + temp1.zw;
    // mad oT0.zw, c16.x, r2.xyxy, v2.xyyx
    o.texcoord.zw = expr16.xx * temp2.xy + i.texcoord1.yx;
    // mul r1.xy, r2, c18.x
    temp1.xy = temp2.xy * expr18.xx;
    // mad oT1.zw, v2.xyyx, c1.xywx, r1.xyxy
    o.texcoord1.zw = i.texcoord1.yx * float2(2, 1) + temp1.xy;
    // dp4 r1.x, r0, c19
    temp1.x = dot(temp0, (World._m00_m10_m20_m30));
    // dp4 r1.y, r0, c20
    temp1.y = dot(temp0, (World._m01_m11_m21_m31));
    // add r1.xy, r1, c22.zwzw
    temp1.xy = temp1.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT2.xy, r1, c22
    o.texcoord2 = temp1 * Shroud.ScaleUV_OffsetUV;
    // dp4 r1.x, r0, c11
    temp1.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 r1.y, r0, c12
    temp1.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r1.z, r0, c14
    temp1.z = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // add r0.xy, r1, r1.z
    temp0.xy = temp1.xy + temp1.zz;
    // mov oPos.xyw, r1.xyzz
    o.position.xyw = temp1.xyz;
    // mov oT3.z, r1.z
    o.texcoord3.z = temp1.z;
    // mul oT3.xy, r0, c1.y
    o.texcoord3.xy = temp0.xy * float2(0.5, 0.5);
    // mul oD0.xyz, v1, c0.z
    o.color.xyz = i.color.xyz * float3(0.75, 0.75, 0.75);
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

technique Default
{
    pass P0
    {
        VertexShader = compile vs_2_0 Default_VertexShader6(); // 40
        PixelShader = compile ps_2_0 Default_PixelShader5(); // 41
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaTestEnable = 0;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
    }
}

technique _Default_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 _Default_M_VertexShader4(); // 42
        PixelShader = compile ps_2_0 _Default_M_PixelShader3(); // 43
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaTestEnable = 0;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
    }
}

technique _Default_L
{
    pass P0
    {
        VertexShader = compile vs_2_0 _Default_L_VertexShader2(); // 44
        PixelShader = compile ps_2_0 _Default_L_PixelShader1(); // 45
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaTestEnable = 0;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
    }
}

