string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct
{
    float3 Color;
    float3 Direction;
} DirectionalLight[3] : register(vs_2_0, c5) <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
float3 PhaseOffset : register(vs_2_0, c21) <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.PhaseOffset";>;
float PhaseOpacity : register(vs_2_0, c22) <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.PhaseOpacity";> = { 1 };
column_major float4x4 View : View : register(vs_2_0, c15);
column_major float4x3 ViewInverse : ViewInverse : register(vs_2_0, c18);
column_major float4x4 WorldViewProjection : WorldViewProjection : register(vs_2_0, c11);
float OpaqueSpeed : register(vs_2_0, c23) <string UIName = "Opaque Speed"; float UIMin = 0; float UIMax = 10000;>;
float TransparentSpeed <string UIName = "Transparent Speed"; float UIMin = 0; float UIMax = 10000;> = { 100 };
float SpeedStretchAmount : register(vs_2_0, c24) <string UIName = "Speed Stretch Amount"; float UIMin = 0; float UIMax = 10000;> = { 1 };
texture DiffuseTexture <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 9
sampler2D DiffuseTextureSampler : register(ps_2_0, s0) <string Texture = "DiffuseTexture"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <DiffuseTexture>; // 12
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
texture EnvironmentTexture <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.DetailTexture";>; // 16
sampler2D EnvironmentTextureSampler <string Texture = "EnvironmentTexture"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.DetailTexture";> =
sampler_state
{
    Texture = <EnvironmentTexture>; // 19
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 1;
    AddressV = 1;
};
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c25) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";>; // 25
sampler2D ShroudTextureSampler : register(ps_2_0, s1) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";> =
sampler_state
{
    Texture = <ShroudTexture>; // 29
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
// Default_PixelShader1 Pixel_2_0 Has PRES False
struct Default_PixelShader1_Input
{
    float4 color : COLOR;
    float4 color1 : COLOR1;
    float2 texcoord1 : TEXCOORD1;
    float2 texcoord3 : TEXCOORD3;
};

float4 Default_PixelShader1(Default_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, 2, 1, -0.75, 0
    // def c1, 0.9, 1.8, 10, -1
    // dcl v0
    // dcl v1
    // dcl t1.xy
    // dcl t3.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t3, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord3.xy);
    // texld r1, t1, s0
    temp1 = tex2D(DiffuseTextureSampler, i.texcoord1.xy);
    // add r0.x, r0.x, c0.z
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.w
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mad r0.yzw, r1.wzyx, c1.wzyx, c1.w
    temp0.yzw = temp1.zyx * float3(10, 1.8, 0.9) + float3(-1, -1, -1);
    // mul r1.w, r1.w, c0.x
    temp1.w = temp1.w * float1(2);
    // mad r0.yzw, v1.w, r0, c0.y
    temp0.yzw = i.color1.www * temp0.yzw + float3(1, 1, 1);
    // mul r1.xyz, r0.x, r0.wzyx
    temp1.xyz = temp0.xxx * temp0.wzy;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// Default_VertexShader2 Vertex_2_0 Has PRES True
struct Default_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct Default_VertexShader2_Output
{
    float4 color : COLOR;
    float4 position : POSITION;
    float4 color1 : COLOR1;
    float2 texcoord2 : TEXCOORD2;
    float2 texcoord3 : TEXCOORD3;
    float2 texcoord1 : TEXCOORD1;
};

Default_VertexShader2_Output Default_VertexShader2(Default_VertexShader2_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 26
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 26
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr26;
    {
        float4 temp0;
        float4 temp1;
        // Expression_2_1
        // neg r0.x, c0.x
        temp0.x = -OpaqueSpeed.x;
        // add r1.x, r0.x, c1.x
        temp1.x = temp0.x + TransparentSpeed.x;
        // rcp c26.x, r1.x
        expr26.x = 1.0f / (temp1.x);
    }

    Default_VertexShader2_Output o;
    float4 temp0, temp1;
    float3 temp2, temp3, temp4;
    // def c0, 1, 0, 2, -1
    // def c1, 0.5, 0.7, -0.5, 0.4
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // dp3 r0.x, v2, v2
    temp0.x = dot(i.texcoord1.xyz, i.texcoord1.xyz);
    // rsq r0.x, r0.x
    temp0.x = 1 / sqrt(temp0.x);
    // rcp r0.x, r0.x
    temp0.x = 1.0f / temp0.x;
    // add r0.y, r0.x, -c23.x
    temp0.y = temp0.x + -OpaqueSpeed.x;
    // mov r1.x, c1.x
    temp1.x = float1(0.5);
    // mad r0.x, r0.x, c24.x, r1.x
    temp0.x = temp0.x * SpeedStretchAmount.x + temp1.x;
    // mul r0.y, r0.y, c26.x
    temp0.y = temp0.y * expr26.x;
    // max r0.y, r0.y, c0.y
    temp0.y = max(temp0.y, float1(0));
    // min r0.y, r0.y, c0.x
    temp0.y = min(temp0.y, float1(1));
    // add r0.y, -r0.y, c0.x
    temp0.y = -temp0.y + float1(1);
    // mul oD0.w, r0.y, c22.x
    o.color.w = temp0.y * PhaseOpacity.x;
    // mad r0.yz, v1.xxyw, c0.z, c0.w
    temp0.yz = i.texcoord.xy * float2(2, 2) + float2(-1, -1);
    // mul r0.y, r0.y, c1.x
    temp0.y = temp0.y * float1(0.5);
    // mov r1.xyz, v2
    temp1.xyz = i.texcoord1.xyz;
    // add r1.xyz, r1, v0
    temp1.xyz = temp1.xyz + i.position.xyz;
    // mov r1.w, c0.x
    temp1.w = float1(1);
    // dp4 r2.x, r1, c15
    temp2.x = dot(temp1, (View._m00_m10_m20_m30));
    // dp4 r2.y, r1, c16
    temp2.y = dot(temp1, (View._m01_m11_m21_m31));
    // dp4 r2.z, r1, c17
    temp2.z = dot(temp1, (View._m02_m12_m22_m32));
    // mad r1, v0.xyzx, c0.xxxy, c0.yyyx
    temp1 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 r3.x, r1, c15
    temp3.x = dot(temp1, (View._m00_m10_m20_m30));
    // dp4 r3.y, r1, c16
    temp3.y = dot(temp1, (View._m01_m11_m21_m31));
    // dp4 r3.z, r1, c17
    temp3.z = dot(temp1, (View._m02_m12_m22_m32));
    // add r1.xyz, r2, -r3
    temp1.xyz = temp2.xyz + -temp3.xyz;
    // nrm r2.xyz, r1
    temp2.xyz = normalize(temp1.xyz).xyz;
    // mul r1.xyz, r3.yzxw, r2.zxyw
    temp1.xyz = temp3.yzx * temp2.zxy;
    // mad r1.xyz, r2.yzxw, r3.zxyw, -r1
    temp1.xyz = temp2.yzx * temp3.zxy + -temp1.xyz;
    // nrm r4.xyz, r1
    temp4.xyz = normalize(temp1.xyz).xyz;
    // mad r1.xyz, r0.y, r4, r3
    temp1.xyz = temp0.yyy * temp4.xyz + temp3.xyz;
    // mul r0.yzw, r0.z, r2.xxyz
    temp0.yzw = temp0.zzz * temp2.xyz;
    // mad r0.xyz, r0.x, r0.yzww, r1
    temp0.xyz = temp0.xxx * temp0.yzw + temp1.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 r1.x, r0, c18
    temp1.x = dot(temp0, (ViewInverse._m00_m10_m20_m30));
    // dp4 r1.y, r0, c19
    temp1.y = dot(temp0, (ViewInverse._m01_m11_m21_m31));
    // dp4 r1.z, r0, c20
    temp1.z = dot(temp0, (ViewInverse._m02_m12_m22_m32));
    // add r0.xyz, r1, c21
    temp0.xyz = temp1.xyz + PhaseOffset.xyz;
    // mov r0.w, c0.x
    temp0.w = float1(1);
    // dp4 oPos.x, r0, c11
    o.position.x = dot(temp0, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c12
    o.position.y = dot(temp0, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c13
    o.position.z = dot(temp0, (WorldViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c14
    o.position.w = dot(temp0, (WorldViewProjection._m03_m13_m23_m33));
    // add r0.xy, r0, c25.zwzw
    temp0.xy = temp0.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mov r1.xyz, c5
    temp1.xyz = DirectionalLight[0].Color.xyz;
    // add r1.xyz, r1, c7
    temp1.xyz = temp1.xyz + DirectionalLight[1].Color.xyz;
    // add r1.xyz, r1, c9
    temp1.xyz = temp1.xyz + DirectionalLight[2].Color.xyz;
    // mul oD1.xyz, r1, c1.y
    o.color1.xyz = temp1.xyz * float3(0.7, 0.7, 0.7);
    // mul r1.xyz, r2.yzxw, r4.zxyw
    temp1.xyz = temp2.yzx * temp4.zxy;
    // mad r1.xyz, r4.yzxw, r2.zxyw, -r1
    temp1.xyz = temp4.yzx * temp2.zxy + -temp1.xyz;
    // add r0.zw, v1.xyxy, c1.z
    temp0.zw = i.texcoord.xy + float2(-0.5, -0.5);
    // mul r0.zw, r0, c1.w
    temp0.zw = temp0.zw * float2(0.4, 0.4);
    // mul r2.xyz, r2, r0.w
    temp2.xyz = temp2.xyz * temp0.www;
    // mad r2.xyz, r0.z, r4, r2
    temp2.xyz = temp0.zzz * temp4.xyz + temp2.xyz;
    // mad r0.z, r0.z, -r0.z, c0.x
    temp0.z = temp0.z * -temp0.z + float1(1);
    // mad r0.z, r0.w, r0.w, r0.z
    temp0.z = temp0.w * temp0.w + temp0.z;
    // rsq r0.z, r0.z
    temp0.z = 1 / sqrt(temp0.z);
    // rcp r0.z, r0.z
    temp0.z = 1.0f / temp0.z;
    // mad r1.xyz, r0.z, r1, r2
    temp1.xyz = temp0.zzz * temp1.xyz + temp2.xyz;
    // dp3 r0.z, r1, r1
    temp0.z = dot(temp1.xyz, temp1.xyz);
    // rsq r0.z, r0.z
    temp0.z = 1 / sqrt(temp0.z);
    // mul r0.zw, r1.xyxy, r0.z
    temp0.zw = temp1.xy * temp0.zz;
    // mad oT2.xy, r0.zwzw, c1.x, c1.x
    o.texcoord2 = temp0.zwzw * float4(0.5, 0.5, 0.5, 0.5) + float4(0.5, 0.5, 0.5, 0.5);
    // mul oT3.xy, r0, c25
    o.texcoord3 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0.xyz, c0.x
    o.color.xyz = float3(1, 1, 1);
    // mov oD1.w, c0.x
    o.color1.w = float1(1);
    // mov oT1.xy, v1
    o.texcoord1 = i.texcoord;
    // 

    return o;
}

technique Default
{
    pass pass0
    {
        VertexShader = compile vs_2_0 Default_VertexShader2(); // 34
        PixelShader = compile ps_2_0 Default_PixelShader1(); // 35
        ZEnable = 1;
        ZWriteEnable = 0;
        ZFunc = 4;
        AlphaBlendEnable = 1;
        CullMode = 1;
        SrcBlend = 2;
        DestBlend = 2;
    }
}

