string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
column_major float4x4 ViewProjection : register(vs_2_0, c119) <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture Texture_0 <string UIWidget = "None"; string UIName = "None"; string SasBindAddress = "WW3D.MiscTexture";>; // 2
sampler2D Texture_0Sampler : register(ps_2_0, s0) <string Texture = "Texture_0"; string UIWidget = "None"; string UIName = "None"; string SasBindAddress = "WW3D.MiscTexture";> =
sampler_state
{
    Texture = <Texture_0>; // 6
    MinFilter = 3;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
float4 TexCoordTransform_0 : register(vs_2_0, c11) <string UIName = "UV0 Scl/Move"; string UIWidget = "Spinner"; float UIMin = -100; float UIMax = 100;> = { 1, 1, 0, 0 };
bool FogEnable <string UIName = "Fog Enable";> = { 1 };
struct
{
    float4 ScaleUV_OffsetUV;
} Shroud : register(vs_2_0, c12) <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud";> = { 1, 1, 0, 0 };
texture ShroudTexture <string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";>; // 16
sampler2D ShroudTextureSampler : register(ps_2_0, s1) <string Texture = "ShroudTexture"; string UIWidget = "None"; string SasBindAddress = "Terrain.Shroud.Texture"; string ResourceName = "ShaderPreviewShroud.dds";> =
sampler_state
{
    Texture = <ShroudTexture>; // 20
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
float Time : Time;
// PS_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_Array_Shader_0_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_Array_Shader_0(PS_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, 2.2, -0.75, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.y
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.z
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // log r0.w, r1.x
    temp0.w = log2(temp1.x);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // log r0.y, r1.z
    temp0.y = log2(temp1.z);
    // mul r0.yzw, r0, c0.x
    temp0.yzw = temp0.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.w
    temp1.x = exp2(temp0.w);
    // exp r1.y, r0.z
    temp1.y = exp2(temp0.z);
    // exp r1.z, r0.y
    temp1.z = exp2(temp0.y);
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_Array_Shader_1_Input
{
    float4 color : COLOR;
    float color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_Array_Shader_1(PS_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, 2.2, -1, 1, -0.75
    // def c1, 0, 0, 0, 0
    // dcl v0
    // dcl v1.x
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.w
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c1.x
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // log r0.w, r1.x
    temp0.w = log2(temp1.x);
    // log r0.z, r1.y
    temp0.z = log2(temp1.y);
    // log r0.y, r1.z
    temp0.y = log2(temp1.z);
    // mul r0.yzw, r0, c0.x
    temp0.yzw = temp0.yzw * float3(2.2, 2.2, 2.2);
    // exp r1.x, r0.w
    temp1.x = exp2(temp0.w);
    // exp r1.y, r0.z
    temp1.y = exp2(temp0.z);
    // exp r1.z, r0.y
    temp1.z = exp2(temp0.y);
    // mad r0.yzw, v0.wzyx, r1.wzyx, c0.y
    temp0.yzw = i.color.zyx * temp1.zyx + float3(-1, -1, -1);
    // mad r0.yzw, v1.x, r0, c0.z
    temp0.yzw = i.color1.xxx * temp0.yzw + float3(1, 1, 1);
    // mul r0.xyz, r0.x, r0.wzyx
    temp0.xyz = temp0.xxx * temp0.wzy;
    // mul r0.w, r1.w, v0.w
    temp0.w = temp1.w * i.color.w;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PS_Array_Shader_2 Pixel_2_0 Has PRES False
struct PS_Array_Shader_2_Input
{
    float4 color : COLOR;
    float color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_Array_Shader_2(PS_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, 2.2, -0.75, 0, 0
    // dcl v0
    // dcl v1.x
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t0, s0
    temp0 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // texld r1, t1, s1
    temp1 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // log r1.w, r0.x
    temp1.w = log2(temp0.x);
    // log r1.z, r0.y
    temp1.z = log2(temp0.y);
    // log r1.y, r0.z
    temp1.y = log2(temp0.z);
    // mul r1.yzw, r1, c0.x
    temp1.yzw = temp1.yzw * float3(2.2, 2.2, 2.2);
    // exp r0.x, r1.w
    temp0.x = exp2(temp1.w);
    // exp r0.y, r1.z
    temp0.y = exp2(temp1.z);
    // exp r0.z, r1.y
    temp0.z = exp2(temp1.y);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mul r1.yzw, r0.wzyx, v1.x
    temp1.yzw = temp0.zyx * i.color1.xxx;
    // add r1.x, r1.x, c0.y
    temp1.x = temp1.x + float1(-0.75);
    // add r1.x, r1.x, r1.x
    temp1.x = temp1.x + temp1.x;
    // max r2.w, r1.x, c0.z
    temp2.w = max(temp1.x, float1(0));
    // add r1.x, r2.w, r2.w
    temp1.x = temp2.w + temp2.w;
    // mul r0.xyz, r1.wzyx, r1.x
    temp0.xyz = temp1.wzy * temp1.xxx;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PS_Array[3] = {
    compile ps_2_0 PS_Array_Shader_0(), // 25
    compile ps_2_0 PS_Array_Shader_1(), // 26
    compile ps_2_0 PS_Array_Shader_2(), // 27
};
// PS_M_Array_Shader_0 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_0_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_0(PS_M_Array_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, -0.75, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.x
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.y
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_M_Array_Shader_1 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_1_Input
{
    float4 color : COLOR;
    float color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_1(PS_M_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, -1, 1, -0.75, 0
    // dcl v0
    // dcl v1.x
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.z
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.w
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // mad r0.yzw, v0.wzyx, r1.wzyx, c0.x
    temp0.yzw = i.color.zyx * temp1.zyx + float3(-1, -1, -1);
    // mul r1.w, r1.w, v0.w
    temp1.w = temp1.w * i.color.w;
    // mad r0.yzw, v1.x, r0, c0.y
    temp0.yzw = i.color1.xxx * temp0.yzw + float3(1, 1, 1);
    // mul r1.xyz, r0.x, r0.wzyx
    temp1.xyz = temp0.xxx * temp0.wzy;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// PS_M_Array_Shader_2 Pixel_2_0 Has PRES False
struct PS_M_Array_Shader_2_Input
{
    float4 color : COLOR;
    float color1 : COLOR1;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 PS_M_Array_Shader_2(PS_M_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, -0.75, 0, 0, 0
    // dcl v0
    // dcl v1.x
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.x
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.y
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r0.yzw, r1.wzyx, v1.x
    temp0.yzw = temp1.zyx * i.color1.xxx;
    // mul r1.xyz, r0.x, r0.wzyx
    temp1.xyz = temp0.xxx * temp0.wzy;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

PixelShader PS_M_Array[3] = {
    compile ps_2_0 PS_M_Array_Shader_0(), // 32
    compile ps_2_0 PS_M_Array_Shader_1(), // 33
    compile ps_2_0 PS_M_Array_Shader_2(), // 34
};
// _Alpha_L_PixelShader7 Pixel_2_0 Has PRES False
struct _Alpha_L_PixelShader7_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 _Alpha_L_PixelShader7(_Alpha_L_PixelShader7_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, -0.75, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.x
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.y
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// _Alpha_L_VertexShader8 Vertex_2_0 Has PRES True
struct _Alpha_L_VertexShader8_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct _Alpha_L_VertexShader8_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float color1 : COLOR1;
};

_Alpha_L_VertexShader8_Output _Alpha_L_VertexShader8(_Alpha_L_VertexShader8_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 13
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 13
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr13;
    {
        // Expression_2_1
        // mul c13.xy, c1.x, c0.zw
        expr13.xy = Time.x * TexCoordTransform_0.zw;
    }

    _Alpha_L_VertexShader8_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov r0.xy, c11
    temp0.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v1, r0, c13
    o.texcoord = i.texcoord * temp0 + expr13;
    // add r0.xy, v0, c12.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c12
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, v2
    o.color = i.color;
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// _Additive_L_PixelShader9 Pixel_2_0 Has PRES False
struct _Additive_L_PixelShader9_Input
{
    float4 color : COLOR;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
};

float4 _Additive_L_PixelShader9(_Additive_L_PixelShader9_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1;
    float4 temp2;
    // def c0, -0.75, 0, 0, 0
    // dcl v0
    // dcl t0.xy
    // dcl t1.xy
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, t1, s1
    temp0 = tex2D(ShroudTextureSampler, i.texcoord1.xy);
    // texld r1, t0, s0
    temp1 = tex2D(Texture_0Sampler, i.texcoord.xy);
    // add r0.x, r0.x, c0.x
    temp0.x = temp0.x + float1(-0.75);
    // add r0.x, r0.x, r0.x
    temp0.x = temp0.x + temp0.x;
    // max r2.w, r0.x, c0.y
    temp2.w = max(temp0.x, float1(0));
    // add r0.x, r2.w, r2.w
    temp0.x = temp2.w + temp2.w;
    // mul r1, r1, v0
    temp1 = temp1 * i.color;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mov oC0, r1
    out_color = temp1;
    // 

    return out_color;
}

// _Additive_L_VertexShader10 Vertex_2_0 Has PRES True
struct _Additive_L_VertexShader10_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct _Additive_L_VertexShader10_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float color1 : COLOR1;
};

_Additive_L_VertexShader10_Output _Additive_L_VertexShader10(_Additive_L_VertexShader10_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 13
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 13
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr13;
    {
        // Expression_2_1
        // mul c13.xy, c1.x, c0.zw
        expr13.xy = Time.x * TexCoordTransform_0.zw;
    }

    _Additive_L_VertexShader10_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov r0.xy, c11
    temp0.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v1, r0, c13
    o.texcoord = i.texcoord * temp0 + expr13;
    // add r0.xy, v0, c12.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c12
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, v2
    o.color = i.color;
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// _Alpha_M_VertexShader11 Vertex_2_0 Has PRES True
struct _Alpha_M_VertexShader11_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct _Alpha_M_VertexShader11_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float color1 : COLOR1;
};

_Alpha_M_VertexShader11_Output _Alpha_M_VertexShader11(_Alpha_M_VertexShader11_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 13
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 13
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr13;
    {
        // Expression_2_1
        // mul c13.xy, c1.x, c0.zw
        expr13.xy = Time.x * TexCoordTransform_0.zw;
    }

    _Alpha_M_VertexShader11_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov r0.xy, c11
    temp0.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v1, r0, c13
    o.texcoord = i.texcoord * temp0 + expr13;
    // add r0.xy, v0, c12.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c12
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, v2
    o.color = i.color;
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// _Additive_M_VertexShader12 Vertex_2_0 Has PRES True
struct _Additive_M_VertexShader12_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct _Additive_M_VertexShader12_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float color1 : COLOR1;
};

_Additive_M_VertexShader12_Output _Additive_M_VertexShader12(_Additive_M_VertexShader12_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 13
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 13
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr13;
    {
        // Expression_2_1
        // mul c13.xy, c1.x, c0.zw
        expr13.xy = Time.x * TexCoordTransform_0.zw;
    }

    _Additive_M_VertexShader12_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov r0.xy, c11
    temp0.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v1, r0, c13
    o.texcoord = i.texcoord * temp0 + expr13;
    // add r0.xy, v0, c12.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c12
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, v2
    o.color = i.color;
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// Alpha_VertexShader13 Vertex_2_0 Has PRES True
struct Alpha_VertexShader13_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Alpha_VertexShader13_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float color1 : COLOR1;
};

Alpha_VertexShader13_Output Alpha_VertexShader13(Alpha_VertexShader13_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 13
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 13
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr13;
    {
        // Expression_2_1
        // mul c13.xy, c1.x, c0.zw
        expr13.xy = Time.x * TexCoordTransform_0.zw;
    }

    Alpha_VertexShader13_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov r0.xy, c11
    temp0.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v1, r0, c13
    o.texcoord = i.texcoord * temp0 + expr13;
    // add r0.xy, v0, c12.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c12
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, v2
    o.color = i.color;
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

// Additive_VertexShader14 Vertex_2_0 Has PRES True
struct Additive_VertexShader14_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Additive_VertexShader14_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float2 texcoord1 : TEXCOORD1;
    float4 color : COLOR;
    float color1 : COLOR1;
};

Additive_VertexShader14_Output Additive_VertexShader14(Additive_VertexShader14_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 13
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 1
      Unknown3: 0
      Unknown4: 0
      Unknown5: 13
      Unknown6: 1
      Mappings: 1
        0 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr13;
    {
        // Expression_2_1
        // mul c13.xy, c1.x, c0.zw
        expr13.xy = Time.x * TexCoordTransform_0.zw;
    }

    Additive_VertexShader14_Output o;
    float4 temp0;
    // def c0, 1, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad r0, v0.xyzx, c0.xxxy, c0.yyyx
    temp0 = i.position.xyzx * float4(1, 1, 1, 0) + float4(0, 0, 0, 1);
    // dp4 oPos.x, r0, c119
    o.position.x = dot(temp0, (ViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r0, c120
    o.position.y = dot(temp0, (ViewProjection._m01_m11_m21_m31));
    // dp4 oPos.z, r0, c121
    o.position.z = dot(temp0, (ViewProjection._m02_m12_m22_m32));
    // dp4 oPos.w, r0, c122
    o.position.w = dot(temp0, (ViewProjection._m03_m13_m23_m33));
    // mov r0.xy, c11
    temp0.xy = TexCoordTransform_0.xy;
    // mad oT0.xy, v1, r0, c13
    o.texcoord = i.texcoord * temp0 + expr13;
    // add r0.xy, v0, c12.zwzw
    temp0.xy = i.position.xy + Shroud.ScaleUV_OffsetUV.zw;
    // mul oT1.xy, r0, c12
    o.texcoord1 = temp0 * Shroud.ScaleUV_OffsetUV;
    // mov oD0, v2
    o.color = i.color;
    // mov oD1.x, c0.x
    o.color1 = float4(1, 1, 1, 1);
    // 

    return o;
}

technique Additive
{
    pass P0
    {
        VertexShader = compile vs_2_0 Additive_VertexShader14(); // 28
        PixelShader = <PS_Array[0]>; // 29
        AlphaBlendEnable = 1;
        AlphaTestEnable = 0;
        CullMode = 1;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        SrcBlend = 2;
        DestBlend = 2;
    }
}

technique Alpha
{
    pass P0
    {
        VertexShader = compile vs_2_0 Alpha_VertexShader13(); // 30
        PixelShader = <PS_Array[0]>; // 31
        AlphaBlendEnable = 1;
        AlphaTestEnable = 0;
        CullMode = 1;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        SrcBlend = 5;
        DestBlend = 6;
    }
}

technique _Additive_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 _Additive_M_VertexShader12(); // 35
        PixelShader = <PS_M_Array[0]>; // 36
        AlphaBlendEnable = 1;
        AlphaTestEnable = 0;
        CullMode = 1;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        SrcBlend = 2;
        DestBlend = 2;
    }
}

technique _Alpha_M
{
    pass P0
    {
        VertexShader = compile vs_2_0 _Alpha_M_VertexShader11(); // 37
        PixelShader = <PS_M_Array[0]>; // 38
        AlphaBlendEnable = 1;
        AlphaTestEnable = 0;
        CullMode = 1;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        SrcBlend = 5;
        DestBlend = 6;
    }
}

technique _Additive_L
{
    pass P0
    {
        VertexShader = compile vs_2_0 _Additive_L_VertexShader10(); // 39
        PixelShader = compile ps_2_0 _Additive_L_PixelShader9(); // 40
        AlphaBlendEnable = 1;
        AlphaTestEnable = 0;
        CullMode = 1;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        SrcBlend = 2;
        DestBlend = 2;
    }
}

technique _Alpha_L
{
    pass P0
    {
        VertexShader = compile vs_2_0 _Alpha_L_VertexShader8(); // 41
        PixelShader = compile ps_2_0 _Alpha_L_PixelShader7(); // 42
        AlphaBlendEnable = 1;
        AlphaTestEnable = 0;
        CullMode = 1;
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        SrcBlend = 5;
        DestBlend = 6;
    }
}

