string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
float4 WorldBones[128] <bool unmanaged = 1;>;
texture FrameY <string SasBindAddress = "Video.FrameY";>; // 2
sampler2D FrameYSampler : register(ps_2_0, s0) <string Texture = "FrameY"; string SasBindAddress = "Video.FrameY";> =
sampler_state
{
    Texture = <FrameY>; // 4
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
texture FrameU <string SasBindAddress = "Video.FrameU";>; // 7
sampler2D FrameUSampler : register(ps_2_0, s1) <string Texture = "FrameU"; string SasBindAddress = "Video.FrameU";> =
sampler_state
{
    Texture = <FrameU>; // 9
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
texture FrameV <string SasBindAddress = "Video.FrameV";>; // 12
sampler2D FrameVSampler : register(ps_2_0, s2) <string Texture = "FrameV"; string SasBindAddress = "Video.FrameV";> =
sampler_state
{
    Texture = <FrameV>; // 14
    AddressU = 3;
    AddressV = 3;
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
};
// Default_PixelShader1 Pixel_2_0 Has PRES False
struct Default_PixelShader1_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

float4 Default_PixelShader1(Default_PixelShader1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, -0.062745, -0.50196, -0.50196, 1
    // def c1, 1.164144, -0.0017889, 1.595786, 0
    // def c2, 1.164144, -0.3914428, -0.8134821, 0
    // def c3, 1.164144, 2.017826, -0.0012458, 0
    // dcl t0.xy
    // dcl v0
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // texld r0, t0, s0
    temp0 = tex2D(FrameYSampler, i.texcoord.xy);
    // texld r1, t0, s1
    temp1 = tex2D(FrameUSampler, i.texcoord.xy);
    // texld r2, t0, s2
    temp2 = tex2D(FrameVSampler, i.texcoord.xy);
    // mov r0.y, r1.x
    temp0.y = temp1.x;
    // mov r0.z, r2.x
    temp0.z = temp2.x;
    // add r0.xyz, r0, c0
    temp0.xyz = temp0.xyz + float3(-0.062745, -0.50196, -0.50196);
    // dp3 r1.x, r0, c1
    temp1.x = dot(temp0.xyz, float3(1.1641444, -0.0017889, 1.5957862));
    // dp3 r1.y, r0, c2
    temp1.y = dot(temp0.xyz, float3(1.1641444, -0.3914428, -0.8134821));
    // dp3 r1.z, r0, c3
    temp1.z = dot(temp0.xyz, float3(1.1641444, 2.0178256, -0.0012458));
    // mov r1.w, c0.w
    temp1.w = float1(1);
    // mul r0, r1, v0
    temp0 = temp1 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Default_VertexShader2 Vertex_2_0 Has PRES False
struct Default_VertexShader2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 color : COLOR;
};

struct Default_VertexShader2_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

Default_VertexShader2_Output Default_VertexShader2(Default_VertexShader2_Input i)
{
    Default_VertexShader2_Output o;
    // def c0, 2, -2, -1, 1
    // def c1, 0, 1, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_color v2
    // mad oPos.xy, v0, c0, c0.zwzw
    o.position.xy = i.position.xy * float2(2, -2) + float2(-1, 1);
    // mov oPos.zw, c1.xyxy
    o.position.zw = float2(0, 1);
    // mov oT0.xy, v1
    o.texcoord = i.texcoord;
    // mov oD0, v2
    o.color = i.color;
    // 

    return o;
}

technique Default
{
    pass P0
    {
        CullMode = 1;
        ZEnable = 0;
        ZWriteEnable = 0;
        AlphaTestEnable = 0;
        AlphaBlendEnable = 1;
        SrcBlend = 5;
        DestBlend = 6;
        VertexShader = compile vs_2_0 Default_VertexShader2(); // 17
        PixelShader = compile ps_2_0 Default_PixelShader1(); // 18
    }
}

