string DefaultParameterScopeBlock = "material"; // 1
float3 AmbientLightColor <bool unmanaged = 1;> = { 0.3, 0.3, 0.3 };
struct {
    float3 Color;
    float3 Direction;
} DirectionalLight[3] <bool unmanaged = 1;> = { 1.625198, 1.512711, 1.097048, 0.62914, -0.34874, 0.69465, 0.5232916, 0.6654605, 0.7815244, -0.32877, 0.90329, 0.27563, 0.4420466, 0.4102767, 0.4420466, -0.80704, -0.58635, 0.06975 };
struct {
    float3 Color;
    float3 Position;
    float2 Range_Inner_Outer;
} PointLight[8] <bool unmanaged = 1;>;
struct {
    float4 WorldPositionMultiplier_XYZZ;
    float2 CurrentOffsetUV;
} Cloud <bool unmanaged = 1;>;
float3 NoCloudMultiplier <bool unmanaged = 1;> = { 1, 1, 1 };
float3 RecolorColorDummy <bool unmanaged = 1;>;
row_major float4x4 ShadowMapWorldToShadow <bool unmanaged = 1;>;
float OpacityOverride <bool unmanaged = 1;> = { 1 };
float3 TintColor <bool unmanaged = 1;> = { 1, 1, 1 };
float3 EyePosition <bool unmanaged = 1;>;
row_major float4x4 ViewProjection <bool unmanaged = 1;>;
struct
{
    float4 VideoTex_NumPerRow_LastFrame_SingleRow_isRand;
    float4 ColorAnimationFunctions[6];
    float4 TimeKeys;
    int ShaderType;
    float SpeedMultiplier;
    float2 ColorScaleRange;
} Draw : register(vs_3_0, c63) <string UIWidget = "None"; string SasBindAddress = "Particle.Draw";> = { 4, 15, -1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, -0.1, 0.2 };
struct
{
    float3 Gravity;
    float3 DriftVelocity;
    float2 VelocityDampingRange;
} Physics : register(vs_3_0, c128) <string UIWidget = "None"; string SasBindAddress = "Particle.Physics";> = { 0, 0, 0, 0, 0, 0, 1, 0 };
struct
{
    float3 Size_Rate_Damping__Min;
    float3 Size_Rate_Damping__Spread;
    float3 XYRotation_Rate_Damping__Min;
    float3 XYRotation_Rate_Damping__Spread;
    float3 ZRotation_Rate_Damping__Min;
    float3 ZRotation_Rate_Damping__Spread;
} Update : register(vs_2_0, c65) <string UIWidget = "None"; string SasBindAddress = "Particle.Update";> = { 0, 0, 1, 10, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0 };
texture ParticleTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 8
sampler2D ParticleTextureSamplerSampler : register(ps_2_0, s0) : register(ps_3_0, s0) <string Texture = "ParticleTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <ParticleTextureSampler>; // 11
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture NextFrameTextureSampler <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";>; // 15
sampler2D NextFrameTextureSamplerSampler : register(ps_3_0, s1) <string Texture = "NextFrameTextureSampler"; string UIWidget = "None"; string SasBindAddress = "Particle.Draw.Texture";> =
sampler_state
{
    Texture = <NextFrameTextureSampler>; // 18
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 2;
    AddressU = 3;
    AddressV = 3;
};
texture DepthTexture <string SasBindAddress = "WW3D.DepthTexture";>; // 22
sampler2D DepthTextureSampler : register(ps_3_0, s2) <string Texture = "DepthTexture"; string SasBindAddress = "WW3D.DepthTexture";> =
sampler_state
{
    Texture = <DepthTexture>; // 24
    MinFilter = 2;
    MagFilter = 2;
    MipFilter = 1;
    AddressU = 3;
    AddressV = 3;
};
bool ShouldDrawParticleSoft <string UIWidget = "None"; string SasBindAddress = "Particle.Draw.ShouldDrawParticleSoft";>;
column_major float4x4 WorldView : WorldView : register(vs_3_0, c85);
column_major float4x4 Projection : Projection : register(vs_3_0, c124);
column_major float4x4 WorldViewProjection : WorldViewProjection;
column_major float4x3 View : View : register(vs_2_0, c78);
row_major float4x4 ProjectionI : ProjectionInverse;
float Time : Time;
struct
{
    float3 StartSizeMinimums;
    float3 StartSizeSpreads;
    float3 SizeRateMinimums;
    float3 SizeRateSpreads;
    float3 SizeDampingMinimums;
    float3 SizeDampingSpreads;
    float3 AngleMinimums;
    float3 AngleSpreads;
    float3 AngularRateMinimums;
    float3 AngularRateSpreads;
    float2 AngleDampingMin_AngleDampingSpread;
    int RotationType;
} GeometryUpdate : register(vs_2_0, c68) : register(vs_3_0, c74) <string UIWidget = "None"; string SasBindAddress = "Particle.GeometryUpdate";>;
// VS_Array_H_Shader_0 Vertex_3_0 Has PRES True
struct VS_Array_H_Shader_0_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct VS_Array_H_Shader_0_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

VS_Array_H_Shader_0_Output VS_Array_H_Shader_0(VS_Array_H_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 44
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 19
      Unknown3: 3
      Unknown4: 0
      Unknown5: 44
      Unknown6: 2
      Mappings: 5
        0 - ConstOutput: 51 ConstInput 2
        1 - ConstOutput: 54 ConstInput 1
        2 - ConstOutput: 56 ConstInput 1
        3 - ConstOutput: 60 ConstInput 3
        4 - ConstOutput: 1 ConstInput 0
    
    */
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    float4 expr57;
    float4 expr58;
    float4 expr59;
    float4 expr60;
    float4 expr61;
    float4 expr62;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c44.x, c1.x, (30)
        expr44.x = Time.x * (30);
        // add c45.x, c0.x, (-1)
        expr45.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // neg r0.y, c0.w
        temp0.y = -Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // max r1.x, r0.y, c0.w
        temp1.x = max(temp0.y, Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w);
        // neg r0.y, r1.x
        temp0.y = -temp1.x;
        // ge r2.x, r0.y, r1.x
        temp2.x = temp0.y >= temp1.x;
        // lt unknown1.x, r0.y, r1.x
        unknown1.x = temp0.y < temp1.x;
        // mul unknown0.x, r0.x, r2.x
        unknown0.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // max r2.x, r0.x, r1.x
        temp2.x = max(temp0.x, temp1.x);
        // neg r0.x, r2.x
        temp0.x = -temp2.x;
        // ge unknown2.x, r0.x, r2.x
        unknown2.x = temp0.x >= temp2.x;
        // rcp c61.x, c0.y
        expr61.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c51.x, r1.x
        expr51.x = temp1.x;
        // mov c54.x, r1.x
        expr54.x = temp1.x;
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // mov c52.x, r0.x
        expr52.x = temp0.x;
        // mov c56.x, r0.x
        expr56.x = temp0.x;
        // mov c60.x, r0.x
        expr60.x = temp0.x;
        // mov c62.x, r0.x
        expr62.x = temp0.x;
    }

    VS_Array_H_Shader_0_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5;
    float3 addr0;
    // def c43, 0.1875, 8.9375, 2.0625, 2.75
    // def c27, 1, 0.5, 0, 16
    // def c30, 0, 0.5, 0, 0.6666667
    // def c36, 1, 0.1875, 1.375, 1
    // def c37, 1, 0.1875, 4.8125, 0
    // def c28, 1, -0.5, 0, 1.0001
    // def c29, 0, -0.5, 0, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c31, 1, 0, 0.5, 0
    // def c32, 1, 0, -0.5, 0
    // def c33, 0, 0, -0.5, 0
    // def c34, 0, 0, 0.5, 0
    // def c35, 0, 0, 0, 1
    // def c38, 0, 0, 0, 0
    // def c39, 0, 0, 0, 1
    // def c40, 1, 0, 0, 1
    // def c41, 1, 0, 0, 0
    // def c42, 0, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // dcl_position o0
    // dcl_texcoord o1.xy
    // dcl_color o2
    // dcl_texcoord1 o3.xyz
    // dcl_texcoord2 o4.x
    // dcl_texcoord3 o5.xyz
    // dcl_texcoord4 o6
    // dcl_texcoord5 o7.xy
    // add r0.x, c44.x, -v1.w
    temp0.x = expr44.x + -i.texcoord.w;
    // mad r0.yzw, v2.x, c43.x, c43
    temp0.yzw = i.texcoord1.xxx * float3(0.1875, 0.1875, 0.1875) + float3(8.9375, 2.0625, 2.75);
    // frc r0.yzw, r0
    temp0.yzw = frac(temp0.yzw);
    // mul r0.yzw, r0, c27.w
    temp0.yzw = temp0.yzw * float3(16, 16, 16);
    // frc r1.xyz, r0.yzww
    temp1.xyz = frac(temp0.yzw);
    // add r0.yzw, r0, -r1.xxyz
    temp0.yzw = temp0.yzw + -temp1.xyz;
    // mova a0.xyz, r0.yzww
    addr0.xyz = temp0.yzw;
    // mov r1.xy, c126
    temp1.xy = Physics.VelocityDampingRange.xy;
    // mad r0.y, c11[a0.x].x, r1.y, r1.x
    temp0.y = float1(0.957897) * temp1.y + temp1.x;
    // add r0.z, r0.y, -c27.x
    temp0.z = temp0.y + float1(-1);
    // sge r0.z, -r0_abs.z, r0_abs.z
    temp0.z = (r0.z == 0) ? 1 : 0;
    // lrp r1.x, r0.z, c28.w, r0.y
    temp1.x = lerp(temp0.y, float1(1.0001), temp0.z);
    // log r0.y, r1.x
    temp0.y = log2(temp1.x);
    // mul r0.z, r0.x, r0.y
    temp0.z = temp0.x * temp0.y;
    // exp r0.z, r0.z
    temp0.z = exp2(temp0.z);
    // add r0.z, r0.z, -c27.x
    temp0.z = temp0.z + float1(-1);
    // mul r0.y, r0.y, c29.w
    temp0.y = temp0.y * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul r0.y, r0.z, r0.y
    temp0.y = temp0.z * temp0.y;
    // mul r0.z, r0.x, c27.y
    temp0.z = temp0.x * float1(0.5);
    // mov r1.xyz, c124
    temp1.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r0.z, r1, c125
    temp1.xyz = temp0.zzz * temp1.xyz + Physics.DriftVelocity.xyz;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mad r0.yzw, v1.xxyz, r0.y, r1.xxyz
    temp0.yzw = i.texcoord.xyz * temp0.yyy + temp1.xyz;
    // add r0.yzw, r0, v0.xxyz
    temp0.yzw = temp0.yzw + i.position.xyz;
    // mov r1.xyz, c11[a0.y]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c75
    temp2.xyz = GeometryUpdate.StartSizeSpreads.xyz;
    // mad r2.xyz, r1, r2, c74
    temp2.xyz = temp1.xyz * temp2.xyz + GeometryUpdate.StartSizeMinimums.xyz;
    // mov r3.xyz, c77
    temp3.xyz = GeometryUpdate.SizeRateSpreads.xyz;
    // mad r3.xyz, r1, r3, c76
    temp3.xyz = temp1.xyz * temp3.xyz + GeometryUpdate.SizeRateMinimums.xyz;
    // mov r4.xyz, c79
    temp4.xyz = GeometryUpdate.SizeDampingSpreads.xyz;
    // mad r1.xyz, r1, r4, c78
    temp1.xyz = temp1.xyz * temp4.xyz + GeometryUpdate.SizeDampingMinimums.xyz;
    // add r4.xyz, r1, -c27.x
    temp4.xyz = temp1.xyz + float3(-1, -1, -1);
    // sge r4.xyz, -r4_abs, r4_abs
    temp4.xyz = (r4.xyz == 0) ? 1 : 0;
    // lrp r5.xyz, r4, c28.w, r1
    temp5.xyz = lerp(temp1.xyz, float3(1.0001, 1.0001, 1.0001), temp4.xyz);
    // log r1.x, r5.x
    temp1.x = log2(temp5.x);
    // log r1.y, r5.y
    temp1.y = log2(temp5.y);
    // log r1.z, r5.z
    temp1.z = log2(temp5.z);
    // mul r4.xyz, r0.x, r1
    temp4.xyz = temp0.xxx * temp1.xyz;
    // exp r5.x, r4.x
    temp5.x = exp2(temp4.x);
    // exp r5.y, r4.y
    temp5.y = exp2(temp4.y);
    // exp r5.z, r4.z
    temp5.z = exp2(temp4.z);
    // add r4.xyz, r5, -c27.x
    temp4.xyz = temp5.xyz + float3(-1, -1, -1);
    // mul r1.xyz, r1, c29.w
    temp1.xyz = temp1.xyz * float3(0.6931472, 0.6931472, 0.6931472);
    // rcp r5.x, r1.x
    temp5.x = 1.0f / temp1.x;
    // rcp r5.y, r1.y
    temp5.y = 1.0f / temp1.y;
    // rcp r5.z, r1.z
    temp5.z = 1.0f / temp1.z;
    // mul r1.xyz, r4, r5
    temp1.xyz = temp4.xyz * temp5.xyz;
    // mad r1.xyz, r3, r1, r2
    temp1.xyz = temp3.xyz * temp1.xyz + temp2.xyz;
    // frc r1.w, v2.y
    temp1.w = frac(i.texcoord1.y);
    // add r1.w, -r1.w, v2.y
    temp1.w = -temp1.w + i.texcoord1.y;
    // mova a0.x, r1.w
    addr0.x = temp1.w;
    // mad r2.xyz, c27[a0.x], r1, r0.yzww
    temp2.xyz = float3(1, 0.5, 0) * temp1.xyz + temp0.yzw;
    // mul r0.y, r1.x, c30.w
    temp0.y = temp1.x * float1(0.6666667);
    // mov r2.w, c27.x
    temp2.w = float1(1);
    // dp4 r1.x, r2, c80
    temp1.x = dot(temp2, (WorldView._m00_m10_m20_m30));
    // dp4 r1.y, r2, c81
    temp1.y = dot(temp2, (WorldView._m01_m11_m21_m31));
    // dp4 r1.z, r2, c82
    temp1.z = dot(temp2, (WorldView._m02_m12_m22_m32));
    // dp4 r1.w, r2, c83
    temp1.w = dot(temp2, (WorldView._m03_m13_m23_m33));
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul o7.x, r1.z, r0.y
    o.texcoord5.x = temp1.z * temp0.y;
    // dp4 r2.x, r1, c84
    temp2.x = dot(temp1, (Projection._m00_m10_m20_m30));
    // dp4 r2.y, r1, c85
    temp2.y = dot(temp1, (Projection._m01_m11_m21_m31));
    // dp4 r2.z, r1, c86
    temp2.z = dot(temp1, (Projection._m02_m12_m22_m32));
    // dp4 r2.w, r1, c87
    temp2.w = dot(temp1, (Projection._m03_m13_m23_m33));
    // rcp r0.z, r2.w
    temp0.z = 1.0f / temp2.w;
    // mul o4.x, r2.z, r0.z
    o.texcoord2 = temp2.z * temp0.z;
    // mul r0.z, r0.x, c72.x
    temp0.z = temp0.x * Draw.SpeedMultiplier.x;
    // min r1.y, r0.z, c45.x
    temp1.y = min(temp0.z, expr45.x);
    // mov r3.x, c27.x
    temp3.x = float1(1);
    // mad r0.w, r0.x, c72.x, r3.x
    temp0.w = temp0.x * Draw.SpeedMultiplier.x + temp3.x;
    // min r1.x, r0.w, c45.x
    temp1.x = min(temp0.w, expr45.x);
    // if b0
    if (Error ConstBool0Error) {
        // frc r3.xy, r1.yxzw
        temp3.xy = frac(temp1.yx);
        // add r4.xz, r1.yyxw, -r3.xyyw
        temp4.xz = temp1.yx + -temp3.xy;
        // mov r4.y, c51.x
        temp4.y = expr51.x;
        // add r3.yz, r4.xxyw, c34[a0.x].xxww
        temp3.yz = temp4.xy + float2(0, 0);
        // mul o1.xy, r3.yzzw, c52.x
        o.texcoord = temp3.yzzw * expr52.x;
        // mov r4.w, c54.x
        temp4.w = expr54.x;
        // add r3.yz, r4.xzww, c34[a0.x].xxww
        temp3.yz = temp4.zw + float2(0, 0);
        // mul o5.xy, r3.yzzw, c52.x
        o.texcoord3.xy = temp3.yz * expr52.xx;
        // mov o5.z, r3.x
        o.texcoord3.z = temp3.x;
        // else
    } else {
        // mad r3.x, v2.x, c36.y, c36.z
        temp3.x = i.texcoord1.x * float1(0.1875) + float1(1.375);
        // frc r3.x, r3.x
        temp3.x = frac(temp3.x);
        // mul r3.x, r3.x, c27.w
        temp3.x = temp3.x * float1(16);
        // frc r3.y, r3.x
        temp3.y = frac(temp3.x);
        // add r3.x, r3.x, -r3.y
        temp3.x = temp3.x + -temp3.y;
        // mova a0.y, r3.x
        addr0.y = temp3.x;
        // mov r3.x, c63.x
        temp3.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
        // mul r3.y, r3.x, c11[a0.y].x
        temp3.y = temp3.x * float1(0.957897);
        // frc r3.z, r3.y
        temp3.z = frac(temp3.y);
        // add r3.w, r3.y, -r3.z
        temp3.w = temp3.y + -temp3.z;
        // slt r3.y, r3.y, -r3.y
        temp3.y = (temp3.y < -temp3.y) ? 1 : 0;
        // slt r3.z, -r3.z, r3.z
        temp3.z = (-temp3.z < temp3.z) ? 1 : 0;
        // mad r1.w, r3.y, r3.z, r3.w
        temp1.w = temp3.y * temp3.z + temp3.w;
        // if b1
        if (Error ConstBool1Error) {
            // mad r3.y, v2.x, c37.y, c37.z
            temp3.y = i.texcoord1.x * float1(0.1875) + float1(4.8125);
            // frc r3.y, r3.y
            temp3.y = frac(temp3.y);
            // mul r3.y, r3.y, c27.w
            temp3.y = temp3.y * float1(16);
            // frc r3.z, r3.y
            temp3.z = frac(temp3.y);
            // add r3.y, r3.y, -r3.z
            temp3.y = temp3.y + -temp3.z;
            // mova a0.y, r3.y
            addr0.y = temp3.y;
            // mul r3.x, r3.x, c11[a0.y].x
            temp3.x = temp3.x * float1(0.957897);
            // frc r3.y, r3.x
            temp3.y = frac(temp3.x);
            // add r3.z, r3.x, -r3.y
            temp3.z = temp3.x + -temp3.y;
            // slt r3.x, r3.x, -r3.x
            temp3.x = (temp3.x < -temp3.x) ? 1 : 0;
            // slt r3.y, -r3.y, r3.y
            temp3.y = (-temp3.y < temp3.y) ? 1 : 0;
            // mad r1.z, r3.x, r3.y, r3.z
            temp1.z = temp3.x * temp3.y + temp3.z;
            // add r3.xy, r1.zwzw, c34[a0.x].xwzw
            temp3.xy = temp1.zw + float2(0, 0);
            // mul r3.xy, r3, c56.x
            temp3.xy = temp3.xy * expr56.xx;
            // mov o5.z, c27.z
            o.texcoord3.z = float1(0);
            // mov o5.xy, r3
            o.texcoord3.xy = temp3.xy;
            // mov o1.xy, r3
            o.texcoord = temp3;
            // else
        } else {
            // if b2
            if (Error ConstBool2Error) {
                // frc r3.z, r1.y
                temp3.z = frac(temp1.y);
                // mov r3.w, c27.z
                temp3.w = float1(0);
                // add r1.yz, r1.xyww, -r3.xzww
                temp1.yz = temp1.yw + -temp3.zw;
                // add r1.yz, r1, c34[a0.x].xxww
                temp1.yz = temp1.yz + float2(0, 0);
                // mul o1.xy, r1.yzzw, c60.x
                o.texcoord = temp1.yzzw * expr60.x;
                // frc r1.y, r1.x
                temp1.y = frac(temp1.x);
                // mov r1.z, c27.z
                temp1.z = float1(0);
                // add r1.xy, r1.xwzw, -r1.yzzw
                temp1.xy = temp1.xw + -temp1.yz;
                // add r1.xy, r1, c34[a0.x].xwzw
                temp1.xy = temp1.xy + float2(0, 0);
                // mul r3.xy, r1, c60.x
                temp3.xy = temp1.xy * expr60.xx;
                // mov o5.xyz, r3
                o.texcoord3 = temp3;
                // else
            } else {
                // mul r1.x, r0.z, c61.x
                temp1.x = temp0.z * expr61.x;
                // frc r1.y, r1_abs.x
                temp1.y = frac(abs(temp1).x);
                // sge r1.x, r1.x, -r1.x
                temp1.x = (temp1.x >= -temp1.x) ? 1 : 0;
                // lrp r3.x, r1.x, r1.y, -r1.y
                temp3.x = lerp(-temp1.y, temp1.y, temp1.x);
                // mul r1.x, r3.x, c63.y
                temp1.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r1.y, r1.x, c62.x
                temp1.y = temp1.x * expr62.x;
                // frc r1.z, r1_abs.y
                temp1.z = frac(abs(temp1).y);
                // sge r1.w, r1.y, -r1.y
                temp1.w = (temp1.y >= -temp1.y) ? 1 : 0;
                // lrp r3.x, r1.w, r1.z, -r1.z
                temp3.x = lerp(-temp1.z, temp1.z, temp1.w);
                // mul r1.x, r3.x, c63.x
                temp1.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r1.zw, r1.xyxy
                temp1.zw = frac(temp1.xy);
                // add r1.xy, r1, -r1.zwzw
                temp1.xy = temp1.xy + -temp1.zw;
                // add r1.xy, r1, c34[a0.x].xwzw
                temp1.xy = temp1.xy + float2(0, 0);
                // mul o1.xy, r1, c62.x
                o.texcoord = temp1 * expr62.x;
                // mul r0.w, r0.w, c61.x
                temp0.w = temp0.w * expr61.x;
                // frc r1.x, r0_abs.w
                temp1.x = frac(abs(temp0).w);
                // sge r0.w, r0.w, -r0.w
                temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
                // lrp r3.x, r0.w, r1.x, -r1.x
                temp3.x = lerp(-temp1.x, temp1.x, temp0.w);
                // mul r0.w, r3.x, c63.y
                temp0.w = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r1.y, r0.w, c62.x
                temp1.y = temp0.w * expr62.x;
                // frc r0.w, r1_abs.y
                temp0.w = frac(abs(temp1).y);
                // sge r1.z, r1.y, -r1.y
                temp1.z = (temp1.y >= -temp1.y) ? 1 : 0;
                // lrp r3.x, r1.z, r0.w, -r0.w
                temp3.x = lerp(-temp0.w, temp0.w, temp1.z);
                // mul r1.x, r3.x, c63.x
                temp1.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r1.zw, r1.xyxy
                temp1.zw = frac(temp1.xy);
                // add r1.xy, r1, -r1.zwzw
                temp1.xy = temp1.xy + -temp1.zw;
                // add r1.xy, r1, c34[a0.x].xwzw
                temp1.xy = temp1.xy + float2(0, 0);
                // mul o5.xy, r1, c62.x
                o.texcoord3.xy = temp1.xy * expr62.xx;
                // frc o5.z, r0.z
                o.texcoord3.z = frac(temp0.z);
                // endif
            }
            // endif
        }
        // endif
    }
    // rcp r0.z, v0.w
    temp0.z = 1.0f / i.position.w;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // mov r1, c64
    temp1 = Draw.ColorAnimationFunctions[0];
    // mad r1, r1, r0.x, c65
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[1];
    // slt r0.zw, r0.x, c70.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c66
    temp3 = Draw.ColorAnimationFunctions[2];
    // mad r3, r3, r0.x, c67
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r4, c68
    temp4 = Draw.ColorAnimationFunctions[4];
    // mad r4, r4, r0.x, c69
    temp4 = temp4 * temp0.x + Draw.ColorAnimationFunctions[5];
    // lrp r5, r0.w, r3, r4
    temp5 = lerp(temp4, temp3, temp0.w);
    // lrp r3, r0.z, r1, r5
    temp3 = lerp(temp5, temp1, temp0.z);
    // mov r1.xy, c73
    temp1.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.z].x, r1.y, r1.x
    temp0.x = float1(0.957897) * temp1.y + temp1.x;
    // mul o2, r3, r0.x
    o.color = temp3 * temp0.x;
    // mov o0, r2
    o.position = temp2;
    // mov o3.xyz, c27.x
    o.texcoord1 = float4(1, 1, 1, 1);
    // mov o6, r2
    o.texcoord4 = temp2;
    // mov o7.y, r0.y
    o.texcoord5.y = temp0.y;
    // 

    return o;
}

// VS_Array_H_Shader_1 Vertex_3_0 Has PRES True
struct VS_Array_H_Shader_1_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct VS_Array_H_Shader_1_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

VS_Array_H_Shader_1_Output VS_Array_H_Shader_1(VS_Array_H_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 44
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 19
      Unknown3: 3
      Unknown4: 0
      Unknown5: 44
      Unknown6: 2
      Mappings: 5
        0 - ConstOutput: 51 ConstInput 2
        1 - ConstOutput: 54 ConstInput 1
        2 - ConstOutput: 56 ConstInput 1
        3 - ConstOutput: 60 ConstInput 3
        4 - ConstOutput: 1 ConstInput 0
    
    */
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    float4 expr57;
    float4 expr58;
    float4 expr59;
    float4 expr60;
    float4 expr61;
    float4 expr62;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c44.x, c1.x, (30)
        expr44.x = Time.x * (30);
        // add c45.x, c0.x, (-1)
        expr45.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // neg r0.y, c0.w
        temp0.y = -Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // max r1.x, r0.y, c0.w
        temp1.x = max(temp0.y, Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w);
        // neg r0.y, r1.x
        temp0.y = -temp1.x;
        // ge r2.x, r0.y, r1.x
        temp2.x = temp0.y >= temp1.x;
        // lt unknown1.x, r0.y, r1.x
        unknown1.x = temp0.y < temp1.x;
        // mul unknown0.x, r0.x, r2.x
        unknown0.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // max r2.x, r0.x, r1.x
        temp2.x = max(temp0.x, temp1.x);
        // neg r0.x, r2.x
        temp0.x = -temp2.x;
        // ge unknown2.x, r0.x, r2.x
        unknown2.x = temp0.x >= temp2.x;
        // rcp c61.x, c0.y
        expr61.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c51.x, r1.x
        expr51.x = temp1.x;
        // mov c54.x, r1.x
        expr54.x = temp1.x;
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // mov c52.x, r0.x
        expr52.x = temp0.x;
        // mov c56.x, r0.x
        expr56.x = temp0.x;
        // mov c60.x, r0.x
        expr60.x = temp0.x;
        // mov c62.x, r0.x
        expr62.x = temp0.x;
    }

    VS_Array_H_Shader_1_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5, temp7, temp9;
    float3 addr0, temp6, temp8, temp10;
    // def c43, 0.1875, 8.9375, 2.0625, 2.75
    // def c27, 1, 0.5, 0, 16
    // def c30, 0, 0.5, 0, 0.1591549
    // def c36, 1, 6.283185, -3.141593, 1
    // def c31, 1, 0, 0.5, 0.001
    // def c32, 1, 0, -0.5, 0.6666667
    // def c37, 1, 0.1875, 1.375, 0
    // def c38, 0, 0.1875, 4.8125, 0
    // def c28, 1, -0.5, 0, 1.0001
    // def c29, 0, -0.5, 0, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c33, 0, 0, -0.5, 0
    // def c34, 0, 0, 0.5, 0
    // def c35, 0, 0, 0, 1
    // def c39, 0, 0, 0, 1
    // def c40, 1, 0, 0, 1
    // def c41, 1, 0, 0, 0
    // def c42, 0, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // dcl_position o0
    // dcl_texcoord o1.xy
    // dcl_color o2
    // dcl_texcoord1 o3.xyz
    // dcl_texcoord2 o4.x
    // dcl_texcoord3 o5.xyz
    // dcl_texcoord4 o6
    // dcl_texcoord5 o7.xy
    // add r0.x, c44.x, -v1.w
    temp0.x = expr44.x + -i.texcoord.w;
    // mad r0.yzw, v2.x, c43.x, c43
    temp0.yzw = i.texcoord1.xxx * float3(0.1875, 0.1875, 0.1875) + float3(8.9375, 2.0625, 2.75);
    // frc r0.yzw, r0
    temp0.yzw = frac(temp0.yzw);
    // mul r0.yzw, r0, c27.w
    temp0.yzw = temp0.yzw * float3(16, 16, 16);
    // frc r1.xyz, r0.yzww
    temp1.xyz = frac(temp0.yzw);
    // add r0.yzw, r0, -r1.xxyz
    temp0.yzw = temp0.yzw + -temp1.xyz;
    // mova a0.xyz, r0.yzww
    addr0.xyz = temp0.yzw;
    // mov r1.xy, c130
    temp1.xy = Physics.VelocityDampingRange.xy;
    // mad r0.y, c11[a0.x].x, r1.y, r1.x
    temp0.y = float1(0.957897) * temp1.y + temp1.x;
    // add r0.z, r0.y, -c27.x
    temp0.z = temp0.y + float1(-1);
    // sge r0.z, -r0_abs.z, r0_abs.z
    temp0.z = (r0.z == 0) ? 1 : 0;
    // lrp r1.x, r0.z, c28.w, r0.y
    temp1.x = lerp(temp0.y, float1(1.0001), temp0.z);
    // log r0.y, r1.x
    temp0.y = log2(temp1.x);
    // mul r0.z, r0.x, r0.y
    temp0.z = temp0.x * temp0.y;
    // exp r0.z, r0.z
    temp0.z = exp2(temp0.z);
    // add r0.z, r0.z, -c27.x
    temp0.z = temp0.z + float1(-1);
    // mul r0.y, r0.y, c29.w
    temp0.y = temp0.y * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul r0.y, r0.z, r0.y
    temp0.y = temp0.z * temp0.y;
    // mul r0.z, r0.x, c27.y
    temp0.z = temp0.x * float1(0.5);
    // mov r1.xyz, c128
    temp1.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r0.z, r1, c129
    temp1.xyz = temp0.zzz * temp1.xyz + Physics.DriftVelocity.xyz;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mad r0.yzw, v1.xxyz, r0.y, r1.xxyz
    temp0.yzw = i.texcoord.xyz * temp0.yyy + temp1.xyz;
    // add r1.xyz, r0.yzww, v0
    temp1.xyz = temp0.yzw + i.position.xyz;
    // mov r2.xyz, c11[a0.y]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c75
    temp3.xyz = GeometryUpdate.StartSizeSpreads.xyz;
    // mad r3.xyz, r2, r3, c74
    temp3.xyz = temp2.xyz * temp3.xyz + GeometryUpdate.StartSizeMinimums.xyz;
    // mov r4.xyz, c77
    temp4.xyz = GeometryUpdate.SizeRateSpreads.xyz;
    // mad r4.xyz, r2, r4, c76
    temp4.xyz = temp2.xyz * temp4.xyz + GeometryUpdate.SizeRateMinimums.xyz;
    // mov r5.xyz, c79
    temp5.xyz = GeometryUpdate.SizeDampingSpreads.xyz;
    // mad r5.xyz, r2, r5, c78
    temp5.xyz = temp2.xyz * temp5.xyz + GeometryUpdate.SizeDampingMinimums.xyz;
    // add r6.xyz, r5, -c27.x
    temp6.xyz = temp5.xyz + float3(-1, -1, -1);
    // sge r6.xyz, -r6_abs, r6_abs
    temp6.xyz = (r6.xyz == 0) ? 1 : 0;
    // lrp r7.xyz, r6, c28.w, r5
    temp7.xyz = lerp(temp5.xyz, float3(1.0001, 1.0001, 1.0001), temp6.xyz);
    // log r5.x, r7.x
    temp5.x = log2(temp7.x);
    // log r5.y, r7.y
    temp5.y = log2(temp7.y);
    // log r5.z, r7.z
    temp5.z = log2(temp7.z);
    // mul r6.xyz, r0.x, r5
    temp6.xyz = temp0.xxx * temp5.xyz;
    // exp r7.x, r6.x
    temp7.x = exp2(temp6.x);
    // exp r7.y, r6.y
    temp7.y = exp2(temp6.y);
    // exp r7.z, r6.z
    temp7.z = exp2(temp6.z);
    // add r6.xyz, r7, -c27.x
    temp6.xyz = temp7.xyz + float3(-1, -1, -1);
    // mul r5.xyz, r5, c29.w
    temp5.xyz = temp5.xyz * float3(0.6931472, 0.6931472, 0.6931472);
    // rcp r7.x, r5.x
    temp7.x = 1.0f / temp5.x;
    // rcp r7.y, r5.y
    temp7.y = 1.0f / temp5.y;
    // rcp r7.z, r5.z
    temp7.z = 1.0f / temp5.z;
    // mul r5.xyz, r6, r7
    temp5.xyz = temp6.xyz * temp7.xyz;
    // mad r3.xyz, r4, r5, r3
    temp3.xyz = temp4.xyz * temp5.xyz + temp3.xyz;
    // frc r1.w, v2.y
    temp1.w = frac(i.texcoord1.y);
    // add r1.w, -r1.w, v2.y
    temp1.w = -temp1.w + i.texcoord1.y;
    // mova a0.x, r1.w
    addr0.x = temp1.w;
    // mul r3.yzw, r3.xxyz, c27[a0.x].xxyz
    temp3.yzw = temp3.xyz * float3(1, 0.5, 0);
    // mov r4.xyz, c81
    temp4.xyz = GeometryUpdate.AngleSpreads.xyz;
    // mad r4.xyz, r2, r4, c80
    temp4.xyz = temp2.xyz * temp4.xyz + GeometryUpdate.AngleMinimums.xyz;
    // mov r5.xyz, c83
    temp5.xyz = GeometryUpdate.AngularRateSpreads.xyz;
    // mad r2.yzw, r2.xxyz, r5.xxyz, c82.xxyz
    temp2.yzw = temp2.xyz * temp5.xyz + GeometryUpdate.AngularRateMinimums.xyz;
    // mad r1.w, r2.x, c84.y, c84.x
    temp1.w = temp2.x * GeometryUpdate.AngleDampingMin_AngleDampingSpread.y + GeometryUpdate.AngleDampingMin_AngleDampingSpread.x;
    // add r2.x, r1.w, -c27.x
    temp2.x = temp1.w + float1(-1);
    // sge r2.x, -r2_abs.x, r2_abs.x
    temp2.x = (r2.x == 0) ? 1 : 0;
    // lrp r4.w, r2.x, c28.w, r1.w
    temp4.w = lerp(temp1.w, float1(1.0001), temp2.x);
    // log r1.w, r4.w
    temp1.w = log2(temp4.w);
    // mul r2.x, r0.x, r1.w
    temp2.x = temp0.x * temp1.w;
    // exp r2.x, r2.x
    temp2.x = exp2(temp2.x);
    // add r2.x, r2.x, -c27.x
    temp2.x = temp2.x + float1(-1);
    // mul r1.w, r1.w, c29.w
    temp1.w = temp1.w * float1(0.6931472);
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // mul r1.w, r2.x, r1.w
    temp1.w = temp2.x * temp1.w;
    // mad r2.xyz, r2.yzww, r1.w, r4
    temp2.xyz = temp2.yzw * temp1.www + temp4.xyz;
    // mad r2.xyz, r2, c30.w, c30.y
    temp2.xyz = temp2.xyz * float3(0.15915494, 0.15915494, 0.15915494) + float3(0.5, 0.5, 0.5);
    // frc r2.xyz, r2
    temp2.xyz = frac(temp2.xyz);
    // mad r2.xyz, r2, c36.y, c36.z
    temp2.xyz = temp2.xyz * float3(6.2831855, 6.2831855, 6.2831855) + float3(-3.1415927, -3.1415927, -3.1415927);
    // sincos r4.xy, r2.x
    temp4.xy = float2(cos(temp2.x), sin(temp2.x));
    // sincos r5.xy, r2.y
    temp5.xy = float2(cos(temp2.y), sin(temp2.y));
    // sincos r6.xy, r2.z
    temp6.xy = float2(cos(temp2.z), sin(temp2.z));
    // mul r2, r4.yyxx, r6.xyxy
    temp2 = temp4.yyxx * temp6.xyxy;
    // mul r6.xy, r5.x, r6
    temp6.xy = temp5.xx * temp6.xy;
    // mov r6.z, -r5.y
    temp6.z = -temp5.y;
    // mad r7.xy, r5.y, r2.yzzw, r2.zyzw
    temp7.xy = temp5.yy * temp2.yz + temp2.zy;
    // mad r2.xy, r5.y, r2.xwzw, -r2.wxzw
    temp2.xy = temp5.yy * temp2.xw + -temp2.wx;
    // mul r4.xy, r4.yxzw, r5.x
    temp4.xy = temp4.yx * temp5.xx;
    // dp3 r1.w, r0.yzww, r0.yzww
    temp1.w = dot(temp0.yzw, temp0.yzw);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // slt r1.w, r1.w, c31.w
    temp1.w = (temp1.w < float1(0.001)) ? 1 : 0;
    // lrp r5.xyz, r1.w, v1, r0.yzww
    temp5.xyz = lerp(temp0.yzw, i.texcoord.xyz, temp1.www);
    // dp3 r0.y, r5, r5
    temp0.y = dot(temp5.xyz, temp5.xyz);
    // rsq r0.y, r0.y
    temp0.y = 1 / sqrt(temp0.y);
    // rcp r0.z, r0.y
    temp0.z = 1.0f / temp0.y;
    // mul r4.zw, r5.xyxy, r5.xyxy
    temp4.zw = temp5.xy * temp5.xy;
    // add r0.w, r4.w, r4.z
    temp0.w = temp4.w + temp4.z;
    // rsq r0.w, r0.w
    temp0.w = 1 / sqrt(temp0.w);
    // rcp r1.w, r0.w
    temp1.w = 1.0f / temp0.w;
    // slt r0.z, -r0.z, r0.z
    temp0.z = (-temp0.z < temp0.z) ? 1 : 0;
    // mul r4.z, r5.z, r0.y
    temp4.z = temp5.z * temp0.y;
    // mul r4.w, r0.y, r1.w
    temp4.w = temp0.y * temp1.w;
    // lrp r8.xz, r0.z, r4.zyww, c27.zyxw
    temp8.xz = lerp(float2(0, 1), temp4.zw, temp0.zz);
    // slt r0.y, -r1.w, r1.w
    temp0.y = (-temp1.w < temp1.w) ? 1 : 0;
    // mad r0.zw, r5.xyyx, r0.w, -c27.xyzx
    temp0.zw = temp5.yx * temp0.ww + float2(-0, -1);
    // mad r5.xy, r0.y, r0.zwzw, c27.zxzw
    temp5.xy = temp0.yy * temp0.zw + float2(0, 1);
    // mul r9.xy, r8.z, r5.yxzw
    temp9.xy = temp8.zz * temp5.yx;
    // mov r9.z, -r5.x
    temp9.z = -temp5.x;
    // mul r5.xw, -r8.x, r5.yyzx
    temp5.xw = -temp8.xx * temp5.yx;
    // mov r9.w, r5.x
    temp9.w = temp5.x;
    // dp3 r0.y, r6, r9.xzww
    temp0.y = dot(temp6.xyz, temp9.xzw);
    // mov r5.z, r9.y
    temp5.z = temp9.y;
    // dp3 r10.x, r6.yxzw, r5.yzww
    temp10.x = dot(temp6.yxz, temp5.yzw);
    // mov r8.y, c27.z
    temp8.y = float1(0);
    // dp3 r6.x, r6, r8
    temp6.x = dot(temp6.xyz, temp8.xyz);
    // mov r2.z, r7.x
    temp2.z = temp7.x;
    // mov r2.w, r4.x
    temp2.w = temp4.x;
    // dp3 r0.z, r2.xzww, r9.xzww
    temp0.z = dot(temp2.xzw, temp9.xzw);
    // dp3 r10.y, r2.zxww, r5.yzww
    temp10.y = dot(temp2.zxw, temp5.yzw);
    // dp3 r6.y, r2.xzww, r8
    temp6.y = dot(temp2.xzw, temp8.xyz);
    // mov r7.z, r2.y
    temp7.z = temp2.y;
    // mov r7.w, r4.y
    temp7.w = temp4.y;
    // dp3 r0.w, r7.yzww, r9.xzww
    temp0.w = dot(temp7.yzw, temp9.xzw);
    // dp3 r10.z, r7.zyww, r5.yzww
    temp10.z = dot(temp7.zyw, temp5.yzw);
    // dp3 r6.z, r7.yzww, r8
    temp6.z = dot(temp7.yzw, temp8.xyz);
    // dp3 r0.y, r3.yzww, r0.yzww
    temp0.y = dot(temp3.yzw, temp0.yzw);
    // dp3 r0.z, r3.yzww, r10
    temp0.z = dot(temp3.yzw, temp10.xyz);
    // dp3 r0.w, r3.yzww, r6
    temp0.w = dot(temp3.yzw, temp6.xyz);
    // add r1.xyz, r1, r0.yzww
    temp1.xyz = temp1.xyz + temp0.yzw;
    // mul r0.y, r3.x, c32.w
    temp0.y = temp3.x * float1(0.6666667);
    // mov r1.w, c27.x
    temp1.w = float1(1);
    // dp4 r2.x, r1, c85
    temp2.x = dot(temp1, (WorldView._m00_m10_m20_m30));
    // dp4 r2.y, r1, c86
    temp2.y = dot(temp1, (WorldView._m01_m11_m21_m31));
    // dp4 r2.z, r1, c87
    temp2.z = dot(temp1, (WorldView._m02_m12_m22_m32));
    // dp4 r2.w, r1, c88
    temp2.w = dot(temp1, (WorldView._m03_m13_m23_m33));
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul o7.x, r2.z, r0.y
    o.texcoord5.x = temp2.z * temp0.y;
    // dp4 r1.x, r2, c124
    temp1.x = dot(temp2, (Projection._m00_m10_m20_m30));
    // dp4 r1.y, r2, c125
    temp1.y = dot(temp2, (Projection._m01_m11_m21_m31));
    // dp4 r1.z, r2, c126
    temp1.z = dot(temp2, (Projection._m02_m12_m22_m32));
    // dp4 r1.w, r2, c127
    temp1.w = dot(temp2, (Projection._m03_m13_m23_m33));
    // rcp r0.z, r1.w
    temp0.z = 1.0f / temp1.w;
    // mul o4.x, r1.z, r0.z
    o.texcoord2 = temp1.z * temp0.z;
    // mul r0.z, r0.x, c72.x
    temp0.z = temp0.x * Draw.SpeedMultiplier.x;
    // min r2.y, r0.z, c45.x
    temp2.y = min(temp0.z, expr45.x);
    // mov r3.x, c27.x
    temp3.x = float1(1);
    // mad r0.w, r0.x, c72.x, r3.x
    temp0.w = temp0.x * Draw.SpeedMultiplier.x + temp3.x;
    // min r2.x, r0.w, c45.x
    temp2.x = min(temp0.w, expr45.x);
    // if b0
    if (Error ConstBool0Error) {
        // frc r3.xy, r2.yxzw
        temp3.xy = frac(temp2.yx);
        // add r4.xz, r2.yyxw, -r3.xyyw
        temp4.xz = temp2.yx + -temp3.xy;
        // mov r4.y, c51.x
        temp4.y = expr51.x;
        // add r3.yz, r4.xxyw, c34[a0.x].xxww
        temp3.yz = temp4.xy + float2(0, 0);
        // mul o1.xy, r3.yzzw, c52.x
        o.texcoord = temp3.yzzw * expr52.x;
        // mov r4.w, c54.x
        temp4.w = expr54.x;
        // add r3.yz, r4.xzww, c34[a0.x].xxww
        temp3.yz = temp4.zw + float2(0, 0);
        // mul o5.xy, r3.yzzw, c52.x
        o.texcoord3.xy = temp3.yz * expr52.xx;
        // mov o5.z, r3.x
        o.texcoord3.z = temp3.x;
        // else
    } else {
        // mad r3.x, v2.x, c37.y, c37.z
        temp3.x = i.texcoord1.x * float1(0.1875) + float1(1.375);
        // frc r3.x, r3.x
        temp3.x = frac(temp3.x);
        // mul r3.x, r3.x, c27.w
        temp3.x = temp3.x * float1(16);
        // frc r3.y, r3.x
        temp3.y = frac(temp3.x);
        // add r3.x, r3.x, -r3.y
        temp3.x = temp3.x + -temp3.y;
        // mova a0.y, r3.x
        addr0.y = temp3.x;
        // mov r3.x, c63.x
        temp3.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
        // mul r3.y, r3.x, c11[a0.y].x
        temp3.y = temp3.x * float1(0.957897);
        // frc r3.z, r3.y
        temp3.z = frac(temp3.y);
        // add r3.w, r3.y, -r3.z
        temp3.w = temp3.y + -temp3.z;
        // slt r3.y, r3.y, -r3.y
        temp3.y = (temp3.y < -temp3.y) ? 1 : 0;
        // slt r3.z, -r3.z, r3.z
        temp3.z = (-temp3.z < temp3.z) ? 1 : 0;
        // mad r2.w, r3.y, r3.z, r3.w
        temp2.w = temp3.y * temp3.z + temp3.w;
        // if b1
        if (Error ConstBool1Error) {
            // mad r3.y, v2.x, c38.y, c38.z
            temp3.y = i.texcoord1.x * float1(0.1875) + float1(4.8125);
            // frc r3.y, r3.y
            temp3.y = frac(temp3.y);
            // mul r3.y, r3.y, c27.w
            temp3.y = temp3.y * float1(16);
            // frc r3.z, r3.y
            temp3.z = frac(temp3.y);
            // add r3.y, r3.y, -r3.z
            temp3.y = temp3.y + -temp3.z;
            // mova a0.y, r3.y
            addr0.y = temp3.y;
            // mul r3.x, r3.x, c11[a0.y].x
            temp3.x = temp3.x * float1(0.957897);
            // frc r3.y, r3.x
            temp3.y = frac(temp3.x);
            // add r3.z, r3.x, -r3.y
            temp3.z = temp3.x + -temp3.y;
            // slt r3.x, r3.x, -r3.x
            temp3.x = (temp3.x < -temp3.x) ? 1 : 0;
            // slt r3.y, -r3.y, r3.y
            temp3.y = (-temp3.y < temp3.y) ? 1 : 0;
            // mad r2.z, r3.x, r3.y, r3.z
            temp2.z = temp3.x * temp3.y + temp3.z;
            // add r3.xy, r2.zwzw, c34[a0.x].xwzw
            temp3.xy = temp2.zw + float2(0, 0);
            // mul r3.xy, r3, c56.x
            temp3.xy = temp3.xy * expr56.xx;
            // mov o5.z, c27.z
            o.texcoord3.z = float1(0);
            // mov o5.xy, r3
            o.texcoord3.xy = temp3.xy;
            // mov o1.xy, r3
            o.texcoord = temp3;
            // else
        } else {
            // if b2
            if (Error ConstBool2Error) {
                // frc r3.z, r2.y
                temp3.z = frac(temp2.y);
                // mov r3.w, c27.z
                temp3.w = float1(0);
                // add r2.yz, r2.xyww, -r3.xzww
                temp2.yz = temp2.yw + -temp3.zw;
                // add r2.yz, r2, c34[a0.x].xxww
                temp2.yz = temp2.yz + float2(0, 0);
                // mul o1.xy, r2.yzzw, c60.x
                o.texcoord = temp2.yzzw * expr60.x;
                // frc r2.y, r2.x
                temp2.y = frac(temp2.x);
                // mov r2.z, c27.z
                temp2.z = float1(0);
                // add r2.xy, r2.xwzw, -r2.yzzw
                temp2.xy = temp2.xw + -temp2.yz;
                // add r2.xy, r2, c34[a0.x].xwzw
                temp2.xy = temp2.xy + float2(0, 0);
                // mul r3.xy, r2, c60.x
                temp3.xy = temp2.xy * expr60.xx;
                // mov o5.xyz, r3
                o.texcoord3 = temp3;
                // else
            } else {
                // mul r2.x, r0.z, c61.x
                temp2.x = temp0.z * expr61.x;
                // frc r2.y, r2_abs.x
                temp2.y = frac(abs(temp2).x);
                // sge r2.x, r2.x, -r2.x
                temp2.x = (temp2.x >= -temp2.x) ? 1 : 0;
                // lrp r3.x, r2.x, r2.y, -r2.y
                temp3.x = lerp(-temp2.y, temp2.y, temp2.x);
                // mul r2.x, r3.x, c63.y
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r2.y, r2.x, c62.x
                temp2.y = temp2.x * expr62.x;
                // frc r2.z, r2_abs.y
                temp2.z = frac(abs(temp2).y);
                // sge r2.w, r2.y, -r2.y
                temp2.w = (temp2.y >= -temp2.y) ? 1 : 0;
                // lrp r3.x, r2.w, r2.z, -r2.z
                temp3.x = lerp(-temp2.z, temp2.z, temp2.w);
                // mul r2.x, r3.x, c63.x
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r2.zw, r2.xyxy
                temp2.zw = frac(temp2.xy);
                // add r2.xy, r2, -r2.zwzw
                temp2.xy = temp2.xy + -temp2.zw;
                // add r2.xy, r2, c34[a0.x].xwzw
                temp2.xy = temp2.xy + float2(0, 0);
                // mul o1.xy, r2, c62.x
                o.texcoord = temp2 * expr62.x;
                // mul r0.w, r0.w, c61.x
                temp0.w = temp0.w * expr61.x;
                // frc r2.x, r0_abs.w
                temp2.x = frac(abs(temp0).w);
                // sge r0.w, r0.w, -r0.w
                temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
                // lrp r3.x, r0.w, r2.x, -r2.x
                temp3.x = lerp(-temp2.x, temp2.x, temp0.w);
                // mul r0.w, r3.x, c63.y
                temp0.w = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r2.y, r0.w, c62.x
                temp2.y = temp0.w * expr62.x;
                // frc r0.w, r2_abs.y
                temp0.w = frac(abs(temp2).y);
                // sge r2.z, r2.y, -r2.y
                temp2.z = (temp2.y >= -temp2.y) ? 1 : 0;
                // lrp r3.x, r2.z, r0.w, -r0.w
                temp3.x = lerp(-temp0.w, temp0.w, temp2.z);
                // mul r2.x, r3.x, c63.x
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r2.zw, r2.xyxy
                temp2.zw = frac(temp2.xy);
                // add r2.xy, r2, -r2.zwzw
                temp2.xy = temp2.xy + -temp2.zw;
                // add r2.xy, r2, c34[a0.x].xwzw
                temp2.xy = temp2.xy + float2(0, 0);
                // mul o5.xy, r2, c62.x
                o.texcoord3.xy = temp2.xy * expr62.xx;
                // frc o5.z, r0.z
                o.texcoord3.z = frac(temp0.z);
                // endif
            }
            // endif
        }
        // endif
    }
    // rcp r0.z, v0.w
    temp0.z = 1.0f / i.position.w;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // mov r2, c64
    temp2 = Draw.ColorAnimationFunctions[0];
    // mad r2, r2, r0.x, c65
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[1];
    // slt r0.zw, r0.x, c70.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c66
    temp3 = Draw.ColorAnimationFunctions[2];
    // mad r3, r3, r0.x, c67
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r4, c68
    temp4 = Draw.ColorAnimationFunctions[4];
    // mad r4, r4, r0.x, c69
    temp4 = temp4 * temp0.x + Draw.ColorAnimationFunctions[5];
    // lrp r5, r0.w, r3, r4
    temp5 = lerp(temp4, temp3, temp0.w);
    // lrp r3, r0.z, r2, r5
    temp3 = lerp(temp5, temp2, temp0.z);
    // mov r2.xy, c73
    temp2.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.z].x, r2.y, r2.x
    temp0.x = float1(0.957897) * temp2.y + temp2.x;
    // mul o2, r3, r0.x
    o.color = temp3 * temp0.x;
    // mov o0, r1
    o.position = temp1;
    // mov o3.xyz, c27.x
    o.texcoord1 = float4(1, 1, 1, 1);
    // mov o6, r1
    o.texcoord4 = temp1;
    // mov o7.y, r0.y
    o.texcoord5.y = temp0.y;
    // 

    return o;
}

// VS_Array_H_Shader_2 Vertex_3_0 Has PRES True
struct VS_Array_H_Shader_2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct VS_Array_H_Shader_2_Output
{
    float4 position : POSITION;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

VS_Array_H_Shader_2_Output VS_Array_H_Shader_2(VS_Array_H_Shader_2_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 44
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 19
      Unknown3: 3
      Unknown4: 0
      Unknown5: 44
      Unknown6: 2
      Mappings: 5
        0 - ConstOutput: 51 ConstInput 2
        1 - ConstOutput: 54 ConstInput 1
        2 - ConstOutput: 56 ConstInput 1
        3 - ConstOutput: 60 ConstInput 3
        4 - ConstOutput: 1 ConstInput 0
    
    */
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    float4 expr57;
    float4 expr58;
    float4 expr59;
    float4 expr60;
    float4 expr61;
    float4 expr62;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c44.x, c1.x, (30)
        expr44.x = Time.x * (30);
        // add c45.x, c0.x, (-1)
        expr45.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // neg r0.y, c0.w
        temp0.y = -Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // max r1.x, r0.y, c0.w
        temp1.x = max(temp0.y, Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w);
        // neg r0.y, r1.x
        temp0.y = -temp1.x;
        // ge r2.x, r0.y, r1.x
        temp2.x = temp0.y >= temp1.x;
        // lt unknown1.x, r0.y, r1.x
        unknown1.x = temp0.y < temp1.x;
        // mul unknown0.x, r0.x, r2.x
        unknown0.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // max r2.x, r0.x, r1.x
        temp2.x = max(temp0.x, temp1.x);
        // neg r0.x, r2.x
        temp0.x = -temp2.x;
        // ge unknown2.x, r0.x, r2.x
        unknown2.x = temp0.x >= temp2.x;
        // rcp c61.x, c0.y
        expr61.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c51.x, r1.x
        expr51.x = temp1.x;
        // mov c54.x, r1.x
        expr54.x = temp1.x;
        // rcp r0.x, c0.x
        temp0.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // mov c52.x, r0.x
        expr52.x = temp0.x;
        // mov c56.x, r0.x
        expr56.x = temp0.x;
        // mov c60.x, r0.x
        expr60.x = temp0.x;
        // mov c62.x, r0.x
        expr62.x = temp0.x;
    }

    VS_Array_H_Shader_2_Output o;
    float4 temp0, temp1, temp2, temp3, temp4, temp5, temp7;
    float3 addr0, temp6;
    // def c43, 0.1875, 8.9375, 2.0625, 2.75
    // def c27, 1, 0.5, 0, 16
    // def c36, 1, 6.283185, -3.141593, 1
    // def c30, 0, 0.5, 0, 0.1591549
    // def c31, 1, 0, 0.5, 0.6666667
    // def c37, 1, 0.1875, 1.375, 0
    // def c38, 0, 0.1875, 4.8125, 0
    // def c28, 1, -0.5, 0, 1.0001
    // def c29, 0, -0.5, 0, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, 1, 0, -0.5, 0
    // def c33, 0, 0, -0.5, 0
    // def c34, 0, 0, 0.5, 0
    // def c35, 0, 0, 0, 1
    // def c39, 0, 0, 0, 1
    // def c40, 1, 0, 0, 1
    // def c41, 1, 0, 0, 0
    // def c42, 0, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // dcl_position o0
    // dcl_texcoord o1.xy
    // dcl_color o2
    // dcl_texcoord1 o3.xyz
    // dcl_texcoord2 o4.x
    // dcl_texcoord3 o5.xyz
    // dcl_texcoord4 o6
    // dcl_texcoord5 o7.xy
    // add r0.x, c44.x, -v1.w
    temp0.x = expr44.x + -i.texcoord.w;
    // mad r0.yzw, v2.x, c43.x, c43
    temp0.yzw = i.texcoord1.xxx * float3(0.1875, 0.1875, 0.1875) + float3(8.9375, 2.0625, 2.75);
    // frc r0.yzw, r0
    temp0.yzw = frac(temp0.yzw);
    // mul r0.yzw, r0, c27.w
    temp0.yzw = temp0.yzw * float3(16, 16, 16);
    // frc r1.xyz, r0.yzww
    temp1.xyz = frac(temp0.yzw);
    // add r0.yzw, r0, -r1.xxyz
    temp0.yzw = temp0.yzw + -temp1.xyz;
    // mova a0.xyz, r0.yzww
    addr0.xyz = temp0.yzw;
    // mov r1.xy, c130
    temp1.xy = Physics.VelocityDampingRange.xy;
    // mad r0.y, c11[a0.x].x, r1.y, r1.x
    temp0.y = float1(0.957897) * temp1.y + temp1.x;
    // add r0.z, r0.y, -c27.x
    temp0.z = temp0.y + float1(-1);
    // sge r0.z, -r0_abs.z, r0_abs.z
    temp0.z = (r0.z == 0) ? 1 : 0;
    // lrp r1.x, r0.z, c28.w, r0.y
    temp1.x = lerp(temp0.y, float1(1.0001), temp0.z);
    // log r0.y, r1.x
    temp0.y = log2(temp1.x);
    // mul r0.z, r0.x, r0.y
    temp0.z = temp0.x * temp0.y;
    // exp r0.z, r0.z
    temp0.z = exp2(temp0.z);
    // add r0.z, r0.z, -c27.x
    temp0.z = temp0.z + float1(-1);
    // mul r0.y, r0.y, c29.w
    temp0.y = temp0.y * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul r0.y, r0.z, r0.y
    temp0.y = temp0.z * temp0.y;
    // mul r0.z, r0.x, c27.y
    temp0.z = temp0.x * float1(0.5);
    // mov r1.xyz, c128
    temp1.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r0.z, r1, c129
    temp1.xyz = temp0.zzz * temp1.xyz + Physics.DriftVelocity.xyz;
    // mul r1.xyz, r0.x, r1
    temp1.xyz = temp0.xxx * temp1.xyz;
    // mad r0.yzw, v1.xxyz, r0.y, r1.xxyz
    temp0.yzw = i.texcoord.xyz * temp0.yyy + temp1.xyz;
    // add r0.yzw, r0, v0.xxyz
    temp0.yzw = temp0.yzw + i.position.xyz;
    // mov r1.xyz, c11[a0.y]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c75
    temp2.xyz = GeometryUpdate.StartSizeSpreads.xyz;
    // mad r2.xyz, r1, r2, c74
    temp2.xyz = temp1.xyz * temp2.xyz + GeometryUpdate.StartSizeMinimums.xyz;
    // mov r3.xyz, c77
    temp3.xyz = GeometryUpdate.SizeRateSpreads.xyz;
    // mad r3.xyz, r1, r3, c76
    temp3.xyz = temp1.xyz * temp3.xyz + GeometryUpdate.SizeRateMinimums.xyz;
    // mov r4.xyz, c79
    temp4.xyz = GeometryUpdate.SizeDampingSpreads.xyz;
    // mad r4.xyz, r1, r4, c78
    temp4.xyz = temp1.xyz * temp4.xyz + GeometryUpdate.SizeDampingMinimums.xyz;
    // add r5.xyz, r4, -c27.x
    temp5.xyz = temp4.xyz + float3(-1, -1, -1);
    // sge r5.xyz, -r5_abs, r5_abs
    temp5.xyz = (r5.xyz == 0) ? 1 : 0;
    // lrp r6.xyz, r5, c28.w, r4
    temp6.xyz = lerp(temp4.xyz, float3(1.0001, 1.0001, 1.0001), temp5.xyz);
    // log r4.x, r6.x
    temp4.x = log2(temp6.x);
    // log r4.y, r6.y
    temp4.y = log2(temp6.y);
    // log r4.z, r6.z
    temp4.z = log2(temp6.z);
    // mul r5.xyz, r0.x, r4
    temp5.xyz = temp0.xxx * temp4.xyz;
    // exp r6.x, r5.x
    temp6.x = exp2(temp5.x);
    // exp r6.y, r5.y
    temp6.y = exp2(temp5.y);
    // exp r6.z, r5.z
    temp6.z = exp2(temp5.z);
    // add r5.xyz, r6, -c27.x
    temp5.xyz = temp6.xyz + float3(-1, -1, -1);
    // mul r4.xyz, r4, c29.w
    temp4.xyz = temp4.xyz * float3(0.6931472, 0.6931472, 0.6931472);
    // rcp r6.x, r4.x
    temp6.x = 1.0f / temp4.x;
    // rcp r6.y, r4.y
    temp6.y = 1.0f / temp4.y;
    // rcp r6.z, r4.z
    temp6.z = 1.0f / temp4.z;
    // mul r4.xyz, r5, r6
    temp4.xyz = temp5.xyz * temp6.xyz;
    // mad r2.xyz, r3, r4, r2
    temp2.xyz = temp3.xyz * temp4.xyz + temp2.xyz;
    // frc r1.w, v2.y
    temp1.w = frac(i.texcoord1.y);
    // add r1.w, -r1.w, v2.y
    temp1.w = -temp1.w + i.texcoord1.y;
    // mova a0.x, r1.w
    addr0.x = temp1.w;
    // mul r2.yzw, r2.xxyz, c27[a0.x].xxyz
    temp2.yzw = temp2.xyz * float3(1, 0.5, 0);
    // mov r3.xyz, c81
    temp3.xyz = GeometryUpdate.AngleSpreads.xyz;
    // mad r3.xyz, r1, r3, c80
    temp3.xyz = temp1.xyz * temp3.xyz + GeometryUpdate.AngleMinimums.xyz;
    // mov r4.xyz, c83
    temp4.xyz = GeometryUpdate.AngularRateSpreads.xyz;
    // mad r1.yzw, r1.xxyz, r4.xxyz, c82.xxyz
    temp1.yzw = temp1.xyz * temp4.xyz + GeometryUpdate.AngularRateMinimums.xyz;
    // mad r1.x, r1.x, c84.y, c84.x
    temp1.x = temp1.x * GeometryUpdate.AngleDampingMin_AngleDampingSpread.y + GeometryUpdate.AngleDampingMin_AngleDampingSpread.x;
    // add r3.w, r1.x, -c27.x
    temp3.w = temp1.x + float1(-1);
    // sge r3.w, -r3_abs.w, r3_abs.w
    temp3.w = (r3.w == 0) ? 1 : 0;
    // lrp r4.x, r3.w, c28.w, r1.x
    temp4.x = lerp(temp1.x, float1(1.0001), temp3.w);
    // log r1.x, r4.x
    temp1.x = log2(temp4.x);
    // mul r3.w, r0.x, r1.x
    temp3.w = temp0.x * temp1.x;
    // exp r3.w, r3.w
    temp3.w = exp2(temp3.w);
    // add r3.w, r3.w, -c27.x
    temp3.w = temp3.w + float1(-1);
    // mul r1.x, r1.x, c29.w
    temp1.x = temp1.x * float1(0.6931472);
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // mul r1.x, r3.w, r1.x
    temp1.x = temp3.w * temp1.x;
    // mad r1.xyz, r1.yzww, r1.x, r3
    temp1.xyz = temp1.yzw * temp1.xxx + temp3.xyz;
    // mad r1.xyz, r1, c30.w, c30.y
    temp1.xyz = temp1.xyz * float3(0.15915494, 0.15915494, 0.15915494) + float3(0.5, 0.5, 0.5);
    // frc r1.xyz, r1
    temp1.xyz = frac(temp1.xyz);
    // mad r1.xyz, r1, c36.y, c36.z
    temp1.xyz = temp1.xyz * float3(6.2831855, 6.2831855, 6.2831855) + float3(-3.1415927, -3.1415927, -3.1415927);
    // sincos r3.xy, r1.x
    temp3.xy = float2(cos(temp1.x), sin(temp1.x));
    // sincos r4.xy, r1.y
    temp4.xy = float2(cos(temp1.y), sin(temp1.y));
    // sincos r5.xy, r1.z
    temp5.xy = float2(cos(temp1.z), sin(temp1.z));
    // mul r1, r3.yyxx, r5.xyxy
    temp1 = temp3.yyxx * temp5.xyxy;
    // mul r5.xy, r4.x, r5
    temp5.xy = temp4.xx * temp5.xy;
    // mov r6.x, -r4.y
    temp6.x = -temp4.y;
    // mad r7.xy, r4.y, r1.yzzw, r1.zyzw
    temp7.xy = temp4.yy * temp1.yz + temp1.zy;
    // mad r1.xy, r4.y, r1.xwzw, -r1.wxzw
    temp1.xy = temp4.yy * temp1.xw + -temp1.wx;
    // mul r6.yz, r3.xyxw, r4.x
    temp6.yz = temp3.yx * temp4.xx;
    // mov r5.z, r1.x
    temp5.z = temp1.x;
    // mov r5.w, r7.y
    temp5.w = temp7.y;
    // dp3 r1.x, r2.yzww, r5.xzww
    temp1.x = dot(temp2.yzw, temp5.xzw);
    // mov r7.z, r5.y
    temp7.z = temp5.y;
    // mov r7.w, r1.y
    temp7.w = temp1.y;
    // dp3 r1.z, r2.zyww, r7.xzww
    temp1.z = dot(temp2.zyw, temp7.xzw);
    // dp3 r1.w, r2.yzww, r6
    temp1.w = dot(temp2.yzw, temp6.xyz);
    // add r1.xyz, r0.yzww, r1.xzww
    temp1.xyz = temp0.yzw + temp1.xzw;
    // mul r0.y, r2.x, c31.w
    temp0.y = temp2.x * float1(0.6666667);
    // mov r1.w, c27.x
    temp1.w = float1(1);
    // dp4 r2.x, r1, c85
    temp2.x = dot(temp1, (WorldView._m00_m10_m20_m30));
    // dp4 r2.y, r1, c86
    temp2.y = dot(temp1, (WorldView._m01_m11_m21_m31));
    // dp4 r2.z, r1, c87
    temp2.z = dot(temp1, (WorldView._m02_m12_m22_m32));
    // dp4 r2.w, r1, c88
    temp2.w = dot(temp1, (WorldView._m03_m13_m23_m33));
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // mul o7.x, r2.z, r0.y
    o.texcoord5.x = temp2.z * temp0.y;
    // dp4 r1.x, r2, c124
    temp1.x = dot(temp2, (Projection._m00_m10_m20_m30));
    // dp4 r1.y, r2, c125
    temp1.y = dot(temp2, (Projection._m01_m11_m21_m31));
    // dp4 r1.z, r2, c126
    temp1.z = dot(temp2, (Projection._m02_m12_m22_m32));
    // dp4 r1.w, r2, c127
    temp1.w = dot(temp2, (Projection._m03_m13_m23_m33));
    // rcp r0.z, r1.w
    temp0.z = 1.0f / temp1.w;
    // mul o4.x, r1.z, r0.z
    o.texcoord2 = temp1.z * temp0.z;
    // mul r0.z, r0.x, c72.x
    temp0.z = temp0.x * Draw.SpeedMultiplier.x;
    // min r2.y, r0.z, c45.x
    temp2.y = min(temp0.z, expr45.x);
    // mov r3.x, c27.x
    temp3.x = float1(1);
    // mad r0.w, r0.x, c72.x, r3.x
    temp0.w = temp0.x * Draw.SpeedMultiplier.x + temp3.x;
    // min r2.x, r0.w, c45.x
    temp2.x = min(temp0.w, expr45.x);
    // if b0
    if (Error ConstBool0Error) {
        // frc r3.xy, r2.yxzw
        temp3.xy = frac(temp2.yx);
        // add r4.xz, r2.yyxw, -r3.xyyw
        temp4.xz = temp2.yx + -temp3.xy;
        // mov r4.y, c51.x
        temp4.y = expr51.x;
        // add r3.yz, r4.xxyw, c34[a0.x].xxww
        temp3.yz = temp4.xy + float2(0, 0);
        // mul o1.xy, r3.yzzw, c52.x
        o.texcoord = temp3.yzzw * expr52.x;
        // mov r4.w, c54.x
        temp4.w = expr54.x;
        // add r3.yz, r4.xzww, c34[a0.x].xxww
        temp3.yz = temp4.zw + float2(0, 0);
        // mul o5.xy, r3.yzzw, c52.x
        o.texcoord3.xy = temp3.yz * expr52.xx;
        // mov o5.z, r3.x
        o.texcoord3.z = temp3.x;
        // else
    } else {
        // mad r3.x, v2.x, c37.y, c37.z
        temp3.x = i.texcoord1.x * float1(0.1875) + float1(1.375);
        // frc r3.x, r3.x
        temp3.x = frac(temp3.x);
        // mul r3.x, r3.x, c27.w
        temp3.x = temp3.x * float1(16);
        // frc r3.y, r3.x
        temp3.y = frac(temp3.x);
        // add r3.x, r3.x, -r3.y
        temp3.x = temp3.x + -temp3.y;
        // mova a0.y, r3.x
        addr0.y = temp3.x;
        // mov r3.x, c63.x
        temp3.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
        // mul r3.y, r3.x, c11[a0.y].x
        temp3.y = temp3.x * float1(0.957897);
        // frc r3.z, r3.y
        temp3.z = frac(temp3.y);
        // add r3.w, r3.y, -r3.z
        temp3.w = temp3.y + -temp3.z;
        // slt r3.y, r3.y, -r3.y
        temp3.y = (temp3.y < -temp3.y) ? 1 : 0;
        // slt r3.z, -r3.z, r3.z
        temp3.z = (-temp3.z < temp3.z) ? 1 : 0;
        // mad r2.w, r3.y, r3.z, r3.w
        temp2.w = temp3.y * temp3.z + temp3.w;
        // if b1
        if (Error ConstBool1Error) {
            // mad r3.y, v2.x, c38.y, c38.z
            temp3.y = i.texcoord1.x * float1(0.1875) + float1(4.8125);
            // frc r3.y, r3.y
            temp3.y = frac(temp3.y);
            // mul r3.y, r3.y, c27.w
            temp3.y = temp3.y * float1(16);
            // frc r3.z, r3.y
            temp3.z = frac(temp3.y);
            // add r3.y, r3.y, -r3.z
            temp3.y = temp3.y + -temp3.z;
            // mova a0.y, r3.y
            addr0.y = temp3.y;
            // mul r3.x, r3.x, c11[a0.y].x
            temp3.x = temp3.x * float1(0.957897);
            // frc r3.y, r3.x
            temp3.y = frac(temp3.x);
            // add r3.z, r3.x, -r3.y
            temp3.z = temp3.x + -temp3.y;
            // slt r3.x, r3.x, -r3.x
            temp3.x = (temp3.x < -temp3.x) ? 1 : 0;
            // slt r3.y, -r3.y, r3.y
            temp3.y = (-temp3.y < temp3.y) ? 1 : 0;
            // mad r2.z, r3.x, r3.y, r3.z
            temp2.z = temp3.x * temp3.y + temp3.z;
            // add r3.xy, r2.zwzw, c34[a0.x].xwzw
            temp3.xy = temp2.zw + float2(0, 0);
            // mul r3.xy, r3, c56.x
            temp3.xy = temp3.xy * expr56.xx;
            // mov o5.z, c27.z
            o.texcoord3.z = float1(0);
            // mov o5.xy, r3
            o.texcoord3.xy = temp3.xy;
            // mov o1.xy, r3
            o.texcoord = temp3;
            // else
        } else {
            // if b2
            if (Error ConstBool2Error) {
                // frc r3.z, r2.y
                temp3.z = frac(temp2.y);
                // mov r3.w, c27.z
                temp3.w = float1(0);
                // add r2.yz, r2.xyww, -r3.xzww
                temp2.yz = temp2.yw + -temp3.zw;
                // add r2.yz, r2, c34[a0.x].xxww
                temp2.yz = temp2.yz + float2(0, 0);
                // mul o1.xy, r2.yzzw, c60.x
                o.texcoord = temp2.yzzw * expr60.x;
                // frc r2.y, r2.x
                temp2.y = frac(temp2.x);
                // mov r2.z, c27.z
                temp2.z = float1(0);
                // add r2.xy, r2.xwzw, -r2.yzzw
                temp2.xy = temp2.xw + -temp2.yz;
                // add r2.xy, r2, c34[a0.x].xwzw
                temp2.xy = temp2.xy + float2(0, 0);
                // mul r3.xy, r2, c60.x
                temp3.xy = temp2.xy * expr60.xx;
                // mov o5.xyz, r3
                o.texcoord3 = temp3;
                // else
            } else {
                // mul r2.x, r0.z, c61.x
                temp2.x = temp0.z * expr61.x;
                // frc r2.y, r2_abs.x
                temp2.y = frac(abs(temp2).x);
                // sge r2.x, r2.x, -r2.x
                temp2.x = (temp2.x >= -temp2.x) ? 1 : 0;
                // lrp r3.x, r2.x, r2.y, -r2.y
                temp3.x = lerp(-temp2.y, temp2.y, temp2.x);
                // mul r2.x, r3.x, c63.y
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r2.y, r2.x, c62.x
                temp2.y = temp2.x * expr62.x;
                // frc r2.z, r2_abs.y
                temp2.z = frac(abs(temp2).y);
                // sge r2.w, r2.y, -r2.y
                temp2.w = (temp2.y >= -temp2.y) ? 1 : 0;
                // lrp r3.x, r2.w, r2.z, -r2.z
                temp3.x = lerp(-temp2.z, temp2.z, temp2.w);
                // mul r2.x, r3.x, c63.x
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r2.zw, r2.xyxy
                temp2.zw = frac(temp2.xy);
                // add r2.xy, r2, -r2.zwzw
                temp2.xy = temp2.xy + -temp2.zw;
                // add r2.xy, r2, c34[a0.x].xwzw
                temp2.xy = temp2.xy + float2(0, 0);
                // mul o1.xy, r2, c62.x
                o.texcoord = temp2 * expr62.x;
                // mul r0.w, r0.w, c61.x
                temp0.w = temp0.w * expr61.x;
                // frc r2.x, r0_abs.w
                temp2.x = frac(abs(temp0).w);
                // sge r0.w, r0.w, -r0.w
                temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
                // lrp r3.x, r0.w, r2.x, -r2.x
                temp3.x = lerp(-temp2.x, temp2.x, temp0.w);
                // mul r0.w, r3.x, c63.y
                temp0.w = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
                // mul r2.y, r0.w, c62.x
                temp2.y = temp0.w * expr62.x;
                // frc r0.w, r2_abs.y
                temp0.w = frac(abs(temp2).y);
                // sge r2.z, r2.y, -r2.y
                temp2.z = (temp2.y >= -temp2.y) ? 1 : 0;
                // lrp r3.x, r2.z, r0.w, -r0.w
                temp3.x = lerp(-temp0.w, temp0.w, temp2.z);
                // mul r2.x, r3.x, c63.x
                temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
                // frc r2.zw, r2.xyxy
                temp2.zw = frac(temp2.xy);
                // add r2.xy, r2, -r2.zwzw
                temp2.xy = temp2.xy + -temp2.zw;
                // add r2.xy, r2, c34[a0.x].xwzw
                temp2.xy = temp2.xy + float2(0, 0);
                // mul o5.xy, r2, c62.x
                o.texcoord3.xy = temp2.xy * expr62.xx;
                // frc o5.z, r0.z
                o.texcoord3.z = frac(temp0.z);
                // endif
            }
            // endif
        }
        // endif
    }
    // rcp r0.z, v0.w
    temp0.z = 1.0f / i.position.w;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // mov r2, c64
    temp2 = Draw.ColorAnimationFunctions[0];
    // mad r2, r2, r0.x, c65
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[1];
    // slt r0.zw, r0.x, c70.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c66
    temp3 = Draw.ColorAnimationFunctions[2];
    // mad r3, r3, r0.x, c67
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r4, c68
    temp4 = Draw.ColorAnimationFunctions[4];
    // mad r4, r4, r0.x, c69
    temp4 = temp4 * temp0.x + Draw.ColorAnimationFunctions[5];
    // lrp r5, r0.w, r3, r4
    temp5 = lerp(temp4, temp3, temp0.w);
    // lrp r3, r0.z, r2, r5
    temp3 = lerp(temp5, temp2, temp0.z);
    // mov r2.xy, c73
    temp2.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.z].x, r2.y, r2.x
    temp0.x = float1(0.957897) * temp2.y + temp2.x;
    // mul o2, r3, r0.x
    o.color = temp3 * temp0.x;
    // mov o0, r1
    o.position = temp1;
    // mov o3.xyz, c27.x
    o.texcoord1 = float4(1, 1, 1, 1);
    // mov o6, r1
    o.texcoord4 = temp1;
    // mov o7.y, r0.y
    o.texcoord5.y = temp0.y;
    // 

    return o;
}

VertexShader VS_Array_H[3] = {
    compile vs_3_0 VS_Array_H_Shader_0(), // 31
    compile vs_3_0 VS_Array_H_Shader_1(), // 32
    compile vs_3_0 VS_Array_H_Shader_2(), // 33
};
// PS_Array_H_Shader_0 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_0_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

float4 PS_Array_H_Shader_0(PS_Array_H_Shader_0_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 0, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord3 v2.xyz
    // dcl_texcoord4 v3.xyw
    // dcl_texcoord5 v4.xy
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // rcp r0.x, v3.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v3
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s2
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v4.y, v4.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v2, s1
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v2.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul oC0.xyz, r0.x, r1
    out_color.xyz = temp0.xxx * temp1.xyz;
    // mov oC0.w, r1.w
    out_color.w = temp1.w;
    // 

    return out_color;
}

// PS_Array_H_Shader_1 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

float4 PS_Array_H_Shader_1(PS_Array_H_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, -1, 1
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s2
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s1
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mad r0.xyz, r1, r0.x, c0.z
    temp0.xyz = temp1.xyz * temp0.xxx + float3(-1, -1, -1);
    // mov oC0.w, r1.w
    out_color.w = temp1.w;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mad oC0.xyz, r1, r0, c0.w
    out_color.xyz = temp1.xyz * temp0.xyz + float3(1, 1, 1);
    // 

    return out_color;
}

// PS_Array_H_Shader_2 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

float4 PS_Array_H_Shader_2(PS_Array_H_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 0, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s2
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s1
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul r0.xyz, r0.x, r1
    temp0.xyz = temp0.xxx * temp1.xyz;
    // mov oC0.w, r1.w
    out_color.w = temp1.w;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_3 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

float4 PS_Array_H_Shader_3(PS_Array_H_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 0, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord3 v2.xyz
    // dcl_texcoord4 v3.xyw
    // dcl_texcoord5 v4.xy
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // rcp r0.x, v3.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v3
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s2
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v4.y, v4.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v2, s1
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v2.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul oC0.w, r0.x, r1.w
    out_color.w = temp0.x * temp1.w;
    // mov oC0.xyz, r1
    out_color.xyz = temp1.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_4 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_4_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

float4 PS_Array_H_Shader_4(PS_Array_H_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, -1, 1
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s2
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s1
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r0.y, r3.w, v1.w
    temp0.y = temp3.w * i.color.w;
    // mad r1.xyz, r3, v1, c0.z
    temp1.xyz = temp3.xyz * i.color.xyz + float3(-1, -1, -1);
    // mul oC0.w, r0.x, r0.y
    out_color.w = temp0.x * temp0.y;
    // mov_sat r0.xyz, v2
    temp0.xyz = saturate(i.texcoord1.xyz);
    // mad oC0.xyz, r0, r1, c0.w
    out_color.xyz = temp0.xyz * temp1.xyz + float3(1, 1, 1);
    // 

    return out_color;
}

// PS_Array_H_Shader_5 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_5_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
    float4 texcoord4 : TEXCOORD4;
    float2 texcoord5 : TEXCOORD5;
};

float4 PS_Array_H_Shader_5(PS_Array_H_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2, temp3;
    // def c0, 0.5, -0.5, 0, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_texcoord4 v4.xyw
    // dcl_texcoord5 v5.xy
    // dcl_2d s0
    // dcl_2d s1
    // dcl_2d s2
    // rcp r0.x, v4.w
    temp0.x = 1.0f / i.texcoord4.w;
    // mul r0.xy, r0.x, v4
    temp0.xy = temp0.xx * i.texcoord4.xy;
    // mad r0.xy, r0, c0, c0.x
    temp0.xy = temp0.xy * float2(0.5, -0.5) + float2(0.5, 0.5);
    // texld r0, r0, s2
    temp0 = tex2D(DepthTextureSampler, temp0.xy);
    // mad_sat r0.x, r0.x, -v5.y, v5.x
    temp0.x = saturate(temp0.x * -i.texcoord5.y + i.texcoord5.x);
    // texld r1, v0, s0
    temp1 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r2, v3, s1
    temp2 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r3, v3.z, r2, r1
    temp3 = lerp(temp1, temp2, i.texcoord3.z);
    // mul r1, r3, v1
    temp1 = temp3 * i.color;
    // mul oC0.w, r0.x, r1.w
    out_color.w = temp0.x * temp1.w;
    // mov_sat r0.xyz, v2
    temp0.xyz = saturate(i.texcoord1.xyz);
    // mul oC0.xyz, r1, r0
    out_color.xyz = temp1.xyz * temp0.xyz;
    // 

    return out_color;
}

// PS_Array_H_Shader_6 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_6_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord3 : TEXCOORD3;
};

float4 PS_Array_H_Shader_6(PS_Array_H_Shader_6_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord3 v2.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r1, v2, s1
    temp1 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r2, v2.z, r1, r0
    temp2 = lerp(temp0, temp1, i.texcoord3.z);
    // mul oC0, r2, v1
    out_color = temp2 * i.color;
    // 

    return out_color;
}

// PS_Array_H_Shader_7 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_7_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
};

float4 PS_Array_H_Shader_7(PS_Array_H_Shader_7_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // def c0, -1, 1, 0, 0
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r1, v3, s1
    temp1 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r2, v3.z, r1, r0
    temp2 = lerp(temp0, temp1, i.texcoord3.z);
    // mad r0.xyz, r2, v1, c0.x
    temp0.xyz = temp2.xyz * i.color.xyz + float3(-1, -1, -1);
    // mul r0.w, r2.w, v1.w
    temp0.w = temp2.w * i.color.w;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mad oC0.xyz, r1, r0, c0.y
    out_color.xyz = temp1.xyz * temp0.xyz + float3(1, 1, 1);
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // 

    return out_color;
}

// PS_Array_H_Shader_8 Pixel_3_0 Has PRES False
struct PS_Array_H_Shader_8_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
    float3 texcoord3 : TEXCOORD3;
};

float4 PS_Array_H_Shader_8(PS_Array_H_Shader_8_Input i) : COLOR
{
    float4 out_color;
    float4 temp0, temp1, temp2;
    // dcl_texcoord v0.xy
    // dcl_color v1
    // dcl_texcoord1 v2.xyz
    // dcl_texcoord3 v3.xyz
    // dcl_2d s0
    // dcl_2d s1
    // texld r0, v0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // texld r1, v3, s1
    temp1 = tex2D(NextFrameTextureSamplerSampler, i.texcoord3.xy);
    // lrp r2, v3.z, r1, r0
    temp2 = lerp(temp0, temp1, i.texcoord3.z);
    // mul r0, r2, v1
    temp0 = temp2 * i.color;
    // mov_sat r1.xyz, v2
    temp1.xyz = saturate(i.texcoord1.xyz);
    // mul oC0.xyz, r0, r1
    out_color.xyz = temp0.xyz * temp1.xyz;
    // mov oC0.w, r0.w
    out_color.w = temp0.w;
    // 

    return out_color;
}

PixelShader PS_Array_H[9] = {
    compile ps_3_0 PS_Array_H_Shader_0(), // 34
    compile ps_3_0 PS_Array_H_Shader_1(), // 35
    compile ps_3_0 PS_Array_H_Shader_2(), // 36
    compile ps_3_0 PS_Array_H_Shader_3(), // 37
    compile ps_3_0 PS_Array_H_Shader_4(), // 38
    compile ps_3_0 PS_Array_H_Shader_5(), // 39
    compile ps_3_0 PS_Array_H_Shader_6(), // 40
    compile ps_3_0 PS_Array_H_Shader_7(), // 41
    compile ps_3_0 PS_Array_H_Shader_8(), // 42
};
// VS_Array_L_Shader_0 Vertex_2_0 Has PRES True
struct VS_Array_L_Shader_0_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct VS_Array_L_Shader_0_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

VS_Array_L_Shader_0_Output VS_Array_L_Shader_0(VS_Array_L_Shader_0_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 44
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 13
      Unknown3: 0
      Unknown4: 0
      Unknown5: 44
      Unknown6: 2
      Mappings: 3
        0 - ConstOutput: 50 ConstInput 2
        1 - ConstOutput: 53 ConstInput 4
        2 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c44.x, c1.x, (30)
        expr44.x = Time.x * (30);
        // add c45.x, c0.x, (-1)
        expr45.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c55.x, r1.x, r0.y
        expr55.x = temp1.x < temp0.y;
        // mul c56.x, r0.x, r2.x
        expr56.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add c50.x, r2.z, r0.x
        expr50.x = temp2.z + temp0.x;
        // rcp c51.x, c0.x
        expr51.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c54.x, r0.x, r1.x
        expr54.x = temp0.x >= temp1.x;
        // rcp c53.x, c0.y
        expr53.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
    }

    VS_Array_L_Shader_0_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4;
    // def c43, 8.9375, 2.0625, 1.375, 4.8125
    // def c28, 1, -0.5, 0, 16
    // def c36, 1, 0.1875, 2.75, 1
    // def c29, 0, -0.5, 0, 1.0001
    // def c27, 1, 0.5, 0, 0.1875
    // def c30, 0, 0.5, 0, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c31, 1, 0, 0.5, 0
    // def c32, 1, 0, -0.5, 0
    // def c33, 0, 0, -0.5, 0
    // def c34, 0, 0, 0.5, 0
    // def c35, 0, 0, 0, 1
    // def c37, 1, 0, 0, 0
    // def c38, 0, 0, 0, 0
    // def c39, 0, 0, 0, 1
    // def c40, 1, 0, 0, 1
    // def c41, 1, 0, 0, 0
    // def c42, 0, 0, 0, 0
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c43
    temp0 = i.texcoord1.x * temp0.w + float4(8.9375, 2.0625, 1.375, 4.8125);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.w
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xyz, c11[a0.y]
    temp0.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r1.xyz, c73
    temp1.xyz = GeometryUpdate.SizeDampingSpreads.xyz;
    // mad r1.xyz, r0, r1, c72
    temp1.xyz = temp0.xyz * temp1.xyz + GeometryUpdate.SizeDampingMinimums.xyz;
    // add r2.xyz, r1, -c27.x
    temp2.xyz = temp1.xyz + float3(-1, -1, -1);
    // mul r2.xyz, r2, r2
    temp2.xyz = temp2.xyz * temp2.xyz;
    // sge r2.xyz, -r2, r2
    temp2.xyz = (-temp2.xyz >= temp2.xyz) ? 1 : 0;
    // lrp r3.xyz, r2, c29.w, r1
    temp3.xyz = lerp(temp1.xyz, float3(1.0001, 1.0001, 1.0001), temp2.xyz);
    // log r1.x, r3.x
    temp1.x = log2(temp3.x);
    // log r1.y, r3.y
    temp1.y = log2(temp3.y);
    // log r1.z, r3.z
    temp1.z = log2(temp3.z);
    // mul r2.xyz, r1, c30.w
    temp2.xyz = temp1.xyz * float3(0.6931472, 0.6931472, 0.6931472);
    // rcp r3.x, r2.x
    temp3.x = 1.0f / temp2.x;
    // rcp r3.y, r2.y
    temp3.y = 1.0f / temp2.y;
    // rcp r3.z, r2.z
    temp3.z = 1.0f / temp2.z;
    // add r0.w, -v1.w, c44.x
    temp0.w = -i.texcoord.w + expr44.x;
    // mul r1.xyz, r1, r0.w
    temp1.xyz = temp1.xyz * temp0.www;
    // exp r2.x, r1.x
    temp2.x = exp2(temp1.x);
    // exp r2.y, r1.y
    temp2.y = exp2(temp1.y);
    // exp r2.z, r1.z
    temp2.z = exp2(temp1.z);
    // add r1.xyz, r2, -c27.x
    temp1.xyz = temp2.xyz + float3(-1, -1, -1);
    // mul r1.xyz, r3, r1
    temp1.xyz = temp3.xyz * temp1.xyz;
    // mov r2.xyz, c69
    temp2.xyz = GeometryUpdate.StartSizeSpreads.xyz;
    // mad r2.xyz, r0, r2, c68
    temp2.xyz = temp0.xyz * temp2.xyz + GeometryUpdate.StartSizeMinimums.xyz;
    // mov r3.xyz, c71
    temp3.xyz = GeometryUpdate.SizeRateSpreads.xyz;
    // mad r0.xyz, r0, r3, c70
    temp0.xyz = temp0.xyz * temp3.xyz + GeometryUpdate.SizeRateMinimums.xyz;
    // mad r0.xyz, r0, r1, r2
    temp0.xyz = temp0.xyz * temp1.xyz + temp2.xyz;
    // mov r1.xy, c80
    temp1.xy = Physics.VelocityDampingRange.xy;
    // mad r1.x, c11[a0.x].x, r1.y, r1.x
    temp1.x = float1(0.957897) * temp1.y + temp1.x;
    // add r1.y, r1.x, -c27.x
    temp1.y = temp1.x + float1(-1);
    // mul r1.y, r1.y, r1.y
    temp1.y = temp1.y * temp1.y;
    // sge r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y >= temp1.y) ? 1 : 0;
    // lrp r2.x, r1.y, c29.w, r1.x
    temp2.x = lerp(temp1.x, float1(1.0001), temp1.y);
    // log r1.x, r2.x
    temp1.x = log2(temp2.x);
    // mul r1.y, r1.x, c30.w
    temp1.y = temp1.x * float1(0.6931472);
    // mul r1.x, r0.w, r1.x
    temp1.x = temp0.w * temp1.x;
    // rcp r1.y, r1.y
    temp1.y = 1.0f / temp1.y;
    // exp r1.x, r1.x
    temp1.x = exp2(temp1.x);
    // add r1.x, r1.x, -c27.x
    temp1.x = temp1.x + float1(-1);
    // mul r1.x, r1.y, r1.x
    temp1.x = temp1.y * temp1.x;
    // mul r1.y, r0.w, c27.y
    temp1.y = temp0.w * float1(0.5);
    // mov r2.xyz, c78
    temp2.xyz = Physics.Gravity.xyz;
    // mad r1.yzw, r1.y, r2.xxyz, c79.xxyz
    temp1.yzw = temp1.yyy * temp2.xyz + Physics.DriftVelocity.xyz;
    // mul r1.yzw, r0.w, r1
    temp1.yzw = temp0.www * temp1.yzw;
    // mad r1.xyz, v1, r1.x, r1.yzww
    temp1.xyz = i.texcoord.xyz * temp1.xxx + temp1.yzw;
    // add r1.xyz, r1, v0
    temp1.xyz = temp1.xyz + i.position.xyz;
    // frc r1.w, v2.y
    temp1.w = frac(i.texcoord1.y);
    // add r1.w, -r1.w, v2.y
    temp1.w = -temp1.w + i.texcoord1.y;
    // mova a0.x, r1.w
    addr0.x = temp1.w;
    // mad r1.xyz, c27[a0.x], r0, r1
    temp1.xyz = float3(1, 0.5, 0) * temp0.xyz + temp1.xyz;
    // mov r1.w, c27.x
    temp1.w = float1(1);
    // dp4 oPos.x, r1, c74
    o.position.x = dot(temp1, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c75
    o.position.y = dot(temp1, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r1, c77
    temp0.y = dot(temp1, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r1, c76
    temp0.x = dot(temp1, (WorldViewProjection._m02_m12_m22_m32));
    // rcp r0.z, r0.y
    temp0.z = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT1.x, r0.x, r0.z
    o.texcoord1 = temp0.x * temp0.z;
    // mov r0.x, c57.x
    temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.y, r0.x, c11[a0.w].x
    temp0.y = temp0.x * float1(0.957897);
    // mul r0.x, r0.x, c11[a0.z].x
    temp0.x = temp0.x * float1(0.957897);
    // frc r0.z, r0.y
    temp0.z = frac(temp0.y);
    // add r1.x, r0.y, -r0.z
    temp1.x = temp0.y + -temp0.z;
    // slt r0.y, r0.y, -r0.y
    temp0.y = (temp0.y < -temp0.y) ? 1 : 0;
    // slt r0.z, -r0.z, r0.z
    temp0.z = (-temp0.z < temp0.z) ? 1 : 0;
    // mad r1.y, r0.y, r0.z, r1.x
    temp1.y = temp0.y * temp0.z + temp1.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r1.z, r0.x, r0.y, r0.z
    temp1.z = temp0.x * temp0.y + temp0.z;
    // add r0.xy, r1.yzzw, c34[a0.x].xwzw
    temp0.xy = temp1.yz + float2(0, 0);
    // mov r2.z, c27.z
    temp2.z = float1(0);
    // mul r0.z, r0.w, c66.x
    temp0.z = temp0.w * Draw.SpeedMultiplier.x;
    // min r1.x, r0.z, c45.x
    temp1.x = min(temp0.z, expr45.x);
    // mul r0.z, r0.z, c53.x
    temp0.z = temp0.z * expr53.x;
    // frc r2.xy, r1.x
    temp2.xy = frac(temp1.x);
    // add r1.xyz, r1.xxzw, -r2
    temp1.xyz = temp1.xxz + -temp2.xyz;
    // add r1.yz, r1, c34[a0.x].xxww
    temp1.yz = temp1.yz + float2(0, 0);
    // abs r2.x, r0.z
    temp2.x = abs(temp0.z);
    // sge r0.z, r0.z, -r0.z
    temp0.z = (temp0.z >= -temp0.z) ? 1 : 0;
    // frc r2.x, r2.x
    temp2.x = frac(temp2.x);
    // lrp r3.x, r0.z, r2.x, -r2.x
    temp3.x = lerp(-temp2.x, temp2.x, temp0.z);
    // mul r0.z, r3.x, c57.y
    temp0.z = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r2.y, r0.z, c51.x
    temp2.y = temp0.z * expr51.x;
    // abs r0.z, r2.y
    temp0.z = abs(temp2.y);
    // frc r0.z, r0.z
    temp0.z = frac(temp0.z);
    // sge r2.z, r2.y, -r2.y
    temp2.z = (temp2.y >= -temp2.y) ? 1 : 0;
    // lrp r3.x, r2.z, r0.z, -r0.z
    temp3.x = lerp(-temp0.z, temp0.z, temp2.z);
    // mul r2.x, r3.x, c57.x
    temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r2.xyxy
    temp2.zw = frac(temp2.xy);
    // add r2.xy, r2, -r2.zwzw
    temp2.xy = temp2.xy + -temp2.zw;
    // add r2.xy, r2, c34[a0.x].xwzw
    temp2.xy = temp2.xy + float2(0, 0);
    // mul r2.xy, r2, c51.x
    temp2.xy = temp2.xy * expr51.xx;
    // mad r1.yz, r1, c51.x, -r2.xxyw
    temp1.yz = temp1.yz * expr51.xx + -temp2.xy;
    // mad r1.yz, c54.x, r1, r2.xxyw
    temp1.yz = expr54.xx * temp1.yz + temp2.xy;
    // mad r0.xy, r0, c51.x, -r1.yzzw
    temp0.xy = temp0.xy * expr51.xx + -temp1.yz;
    // mad r0.xy, c55.x, r0, r1.yzzw
    temp0.xy = expr55.xx * temp0.xy + temp1.yz;
    // mov r1.w, c50.x
    temp1.w = expr50.x;
    // add r1.xy, r1.xwzw, c34[a0.x].xwzw
    temp1.xy = temp1.xw + float2(0, 0);
    // mad r1.xy, r1, c51.x, -r0
    temp1.xy = temp1.xy * expr51.xx + -temp0.xy;
    // mad oT0.xy, c56.x, r1, r0
    o.texcoord = expr56.x * temp1 + temp0;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.w, r0.x
    temp0.x = temp0.w * temp0.x;
    // mov r1, c60
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c61
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c62
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c63
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c64
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c58
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c59
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.z, r1, r2
    temp4 = lerp(temp2, temp1, temp0.z);
    // lrp r1, r0.y, r3, r4
    temp1 = lerp(temp4, temp3, temp0.y);
    // mad r0.x, v2.x, c36.y, c36.z
    temp0.x = i.texcoord1.x * float1(0.1875) + float1(2.75);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mul r0.x, r0.x, c28.w
    temp0.x = temp0.x * float1(16);
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.x, r0.x, -r0.y
    temp0.x = temp0.x + -temp0.y;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mov r0.xy, c67
    temp0.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.x].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // mul oD0, r1, r0.x
    o.color = temp1 * temp0.x;
    // 

    return o;
}

// VS_Array_L_Shader_1 Vertex_2_0 Has PRES True
struct VS_Array_L_Shader_1_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct VS_Array_L_Shader_1_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

VS_Array_L_Shader_1_Output VS_Array_L_Shader_1(VS_Array_L_Shader_1_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 44
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 13
      Unknown3: 0
      Unknown4: 0
      Unknown5: 44
      Unknown6: 2
      Mappings: 3
        0 - ConstOutput: 50 ConstInput 2
        1 - ConstOutput: 53 ConstInput 4
        2 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c44.x, c1.x, (30)
        expr44.x = Time.x * (30);
        // add c45.x, c0.x, (-1)
        expr45.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c55.x, r1.x, r0.y
        expr55.x = temp1.x < temp0.y;
        // mul c56.x, r0.x, r2.x
        expr56.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add c50.x, r2.z, r0.x
        expr50.x = temp2.z + temp0.x;
        // rcp c51.x, c0.x
        expr51.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c54.x, r0.x, r1.x
        expr54.x = temp0.x >= temp1.x;
        // rcp c53.x, c0.y
        expr53.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
    }

    VS_Array_L_Shader_1_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4, temp5, temp7, temp8;
    float3 temp6, temp9, temp10;
    // def c43, 8.9375, 2.0625, 1.375, 4.8125
    // def c28, 1, -0.5, 0, 16
    // def c36, 1, 6.283185, -3.141593, 1
    // def c31, 1, 0, 0.5, 0.1591549
    // def c32, 1, 0, -0.5, 0.001
    // def c37, 1, 0.1875, 2.75, 0
    // def c29, 0, -0.5, 0, 1.0001
    // def c27, 1, 0.5, 0, 0.1875
    // def c30, 0, 0.5, 0, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c33, 0, 0, -0.5, 0
    // def c34, 0, 0, 0.5, 0
    // def c35, 0, 0, 0, 1
    // def c38, 0, 0, 0, 0
    // def c39, 0, 0, 0, 1
    // def c40, 1, 0, 0, 1
    // def c41, 1, 0, 0, 0
    // def c42, 0, 0, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c43
    temp0 = i.texcoord1.x * temp0.w + float4(8.9375, 2.0625, 1.375, 4.8125);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.w
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xy, c85
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.x].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, -c27.x
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.w, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c30.w
    temp0.y = temp0.x * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, -v1.w, c44.x
    temp0.z = -i.texcoord.w + expr44.x;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, -c27.x
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mul r0.y, r0.z, c27.y
    temp0.y = temp0.z * float1(0.5);
    // mov r1.xyz, c83
    temp1.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r0.y, r1, c84
    temp1.xyz = temp0.yyy * temp1.xyz + Physics.DriftVelocity.xyz;
    // mul r1.xyz, r0.z, r1
    temp1.xyz = temp0.zzz * temp1.xyz;
    // mad r0.xyw, v1.xyzz, r0.x, r1.xyzz
    temp0.xyw = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // dp3 r1.x, r0.xyww, r0.xyww
    temp1.x = dot(temp0.xyw, temp0.xyw);
    // rsq r1.x, r1.x
    temp1.x = 1 / sqrt(temp1.x);
    // rcp r1.x, r1.x
    temp1.x = 1.0f / temp1.x;
    // slt r1.x, r1.x, c32.w
    temp1.x = (temp1.x < float1(0.001)) ? 1 : 0;
    // lrp r2.xyz, r1.x, v1, r0.xyww
    temp2.xyz = lerp(temp0.xyw, i.texcoord.xyz, temp1.xxx);
    // add r0.xyw, r0, v0.xyzz
    temp0.xyw = temp0.xyw + i.position.xyz;
    // mul r1.xy, r2, r2
    temp1.xy = temp2.xy * temp2.xy;
    // add r1.x, r1.y, r1.x
    temp1.x = temp1.y + temp1.x;
    // rsq r1.x, r1.x
    temp1.x = 1 / sqrt(temp1.x);
    // rcp r1.y, r1.x
    temp1.y = 1.0f / temp1.x;
    // mad r1.xz, r2.yyxw, r1.x, -c27.zyxw
    temp1.xz = temp2.yx * temp1.xx + float2(-0, -1);
    // dp3 r1.w, r2, r2
    temp1.w = dot(temp2.xyz, temp2.xyz);
    // rsq r1.w, r1.w
    temp1.w = 1 / sqrt(temp1.w);
    // mul r2.y, r1.y, r1.w
    temp2.y = temp1.y * temp1.w;
    // slt r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y < temp1.y) ? 1 : 0;
    // mul r2.x, r2.z, r1.w
    temp2.x = temp2.z * temp1.w;
    // rcp r1.w, r1.w
    temp1.w = 1.0f / temp1.w;
    // slt r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w < temp1.w) ? 1 : 0;
    // lrp r3.xz, r1.w, r2.xyyw, c27.zyxw
    temp3.xz = lerp(float2(0, 1), temp2.xy, temp1.ww);
    // mov r2.xyz, c11[a0.y]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mad r1.w, r2.x, c78.y, c78.x
    temp1.w = temp2.x * GeometryUpdate.AngleDampingMin_AngleDampingSpread.y + GeometryUpdate.AngleDampingMin_AngleDampingSpread.x;
    // add r2.w, r1.w, -c27.x
    temp2.w = temp1.w + float1(-1);
    // mul r2.w, r2.w, r2.w
    temp2.w = temp2.w * temp2.w;
    // sge r2.w, -r2.w, r2.w
    temp2.w = (-temp2.w >= temp2.w) ? 1 : 0;
    // lrp r3.w, r2.w, c29.w, r1.w
    temp3.w = lerp(temp1.w, float1(1.0001), temp2.w);
    // log r1.w, r3.w
    temp1.w = log2(temp3.w);
    // mul r2.w, r1.w, c30.w
    temp2.w = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.w, r2.w
    temp2.w = 1.0f / temp2.w;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, -c27.x
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.w, r1.w
    temp1.w = temp2.w * temp1.w;
    // mov r4.xyz, c75
    temp4.xyz = GeometryUpdate.AngleSpreads.xyz;
    // mad r4.xyz, r2, r4, c74
    temp4.xyz = temp2.xyz * temp4.xyz + GeometryUpdate.AngleMinimums.xyz;
    // mov r5.xyz, c77
    temp5.xyz = GeometryUpdate.AngularRateSpreads.xyz;
    // mad r5.xyz, r2, r5, c76
    temp5.xyz = temp2.xyz * temp5.xyz + GeometryUpdate.AngularRateMinimums.xyz;
    // mad r4.xyz, r5, r1.w, r4
    temp4.xyz = temp5.xyz * temp1.www + temp4.xyz;
    // mad r4.xyz, r4, c31.w, c31.z
    temp4.xyz = temp4.xyz * float3(0.15915494, 0.15915494, 0.15915494) + float3(0.5, 0.5, 0.5);
    // frc r4.xyz, r4
    temp4.xyz = frac(temp4.xyz);
    // mad r4.xyz, r4, c36.y, c36.z
    temp4.xyz = temp4.xyz * float3(6.2831855, 6.2831855, 6.2831855) + float3(-3.1415927, -3.1415927, -3.1415927);
    // sincos r5.xy, r4.z, c0, c1
    temp5.xy = float2(cos(temp4.z), sin(temp4.z));
    // sincos r6.xy, r4.y, c0, c1
    temp6.xy = float2(cos(temp4.y), sin(temp4.y));
    // sincos r7.xy, r4.x, c0, c1
    temp7.xy = float2(cos(temp4.x), sin(temp4.x));
    // mul r4.xy, r5, r6.x
    temp4.xy = temp5.xy * temp6.xx;
    // mul r5, r5.xyxy, r7.yyxx
    temp5 = temp5.xyxy * temp7.yyxx;
    // mul r6.xz, r6.x, r7.yyxw
    temp6.xz = temp6.xx * temp7.yx;
    // mov r4.z, -r6.y
    temp4.z = -temp6.y;
    // mov r3.y, c27.z
    temp3.y = float1(0);
    // dp3 r7.x, r4, r3
    temp7.x = dot(temp4.xyz, temp3.xyz);
    // mad r8.xy, r6.y, r5.xwzw, -r5.wxzw
    temp8.xy = temp6.yy * temp5.xw + -temp5.wx;
    // mad r5.xy, r6.y, r5.yzzw, r5.zyzw
    temp5.xy = temp6.yy * temp5.yz + temp5.zy;
    // mov r8.w, r6.x
    temp8.w = temp6.x;
    // mov r5.w, r6.z
    temp5.w = temp6.z;
    // mov r8.z, r5.x
    temp8.z = temp5.x;
    // dp3 r7.y, r8.xzww, r3
    temp7.y = dot(temp8.xzw, temp3.xyz);
    // mov r5.z, r8.y
    temp5.z = temp8.y;
    // dp3 r7.z, r5.yzww, r3
    temp7.z = dot(temp5.yzw, temp3.xyz);
    // mov r6.xyz, c73
    temp6.xyz = GeometryUpdate.SizeDampingSpreads.xyz;
    // mad r6.xyz, r2, r6, c72
    temp6.xyz = temp2.xyz * temp6.xyz + GeometryUpdate.SizeDampingMinimums.xyz;
    // add r9.xyz, r6, -c27.x
    temp9.xyz = temp6.xyz + float3(-1, -1, -1);
    // mul r9.xyz, r9, r9
    temp9.xyz = temp9.xyz * temp9.xyz;
    // sge r9.xyz, -r9, r9
    temp9.xyz = (-temp9.xyz >= temp9.xyz) ? 1 : 0;
    // lrp r10.xyz, r9, c29.w, r6
    temp10.xyz = lerp(temp6.xyz, float3(1.0001, 1.0001, 1.0001), temp9.xyz);
    // log r6.x, r10.x
    temp6.x = log2(temp10.x);
    // log r6.y, r10.y
    temp6.y = log2(temp10.y);
    // log r6.z, r10.z
    temp6.z = log2(temp10.z);
    // mul r9.xyz, r0.z, r6
    temp9.xyz = temp0.zzz * temp6.xyz;
    // mul r6.xyz, r6, c30.w
    temp6.xyz = temp6.xyz * float3(0.6931472, 0.6931472, 0.6931472);
    // exp r10.x, r9.x
    temp10.x = exp2(temp9.x);
    // exp r10.y, r9.y
    temp10.y = exp2(temp9.y);
    // exp r10.z, r9.z
    temp10.z = exp2(temp9.z);
    // add r9.xyz, r10, -c27.x
    temp9.xyz = temp10.xyz + float3(-1, -1, -1);
    // rcp r10.x, r6.x
    temp10.x = 1.0f / temp6.x;
    // rcp r10.y, r6.y
    temp10.y = 1.0f / temp6.y;
    // rcp r10.z, r6.z
    temp10.z = 1.0f / temp6.z;
    // mul r6.xyz, r9, r10
    temp6.xyz = temp9.xyz * temp10.xyz;
    // mov r9.xyz, c69
    temp9.xyz = GeometryUpdate.StartSizeSpreads.xyz;
    // mad r9.xyz, r2, r9, c68
    temp9.xyz = temp2.xyz * temp9.xyz + GeometryUpdate.StartSizeMinimums.xyz;
    // mov r10.xyz, c71
    temp10.xyz = GeometryUpdate.SizeRateSpreads.xyz;
    // mad r2.xyz, r2, r10, c70
    temp2.xyz = temp2.xyz * temp10.xyz + GeometryUpdate.SizeRateMinimums.xyz;
    // mad r2.xyz, r2, r6, r9
    temp2.xyz = temp2.xyz * temp6.xyz + temp9.xyz;
    // frc r1.w, v2.y
    temp1.w = frac(i.texcoord1.y);
    // add r1.w, -r1.w, v2.y
    temp1.w = -temp1.w + i.texcoord1.y;
    // mova a0.x, r1.w
    addr0.x = temp1.w;
    // mul r2.xyz, r2, c27[a0.x]
    temp2.xyz = temp2.xyz * float3(1, 0.5, 0);
    // dp3 r6.z, r2, r7
    temp6.z = dot(temp2.xyz, temp7.xyz);
    // mad r1.xy, r1.y, r1.xzzw, c27.zxzw
    temp1.xy = temp1.yy * temp1.xz + float2(0, 1);
    // mul r3.xy, -r3.x, r1.yxzw
    temp3.xy = -temp3.xx * temp1.yx;
    // mul r7.xy, r3.z, r1.yxzw
    temp7.xy = temp3.zz * temp1.yx;
    // mov r7.w, r3.x
    temp7.w = temp3.x;
    // mov r1.w, r3.y
    temp1.w = temp3.y;
    // mov r7.z, -r1.x
    temp7.z = -temp1.x;
    // dp3 r3.x, r4, r7.xzww
    temp3.x = dot(temp4.xyz, temp7.xzw);
    // dp3 r3.y, r8.xzww, r7.xzww
    temp3.y = dot(temp8.xzw, temp7.xzw);
    // dp3 r3.z, r5.yzww, r7.xzww
    temp3.z = dot(temp5.yzw, temp7.xzw);
    // mov r1.z, r7.y
    temp1.z = temp7.y;
    // dp3 r6.x, r2, r3
    temp6.x = dot(temp2.xyz, temp3.xyz);
    // dp3 r3.y, r8.zxww, r1.yzww
    temp3.y = dot(temp8.zxw, temp1.yzw);
    // dp3 r3.z, r5.zyww, r1.yzww
    temp3.z = dot(temp5.zyw, temp1.yzw);
    // dp3 r3.x, r4.yxzw, r1.yzww
    temp3.x = dot(temp4.yxz, temp1.yzw);
    // dp3 r6.y, r2, r3
    temp6.y = dot(temp2.xyz, temp3.xyz);
    // add r1.xyz, r0.xyww, r6
    temp1.xyz = temp0.xyw + temp6.xyz;
    // mov r1.w, c27.x
    temp1.w = float1(1);
    // dp4 oPos.x, r1, c79
    o.position.x = dot(temp1, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c80
    o.position.y = dot(temp1, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r1, c82
    temp0.y = dot(temp1, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r1, c81
    temp0.x = dot(temp1, (WorldViewProjection._m02_m12_m22_m32));
    // rcp r0.w, r0.y
    temp0.w = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT1.x, r0.x, r0.w
    o.texcoord1 = temp0.x * temp0.w;
    // mov r0.x, c57.x
    temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.y, r0.x, c11[a0.w].x
    temp0.y = temp0.x * float1(0.957897);
    // mul r0.x, r0.x, c11[a0.z].x
    temp0.x = temp0.x * float1(0.957897);
    // frc r0.w, r0.y
    temp0.w = frac(temp0.y);
    // add r1.x, r0.y, -r0.w
    temp1.x = temp0.y + -temp0.w;
    // slt r0.y, r0.y, -r0.y
    temp0.y = (temp0.y < -temp0.y) ? 1 : 0;
    // slt r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w < temp0.w) ? 1 : 0;
    // mad r1.y, r0.y, r0.w, r1.x
    temp1.y = temp0.y * temp0.w + temp1.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.w, r0.x, -r0.y
    temp0.w = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r1.z, r0.x, r0.y, r0.w
    temp1.z = temp0.x * temp0.y + temp0.w;
    // add r0.xy, r1.yzzw, c34[a0.x].xwzw
    temp0.xy = temp1.yz + float2(0, 0);
    // mov r2.z, c27.z
    temp2.z = float1(0);
    // mul r0.w, r0.z, c66.x
    temp0.w = temp0.z * Draw.SpeedMultiplier.x;
    // min r1.x, r0.w, c45.x
    temp1.x = min(temp0.w, expr45.x);
    // mul r0.w, r0.w, c53.x
    temp0.w = temp0.w * expr53.x;
    // frc r2.xy, r1.x
    temp2.xy = frac(temp1.x);
    // add r1.xyz, r1.xxzw, -r2
    temp1.xyz = temp1.xxz + -temp2.xyz;
    // add r1.yz, r1, c34[a0.x].xxww
    temp1.yz = temp1.yz + float2(0, 0);
    // abs r2.x, r0.w
    temp2.x = abs(temp0.w);
    // sge r0.w, r0.w, -r0.w
    temp0.w = (temp0.w >= -temp0.w) ? 1 : 0;
    // frc r2.x, r2.x
    temp2.x = frac(temp2.x);
    // lrp r3.x, r0.w, r2.x, -r2.x
    temp3.x = lerp(-temp2.x, temp2.x, temp0.w);
    // mul r0.w, r3.x, c57.y
    temp0.w = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r2.y, r0.w, c51.x
    temp2.y = temp0.w * expr51.x;
    // abs r0.w, r2.y
    temp0.w = abs(temp2.y);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r2.z, r2.y, -r2.y
    temp2.z = (temp2.y >= -temp2.y) ? 1 : 0;
    // lrp r3.x, r2.z, r0.w, -r0.w
    temp3.x = lerp(-temp0.w, temp0.w, temp2.z);
    // mul r2.x, r3.x, c57.x
    temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r2.xyxy
    temp2.zw = frac(temp2.xy);
    // add r2.xy, r2, -r2.zwzw
    temp2.xy = temp2.xy + -temp2.zw;
    // add r2.xy, r2, c34[a0.x].xwzw
    temp2.xy = temp2.xy + float2(0, 0);
    // mul r2.xy, r2, c51.x
    temp2.xy = temp2.xy * expr51.xx;
    // mad r1.yz, r1, c51.x, -r2.xxyw
    temp1.yz = temp1.yz * expr51.xx + -temp2.xy;
    // mad r1.yz, c54.x, r1, r2.xxyw
    temp1.yz = expr54.xx * temp1.yz + temp2.xy;
    // mad r0.xy, r0, c51.x, -r1.yzzw
    temp0.xy = temp0.xy * expr51.xx + -temp1.yz;
    // mad r0.xy, c55.x, r0, r1.yzzw
    temp0.xy = expr55.xx * temp0.xy + temp1.yz;
    // mov r1.w, c50.x
    temp1.w = expr50.x;
    // add r1.xy, r1.xwzw, c34[a0.x].xwzw
    temp1.xy = temp1.xw + float2(0, 0);
    // mad r1.xy, r1, c51.x, -r0
    temp1.xy = temp1.xy * expr51.xx + -temp0.xy;
    // mad oT0.xy, c56.x, r1, r0
    o.texcoord = expr56.x * temp1 + temp0;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.z, r0.x
    temp0.x = temp0.z * temp0.x;
    // mov r1, c60
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c61
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c62
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c63
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c64
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c58
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c59
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.z, r1, r2
    temp4 = lerp(temp2, temp1, temp0.z);
    // lrp r1, r0.y, r3, r4
    temp1 = lerp(temp4, temp3, temp0.y);
    // mad r0.x, v2.x, c37.y, c37.z
    temp0.x = i.texcoord1.x * float1(0.1875) + float1(2.75);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mul r0.x, r0.x, c28.w
    temp0.x = temp0.x * float1(16);
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.x, r0.x, -r0.y
    temp0.x = temp0.x + -temp0.y;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mov r0.xy, c67
    temp0.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.x].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // mul oD0, r1, r0.x
    o.color = temp1 * temp0.x;
    // 

    return o;
}

// VS_Array_L_Shader_2 Vertex_2_0 Has PRES True
struct VS_Array_L_Shader_2_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct VS_Array_L_Shader_2_Output
{
    float4 position : POSITION;
    float texcoord1 : TEXCOORD1;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

VS_Array_L_Shader_2_Output VS_Array_L_Shader_2(VS_Array_L_Shader_2_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 44
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 13
      Unknown3: 0
      Unknown4: 0
      Unknown5: 44
      Unknown6: 2
      Mappings: 3
        0 - ConstOutput: 50 ConstInput 2
        1 - ConstOutput: 53 ConstInput 4
        2 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    float4 expr54;
    float4 expr55;
    float4 expr56;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c44.x, c1.x, (30)
        expr44.x = Time.x * (30);
        // add c45.x, c0.x, (-1)
        expr45.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c55.x, r1.x, r0.y
        expr55.x = temp1.x < temp0.y;
        // mul c56.x, r0.x, r2.x
        expr56.x = temp0.x * temp2.x;
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add c50.x, r2.z, r0.x
        expr50.x = temp2.z + temp0.x;
        // rcp c51.x, c0.x
        expr51.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c54.x, r0.x, r1.x
        expr54.x = temp0.x >= temp1.x;
        // rcp c53.x, c0.y
        expr53.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
    }

    VS_Array_L_Shader_2_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4, temp5;
    // def c43, 8.9375, 2.0625, 1.375, 4.8125
    // def c28, 1, -0.5, 0, 16
    // def c36, 1, 6.283185, -3.141593, 1
    // def c31, 1, 0, 0.5, 0.1591549
    // def c37, 1, 0.1875, 2.75, 0
    // def c29, 0, -0.5, 0, 1.0001
    // def c27, 1, 0.5, 0, 0.1875
    // def c30, 0, 0.5, 0, 0.6931472
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, 1, 0, -0.5, 0
    // def c33, 0, 0, -0.5, 0
    // def c34, 0, 0, 0.5, 0
    // def c35, 0, 0, 0, 1
    // def c38, 0, 0, 0, 0
    // def c39, 0, 0, 0, 1
    // def c40, 1, 0, 0, 1
    // def c41, 1, 0, 0, 0
    // def c42, 0, 0, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c43
    temp0 = i.texcoord1.x * temp0.w + float4(8.9375, 2.0625, 1.375, 4.8125);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.w
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xyz, c11[a0.y]
    temp0.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r1.xyz, c73
    temp1.xyz = GeometryUpdate.SizeDampingSpreads.xyz;
    // mad r1.xyz, r0, r1, c72
    temp1.xyz = temp0.xyz * temp1.xyz + GeometryUpdate.SizeDampingMinimums.xyz;
    // add r2.xyz, r1, -c27.x
    temp2.xyz = temp1.xyz + float3(-1, -1, -1);
    // mul r2.xyz, r2, r2
    temp2.xyz = temp2.xyz * temp2.xyz;
    // sge r2.xyz, -r2, r2
    temp2.xyz = (-temp2.xyz >= temp2.xyz) ? 1 : 0;
    // lrp r3.xyz, r2, c29.w, r1
    temp3.xyz = lerp(temp1.xyz, float3(1.0001, 1.0001, 1.0001), temp2.xyz);
    // log r1.x, r3.x
    temp1.x = log2(temp3.x);
    // log r1.y, r3.y
    temp1.y = log2(temp3.y);
    // log r1.z, r3.z
    temp1.z = log2(temp3.z);
    // mul r2.xyz, r1, c30.w
    temp2.xyz = temp1.xyz * float3(0.6931472, 0.6931472, 0.6931472);
    // rcp r3.x, r2.x
    temp3.x = 1.0f / temp2.x;
    // rcp r3.y, r2.y
    temp3.y = 1.0f / temp2.y;
    // rcp r3.z, r2.z
    temp3.z = 1.0f / temp2.z;
    // add r0.w, -v1.w, c44.x
    temp0.w = -i.texcoord.w + expr44.x;
    // mul r1.xyz, r1, r0.w
    temp1.xyz = temp1.xyz * temp0.www;
    // exp r2.x, r1.x
    temp2.x = exp2(temp1.x);
    // exp r2.y, r1.y
    temp2.y = exp2(temp1.y);
    // exp r2.z, r1.z
    temp2.z = exp2(temp1.z);
    // add r1.xyz, r2, -c27.x
    temp1.xyz = temp2.xyz + float3(-1, -1, -1);
    // mul r1.xyz, r3, r1
    temp1.xyz = temp3.xyz * temp1.xyz;
    // mov r2.xyz, c69
    temp2.xyz = GeometryUpdate.StartSizeSpreads.xyz;
    // mad r2.xyz, r0, r2, c68
    temp2.xyz = temp0.xyz * temp2.xyz + GeometryUpdate.StartSizeMinimums.xyz;
    // mov r3.xyz, c71
    temp3.xyz = GeometryUpdate.SizeRateSpreads.xyz;
    // mad r3.xyz, r0, r3, c70
    temp3.xyz = temp0.xyz * temp3.xyz + GeometryUpdate.SizeRateMinimums.xyz;
    // mad r1.xyz, r3, r1, r2
    temp1.xyz = temp3.xyz * temp1.xyz + temp2.xyz;
    // frc r1.w, v2.y
    temp1.w = frac(i.texcoord1.y);
    // add r1.w, -r1.w, v2.y
    temp1.w = -temp1.w + i.texcoord1.y;
    // mova a0.y, r1.w
    addr0.y = temp1.w;
    // mul r1.xyz, r1, c27[a0.y]
    temp1.xyz = temp1.xyz * float3(1, 0.5, 0);
    // mad r1.w, r0.x, c78.y, c78.x
    temp1.w = temp0.x * GeometryUpdate.AngleDampingMin_AngleDampingSpread.y + GeometryUpdate.AngleDampingMin_AngleDampingSpread.x;
    // add r2.x, r1.w, -c27.x
    temp2.x = temp1.w + float1(-1);
    // mul r2.x, r2.x, r2.x
    temp2.x = temp2.x * temp2.x;
    // sge r2.x, -r2.x, r2.x
    temp2.x = (-temp2.x >= temp2.x) ? 1 : 0;
    // lrp r3.x, r2.x, c29.w, r1.w
    temp3.x = lerp(temp1.w, float1(1.0001), temp2.x);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.x, r1.w, c30.w
    temp2.x = temp1.w * float1(0.6931472);
    // mul r1.w, r0.w, r1.w
    temp1.w = temp0.w * temp1.w;
    // rcp r2.x, r2.x
    temp2.x = 1.0f / temp2.x;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, -c27.x
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.x, r1.w
    temp1.w = temp2.x * temp1.w;
    // mov r2.xyz, c75
    temp2.xyz = GeometryUpdate.AngleSpreads.xyz;
    // mad r2.xyz, r0, r2, c74
    temp2.xyz = temp0.xyz * temp2.xyz + GeometryUpdate.AngleMinimums.xyz;
    // mov r3.xyz, c77
    temp3.xyz = GeometryUpdate.AngularRateSpreads.xyz;
    // mad r0.xyz, r0, r3, c76
    temp0.xyz = temp0.xyz * temp3.xyz + GeometryUpdate.AngularRateMinimums.xyz;
    // mad r0.xyz, r0, r1.w, r2
    temp0.xyz = temp0.xyz * temp1.www + temp2.xyz;
    // mad r0.xyz, r0, c31.w, c31.z
    temp0.xyz = temp0.xyz * float3(0.15915494, 0.15915494, 0.15915494) + float3(0.5, 0.5, 0.5);
    // frc r0.xyz, r0
    temp0.xyz = frac(temp0.xyz);
    // mad r0.xyz, r0, c36.y, c36.z
    temp0.xyz = temp0.xyz * float3(6.2831855, 6.2831855, 6.2831855) + float3(-3.1415927, -3.1415927, -3.1415927);
    // sincos r2.xy, r0.x, c0, c1
    temp2.xy = float2(cos(temp0.x), sin(temp0.x));
    // sincos r3.xy, r0.z, c0, c1
    temp3.xy = float2(cos(temp0.z), sin(temp0.z));
    // sincos r4.xy, r0.y, c0, c1
    temp4.xy = float2(cos(temp0.y), sin(temp0.y));
    // mul r5, r2.yyxx, r3.xyxy
    temp5 = temp2.yyxx * temp3.xyxy;
    // mul r0.yz, r2.xyxw, r4.x
    temp0.yz = temp2.yx * temp4.xx;
    // mul r2.xy, r3, r4.x
    temp2.xy = temp3.xy * temp4.xx;
    // mad r3.xy, r4.y, r5.xwzw, -r5.wxzw
    temp3.xy = temp4.yy * temp5.xw + -temp5.wx;
    // mad r5.xy, r4.y, r5.yzzw, r5.zyzw
    temp5.xy = temp4.yy * temp5.yz + temp5.zy;
    // mov r0.x, -r4.y
    temp0.x = -temp4.y;
    // mov r2.z, r3.x
    temp2.z = temp3.x;
    // mov r5.w, r3.y
    temp5.w = temp3.y;
    // mov r2.w, r5.y
    temp2.w = temp5.y;
    // dp3 r2.x, r1, r2.xzww
    temp2.x = dot(temp1.xyz, temp2.xzw);
    // mov r5.z, r2.y
    temp5.z = temp2.y;
    // dp3 r2.z, r1.yxzw, r5.xzww
    temp2.z = dot(temp1.yxz, temp5.xzw);
    // dp3 r2.w, r1, r0
    temp2.w = dot(temp1.xyz, temp0.xyz);
    // mov r0.xy, c85
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.x].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, -c27.x
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.w, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c30.w
    temp0.y = temp0.x * float1(0.6931472);
    // mul r0.x, r0.w, r0.x
    temp0.x = temp0.w * temp0.x;
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, -c27.x
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mul r0.y, r0.w, c27.y
    temp0.y = temp0.w * float1(0.5);
    // mov r1.xyz, c83
    temp1.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r0.y, r1, c84
    temp1.xyz = temp0.yyy * temp1.xyz + Physics.DriftVelocity.xyz;
    // mul r1.xyz, r0.w, r1
    temp1.xyz = temp0.www * temp1.xyz;
    // mad r0.xyz, v1, r0.x, r1
    temp0.xyz = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // add r0.xyz, r0, v0
    temp0.xyz = temp0.xyz + i.position.xyz;
    // add r1.xyz, r2.xzww, r0
    temp1.xyz = temp2.xzw + temp0.xyz;
    // mov r1.w, c27.x
    temp1.w = float1(1);
    // dp4 oPos.x, r1, c79
    o.position.x = dot(temp1, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r1, c80
    o.position.y = dot(temp1, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r1, c82
    temp0.y = dot(temp1, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r1, c81
    temp0.x = dot(temp1, (WorldViewProjection._m02_m12_m22_m32));
    // rcp r0.z, r0.y
    temp0.z = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT1.x, r0.x, r0.z
    o.texcoord1 = temp0.x * temp0.z;
    // mov r0.x, c57.x
    temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.y, r0.x, c11[a0.w].x
    temp0.y = temp0.x * float1(0.957897);
    // mul r0.x, r0.x, c11[a0.z].x
    temp0.x = temp0.x * float1(0.957897);
    // frc r0.z, r0.y
    temp0.z = frac(temp0.y);
    // add r1.x, r0.y, -r0.z
    temp1.x = temp0.y + -temp0.z;
    // slt r0.y, r0.y, -r0.y
    temp0.y = (temp0.y < -temp0.y) ? 1 : 0;
    // slt r0.z, -r0.z, r0.z
    temp0.z = (-temp0.z < temp0.z) ? 1 : 0;
    // mad r1.y, r0.y, r0.z, r1.x
    temp1.y = temp0.y * temp0.z + temp1.x;
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.z, r0.x, -r0.y
    temp0.z = temp0.x + -temp0.y;
    // slt r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y < temp0.y) ? 1 : 0;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // mad r1.z, r0.x, r0.y, r0.z
    temp1.z = temp0.x * temp0.y + temp0.z;
    // add r0.xy, r1.yzzw, c34[a0.y].xwzw
    temp0.xy = temp1.yz + float2(0, 0);
    // mov r2.z, c27.z
    temp2.z = float1(0);
    // mul r0.z, r0.w, c66.x
    temp0.z = temp0.w * Draw.SpeedMultiplier.x;
    // min r1.x, r0.z, c45.x
    temp1.x = min(temp0.z, expr45.x);
    // mul r0.z, r0.z, c53.x
    temp0.z = temp0.z * expr53.x;
    // frc r2.xy, r1.x
    temp2.xy = frac(temp1.x);
    // add r1.xyz, r1.xxzw, -r2
    temp1.xyz = temp1.xxz + -temp2.xyz;
    // add r1.yz, r1, c34[a0.y].xxww
    temp1.yz = temp1.yz + float2(0, 0);
    // abs r2.x, r0.z
    temp2.x = abs(temp0.z);
    // sge r0.z, r0.z, -r0.z
    temp0.z = (temp0.z >= -temp0.z) ? 1 : 0;
    // frc r2.x, r2.x
    temp2.x = frac(temp2.x);
    // lrp r3.x, r0.z, r2.x, -r2.x
    temp3.x = lerp(-temp2.x, temp2.x, temp0.z);
    // mul r0.z, r3.x, c57.y
    temp0.z = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r2.y, r0.z, c51.x
    temp2.y = temp0.z * expr51.x;
    // abs r0.z, r2.y
    temp0.z = abs(temp2.y);
    // frc r0.z, r0.z
    temp0.z = frac(temp0.z);
    // sge r2.z, r2.y, -r2.y
    temp2.z = (temp2.y >= -temp2.y) ? 1 : 0;
    // lrp r3.x, r2.z, r0.z, -r0.z
    temp3.x = lerp(-temp0.z, temp0.z, temp2.z);
    // mul r2.x, r3.x, c57.x
    temp2.x = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r2.xyxy
    temp2.zw = frac(temp2.xy);
    // add r2.xy, r2, -r2.zwzw
    temp2.xy = temp2.xy + -temp2.zw;
    // add r2.xy, r2, c34[a0.y].xwzw
    temp2.xy = temp2.xy + float2(0, 0);
    // mul r2.xy, r2, c51.x
    temp2.xy = temp2.xy * expr51.xx;
    // mad r1.yz, r1, c51.x, -r2.xxyw
    temp1.yz = temp1.yz * expr51.xx + -temp2.xy;
    // mad r1.yz, c54.x, r1, r2.xxyw
    temp1.yz = expr54.xx * temp1.yz + temp2.xy;
    // mad r0.xy, r0, c51.x, -r1.yzzw
    temp0.xy = temp0.xy * expr51.xx + -temp1.yz;
    // mad r0.xy, c55.x, r0, r1.yzzw
    temp0.xy = expr55.xx * temp0.xy + temp1.yz;
    // mov r1.w, c50.x
    temp1.w = expr50.x;
    // add r1.xy, r1.xwzw, c34[a0.y].xwzw
    temp1.xy = temp1.xw + float2(0, 0);
    // mad r1.xy, r1, c51.x, -r0
    temp1.xy = temp1.xy * expr51.xx + -temp0.xy;
    // mad oT0.xy, c56.x, r1, r0
    o.texcoord = expr56.x * temp1 + temp0;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.w, r0.x
    temp0.x = temp0.w * temp0.x;
    // mov r1, c60
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c61
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c62
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c63
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.yz, r0.x, c64
    temp0.yz = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c58
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c59
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.z, r1, r2
    temp4 = lerp(temp2, temp1, temp0.z);
    // lrp r1, r0.y, r3, r4
    temp1 = lerp(temp4, temp3, temp0.y);
    // mad r0.x, v2.x, c37.y, c37.z
    temp0.x = i.texcoord1.x * float1(0.1875) + float1(2.75);
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // mul r0.x, r0.x, c28.w
    temp0.x = temp0.x * float1(16);
    // frc r0.y, r0.x
    temp0.y = frac(temp0.x);
    // add r0.x, r0.x, -r0.y
    temp0.x = temp0.x + -temp0.y;
    // mova a0.x, r0.x
    addr0.x = temp0.x;
    // mov r0.xy, c67
    temp0.xy = Draw.ColorScaleRange.xy;
    // mad r0.x, c11[a0.x].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // mul oD0, r1, r0.x
    o.color = temp1 * temp0.x;
    // 

    return o;
}

VertexShader VS_Array_L[3] = {
    compile vs_2_0 VS_Array_L_Shader_0(), // 43
    compile vs_2_0 VS_Array_L_Shader_1(), // 44
    compile vs_2_0 VS_Array_L_Shader_2(), // 45
};
// PSCreateShadowMap_Array_Shader_0 Pixel_2_0 Has PRES False
float4 PSCreateShadowMap_Array_Shader_0(float texcoord2 : TEXCOORD2) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t2.x
    // mov r0, t2.x
    temp0 = texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_1 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_1_Input
{
    float2 texcoord : TEXCOORD;
    float3 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_1(PSCreateShadowMap_Array_Shader_1_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, -0.3, 0, 0
    // dcl t0.xy
    // dcl v0.xyz
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, r0.x, c0.y
    temp0 = temp0.x + float4(-0.3, -0.3, -0.3, -0.3);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_2 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_2_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_2(PSCreateShadowMap_Array_Shader_2_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_3 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_3_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_3(PSCreateShadowMap_Array_Shader_3_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_4 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_4_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_4(PSCreateShadowMap_Array_Shader_4_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, -0.1, 0, 0, 0
    // dcl t0.xy
    // dcl v0
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mad r0, r0.w, v0.w, c0.x
    temp0 = temp0.w * i.color.w + float4(-0.1, -0.1, -0.1, -0.1);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// PSCreateShadowMap_Array_Shader_5 Pixel_2_0 Has PRES False
struct PSCreateShadowMap_Array_Shader_5_Input
{
    float2 texcoord : TEXCOORD;
    float3 color : COLOR;
    float texcoord2 : TEXCOORD2;
};

float4 PSCreateShadowMap_Array_Shader_5(PSCreateShadowMap_Array_Shader_5_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // def c0, 1, 0.3, 0, 0
    // dcl t0.xy
    // dcl v0.xyz
    // dcl t2.x
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0.xyz, r0, v0
    temp0.xyz = temp0.xyz * i.color.xyz;
    // dp3 r0.x, r0, c0.x
    temp0.x = dot(temp0.xyz, float3(1, 1, 1));
    // add r0, -r0.x, c0.y
    temp0 = -temp0.x + float4(0.3, 0.3, 0.3, 0.3);
    // texkill r0
    clip(temp0);
    // mov r0, t2.x
    temp0 = i.texcoord2.x;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

PixelShader PSCreateShadowMap_Array[6] = {
    compile ps_2_0 PSCreateShadowMap_Array_Shader_0(), // 52
    compile ps_2_0 PSCreateShadowMap_Array_Shader_1(), // 53
    compile ps_2_0 PSCreateShadowMap_Array_Shader_2(), // 54
    compile ps_2_0 PSCreateShadowMap_Array_Shader_3(), // 55
    compile ps_2_0 PSCreateShadowMap_Array_Shader_4(), // 56
    compile ps_2_0 PSCreateShadowMap_Array_Shader_5(), // 57
};
// _CreateShadowMap_Expression22 Expression_2_0 Has PRES False
float _CreateShadowMap_Expression22()
{
    float1 expr0;
    // min c0.x, c8.x, (5)
    expr0.x = min(Draw.ShaderType.x, (5));
    return expr0;
}

// _CreateShadowMap_VertexShader23 Vertex_2_0 Has PRES True
struct _CreateShadowMap_VertexShader23_Input
{
    float4 position : POSITION;
    float4 texcoord : TEXCOORD;
    float4 texcoord1 : TEXCOORD1;
};

struct _CreateShadowMap_VertexShader23_Output
{
    float4 position : POSITION;
    float texcoord2 : TEXCOORD2;
    float3 texcoord3 : TEXCOORD3;
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
    float3 texcoord1 : TEXCOORD1;
};

_CreateShadowMap_VertexShader23_Output _CreateShadowMap_VertexShader23(_CreateShadowMap_VertexShader23_Input i)
{
    /*
    PRSI
      OutputRegisterOffset: 39
      Unknown1: 0
      Unknown2: 0
      OutputRegisterCount: 15
      Unknown3: 0
      Unknown4: 0
      Unknown5: 39
      Unknown6: 2
      Mappings: 4
        0 - ConstOutput: 45 ConstInput 2
        1 - ConstOutput: 48 ConstInput 1
        2 - ConstOutput: 50 ConstInput 4
        3 - ConstOutput: 0 ConstInput 0
    
    */
    float4 expr39;
    float4 expr40;
    float4 expr41;
    float4 expr42;
    float4 expr43;
    float4 expr44;
    float4 expr45;
    float4 expr46;
    float4 expr47;
    float4 expr48;
    float4 expr49;
    float4 expr50;
    float4 expr51;
    float4 expr52;
    float4 expr53;
    {
        float4 temp0;
        float4 temp1;
        float4 temp2;
        // Expression_2_1
        // mul c39.x, c1.x, (30)
        expr39.x = Time.x * (30);
        // add c40.x, c0.x, (-1)
        expr40.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x + (-1);
        // lt r0.x, (0), c0.z
        temp0.x = (0) < Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z;
        // mul r0.y, c0.w, c0.w
        temp0.y = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.w;
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // ge r2.x, r1.x, r0.y
        temp2.x = temp1.x >= temp0.y;
        // lt c52.x, r1.x, r0.y
        expr52.x = temp1.x < temp0.y;
        // mul c53.x, r0.x, r2.x
        expr53.x = temp0.x * temp2.x;
        // rcp c46.x, c0.x
        expr46.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x);
        // add r0.x, c0.z, (1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (1);
        // mul r1.x, r0.x, r0.x
        temp1.x = temp0.x * temp0.x;
        // neg r0.x, r1.x
        temp0.x = -temp1.x;
        // ge c51.x, r0.x, r1.x
        expr51.x = temp0.x >= temp1.x;
        // rcp c50.x, c0.y
        expr50.x = 1.0f / (Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y);
        // add r0.x, c0.z, (-1)
        temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z + (-1);
        // neg r1.x, r0.x
        temp1.x = -temp0.x;
        // lt r2.x, r0.x, r1.x
        temp2.x = temp0.x < temp1.x;
        // frc r0.y, c0.z
        temp0.y = frac(Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.z);
        // neg r1.x, r0.y
        temp1.x = -temp0.y;
        // lt r2.y, r1.x, r0.y
        temp2.y = temp1.x < temp0.y;
        // add r2.z, r0.x, r1.x
        temp2.z = temp0.x + temp1.x;
        // mul r0.x, r2.x, r2.y
        temp0.x = temp2.x * temp2.y;
        // add r1.x, r2.z, r0.x
        temp1.x = temp2.z + temp0.x;
        // mov c45.x, r1.x
        expr45.x = temp1.x;
        // mov c48.x, r1.x
        expr48.x = temp1.x;
    }

    _CreateShadowMap_VertexShader23_Output o;
    float4 temp0, temp1, addr0, temp2, temp3, temp4;
    float3 temp5, temp6, temp7;
    // def c36, 2.0625, 8.9375, 6.1875, 1.375
    // def c28, 0.5, -0.5, 16, -1
    // def c30, -0.5, 0.5, 0.1591549, 0
    // def c31, 0, 0, 6.283185, -3.141593
    // def c38, 0.1875, 4.8125, 2.75, 0
    // def c37, 1, -1, 0.5, 0
    // def c29, 0.5, 0.5, 1.0001, 0.6931472
    // def c27, -0.5, -0.5, 0, 0.1875
    // def c11, 0.957897, 0.3788705, 0.3635719, 0.3287609
    // def c12, 0.1762373, 0.9145751, 0.4360935, 0.3476284
    // def c13, 0.743219, 0.4425611, 0.9974546, 0.3622138
    // def c14, 0.4896626, 0.6664233, 0.8305699, 0.9742577
    // def c15, 0.8947675, 0.8236215, 0.9309705, 0.05219847
    // def c16, 0.1411007, 0.6527002, 0.008452523, 0.6430574
    // def c17, 0.229799, 0.897999, 0.753822, 0.1316504
    // def c18, 0.5815384, 0.2836916, 0.09156471, 0.407481
    // def c19, 0.2706044, 0.7228181, 0.1694367, 0.1469052
    // def c20, 0.5995556, 0.0964533, 0.8763983, 0.1172229
    // def c21, 0.5101711, 0.9421572, 0.1957888, 0.9167565
    // def c22, 0.03546793, 0.5340094, 0.1673218, 0.5576764
    // def c23, 0.861564, 0.2251601, 0.082332, 0.8790039
    // def c24, 0.1730866, 0.8935188, 0.01392406, 0.1787381
    // def c25, 0.8269383, 0.7718143, 0.4395359, 0.493963
    // def c26, 0.5423613, 0.7218617, 0.7697314, 0.5878567
    // def c32, -0.25, -0.25, 0, 0
    // def c33, 0.25, -0.25, 0, 0
    // def c34, 0.25, 0.25, 0, 0
    // def c35, -0.25, 0.25, 0, 0
    // def c0, -1.550099E-06, -2.170139E-05, 0.002604167, 0.0002604167
    // def c1, -0.02083333, -0.125, 1, 0.5
    // dcl_position v0
    // dcl_texcoord v1
    // dcl_texcoord1 v2
    // mov r0.w, c27.w
    temp0.w = float1(0.1875);
    // mad r0, v2.x, r0.w, c36
    temp0 = i.texcoord1.x * temp0.w + float4(2.0625, 8.9375, 6.1875, 1.375);
    // frc r0, r0
    temp0 = frac(temp0);
    // mul r0, r0, c28.z
    temp0 = temp0 * float4(16, 16, 16, 16);
    // frc r1, r0
    temp1 = frac(temp0);
    // add r0, r0, -r1
    temp0 = temp0 + -temp1;
    // mova a0, r0
    addr0 = temp0;
    // mov r0.xy, c77
    temp0.xy = Physics.VelocityDampingRange.xy;
    // mad r0.x, c11[a0.y].x, r0.y, r0.x
    temp0.x = float1(0.957897) * temp0.y + temp0.x;
    // add r0.y, r0.x, c28.w
    temp0.y = temp0.x + float1(-1);
    // mul r0.y, r0.y, r0.y
    temp0.y = temp0.y * temp0.y;
    // sge r0.y, -r0.y, r0.y
    temp0.y = (-temp0.y >= temp0.y) ? 1 : 0;
    // lrp r1.x, r0.y, c29.z, r0.x
    temp1.x = lerp(temp0.x, float1(1.0001), temp0.y);
    // log r0.x, r1.x
    temp0.x = log2(temp1.x);
    // mul r0.y, r0.x, c29.w
    temp0.y = temp0.x * float1(0.6931472);
    // rcp r0.y, r0.y
    temp0.y = 1.0f / temp0.y;
    // add r0.z, -v1.w, c39.x
    temp0.z = -i.texcoord.w + expr39.x;
    // mul r0.x, r0.x, r0.z
    temp0.x = temp0.x * temp0.z;
    // exp r0.x, r0.x
    temp0.x = exp2(temp0.x);
    // add r0.x, r0.x, c28.w
    temp0.x = temp0.x + float1(-1);
    // mul r0.x, r0.y, r0.x
    temp0.x = temp0.y * temp0.x;
    // mov r1.xyz, v0
    temp1.xyz = i.position.xyz;
    // mad r0.xyw, v1.xyzz, r0.x, r1.xyzz
    temp0.xyw = i.texcoord.xyz * temp0.xxx + temp1.xyz;
    // mul r1.x, r0.z, -c27.x
    temp1.x = temp0.z * float1(0.5);
    // mov r2.xyz, c75
    temp2.xyz = Physics.Gravity.xyz;
    // mad r1.xyz, r1.x, r2, c76
    temp1.xyz = temp1.xxx * temp2.xyz + Physics.DriftVelocity.xyz;
    // mad r0.xyw, r1.xyzz, r0.z, r0
    temp0.xyw = temp1.xyz * temp0.zzz + temp0.xyw;
    // add r1.xyz, r0.xyyw, -v0.xyyw
    temp1.xyz = temp0.xyy + -i.position.xyy;
    // mov r2.xyz, c11[a0.z]
    temp2.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r3.xyz, c68
    temp3.xyz = Update.XYRotation_Rate_Damping__Spread.xyz;
    // mad r2.xyz, r2, r3, c67
    temp2.xyz = temp2.xyz * temp3.xyz + Update.XYRotation_Rate_Damping__Min.xyz;
    // add r1.w, r2.z, c28.w
    temp1.w = temp2.z + float1(-1);
    // mul r1.w, r1.w, r1.w
    temp1.w = temp1.w * temp1.w;
    // sge r1.w, -r1.w, r1.w
    temp1.w = (-temp1.w >= temp1.w) ? 1 : 0;
    // lrp r3.x, r1.w, c29.z, r2.z
    temp3.x = lerp(temp2.z, float1(1.0001), temp1.w);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.z, r1.w, c29.w
    temp2.z = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.z, r2.z
    temp2.z = 1.0f / temp2.z;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.z, r1.w
    temp1.w = temp2.z * temp1.w;
    // mad r1.w, r2.y, r1.w, r2.x
    temp1.w = temp2.y * temp1.w + temp2.x;
    // mad r1.w, r1.w, c30.z, c30.y
    temp1.w = temp1.w * float1(0.15915494) + float1(0.5);
    // frc r1.w, r1.w
    temp1.w = frac(temp1.w);
    // mad r1.w, r1.w, c31.z, c31.w
    temp1.w = temp1.w * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.w, c0, c1
    temp2.xy = float2(cos(temp1.w), sin(temp1.w));
    // mul r1.yzw, r1.xxyz, r2.xxyx
    temp1.yzw = temp1.xyz * temp2.xyx;
    // mad r1.w, r1.x, -r2.y, r1.w
    temp1.w = temp1.x * -temp2.y + temp1.w;
    // add r1.x, r1.z, r1.y
    temp1.x = temp1.z + temp1.y;
    // add r0.xy, r1.xwzw, v0
    temp0.xy = temp1.xw + i.position.xy;
    // mov r1.xyz, c11[a0.w]
    temp1.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r2.xyz, c70
    temp2.xyz = Update.ZRotation_Rate_Damping__Spread.xyz;
    // mad r1.yzw, r1.xxyz, r2.xxyz, c69.xxyz
    temp1.yzw = temp1.xyz * temp2.xyz + Update.ZRotation_Rate_Damping__Min.xyz;
    // add r2.x, r1.w, c28.w
    temp2.x = temp1.w + float1(-1);
    // mul r2.x, r2.x, r2.x
    temp2.x = temp2.x * temp2.x;
    // sge r2.x, -r2.x, r2.x
    temp2.x = (-temp2.x >= temp2.x) ? 1 : 0;
    // lrp r3.x, r2.x, c29.z, r1.w
    temp3.x = lerp(temp1.w, float1(1.0001), temp2.x);
    // log r1.w, r3.x
    temp1.w = log2(temp3.x);
    // mul r2.x, r1.w, c29.w
    temp2.x = temp1.w * float1(0.6931472);
    // mul r1.w, r0.z, r1.w
    temp1.w = temp0.z * temp1.w;
    // rcp r2.x, r2.x
    temp2.x = 1.0f / temp2.x;
    // exp r1.w, r1.w
    temp1.w = exp2(temp1.w);
    // add r1.w, r1.w, c28.w
    temp1.w = temp1.w + float1(-1);
    // mul r1.w, r2.x, r1.w
    temp1.w = temp2.x * temp1.w;
    // mad r1.y, r1.z, r1.w, r1.y
    temp1.y = temp1.z * temp1.w + temp1.y;
    // mad r1.y, r1.y, c30.z, c30.y
    temp1.y = temp1.y * float1(0.15915494) + float1(0.5);
    // frc r1.y, r1.y
    temp1.y = frac(temp1.y);
    // mad r1.y, r1.y, c31.z, c31.w
    temp1.y = temp1.y * float1(6.2831855) + float1(-3.1415927);
    // sincos r2.xy, r1.y, c0, c1
    temp2.xy = float2(cos(temp1.y), sin(temp1.y));
    // slt r1.y, v0.w, r0.z
    temp1.y = (i.position.w < temp0.z) ? 1 : 0;
    // mad r1.y, r1.y, -v2.y, v2.y
    temp1.y = temp1.y * -i.texcoord1.y + i.texcoord1.y;
    // frc r1.z, r1.y
    temp1.z = frac(temp1.y);
    // add r1.y, r1.y, -r1.z
    temp1.y = temp1.y + -temp1.z;
    // mova a0.y, r1.y
    addr0.y = temp1.y;
    // mul r1.yzw, r2.xxyx, c27[a0.y].xxyy
    temp1.yzw = temp2.xyx * float3(-0.5, -0.5, -0.5);
    // mad r1.w, c27[a0.y].x, -r2.y, r1.w
    temp1.w = float1(-0.5) * -temp2.y + temp1.w;
    // mov r2.xy, c27[a0.y]
    temp2.xy = float2(-0.5, -0.5);
    // mad r2.xy, r2, c37, c37.z
    temp2.xy = temp2.xy * float2(1, -1) + float2(0.5, 0.5);
    // add r1.y, r1.z, r1.y
    temp1.y = temp1.z + temp1.y;
    // mul r3.xyz, r1.w, c79
    temp3.xyz = temp1.www * (View._m01_m11_m21_m31).xyz;
    // mad r1.yzw, r1.y, c78.xxyz, r3.xxyz
    temp1.yzw = temp1.yyy * (View._m00_m10_m20_m30).xyz + temp3.xyz;
    // mov r3.xyz, c11[a0.x]
    temp3.xyz = float3(0.957897, 0.37887052, 0.36357188);
    // mov r4.xyz, c66
    temp4.xyz = Update.Size_Rate_Damping__Spread.xyz;
    // mad r3.xyz, r3, r4, c65
    temp3.xyz = temp3.xyz * temp4.xyz + Update.Size_Rate_Damping__Min.xyz;
    // mul r1.x, r1.x, c54.x
    temp1.x = temp1.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // add r2.z, r3.z, c28.w
    temp2.z = temp3.z + float1(-1);
    // mul r2.z, r2.z, r2.z
    temp2.z = temp2.z * temp2.z;
    // sge r2.z, -r2.z, r2.z
    temp2.z = (-temp2.z >= temp2.z) ? 1 : 0;
    // lrp r4.x, r2.z, c29.z, r3.z
    temp4.x = lerp(temp3.z, float1(1.0001), temp2.z);
    // log r2.z, r4.x
    temp2.z = log2(temp4.x);
    // mul r2.w, r2.z, c29.w
    temp2.w = temp2.z * float1(0.6931472);
    // mul r2.z, r0.z, r2.z
    temp2.z = temp0.z * temp2.z;
    // rcp r2.w, r2.w
    temp2.w = 1.0f / temp2.w;
    // exp r2.z, r2.z
    temp2.z = exp2(temp2.z);
    // add r2.z, r2.z, c28.w
    temp2.z = temp2.z + float1(-1);
    // mul r2.z, r2.w, r2.z
    temp2.z = temp2.w * temp2.z;
    // mad r2.z, r3.y, r2.z, r3.x
    temp2.z = temp3.y * temp2.z + temp3.x;
    // mad r3.xyz, r2.z, r1.yzww, r0.xyww
    temp3.xyz = temp2.zzz * temp1.yzw + temp0.xyw;
    // mov r3.w, -c28.w
    temp3.w = float1(1);
    // dp4 oPos.x, r3, c71
    o.position.x = dot(temp3, (WorldViewProjection._m00_m10_m20_m30));
    // dp4 oPos.y, r3, c72
    o.position.y = dot(temp3, (WorldViewProjection._m01_m11_m21_m31));
    // dp4 r0.y, r3, c74
    temp0.y = dot(temp3, (WorldViewProjection._m03_m13_m23_m33));
    // dp4 r0.x, r3, c73
    temp0.x = dot(temp3, (WorldViewProjection._m02_m12_m22_m32));
    // rcp r0.w, r0.y
    temp0.w = 1.0f / temp0.y;
    // mov oPos.zw, r0.xyxy
    o.position.zw = temp0.xy;
    // mul oT2.x, r0.x, r0.w
    o.texcoord2 = temp0.x * temp0.w;
    // mov r0.w, c28.w
    temp0.w = float1(-1);
    // mad r0.x, r0.z, c63.x, -r0.w
    temp0.x = temp0.z * Draw.SpeedMultiplier.x + -temp0.w;
    // mul r0.y, r0.x, c50.x
    temp0.y = temp0.x * expr50.x;
    // min r3.x, r0.x, c40.x
    temp3.x = min(temp0.x, expr40.x);
    // abs r0.x, r0.y
    temp0.x = abs(temp0.y);
    // sge r0.y, r0.y, -r0.y
    temp0.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // frc r0.x, r0.x
    temp0.x = frac(temp0.x);
    // lrp r1.y, r0.y, r0.x, -r0.x
    temp1.y = lerp(-temp0.x, temp0.x, temp0.y);
    // mul r0.x, r1.y, c54.y
    temp0.x = temp1.y * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r0.y, r0.x, c46.x
    temp0.y = temp0.x * expr46.x;
    // abs r0.w, r0.y
    temp0.w = abs(temp0.y);
    // frc r0.w, r0.w
    temp0.w = frac(temp0.w);
    // sge r1.y, r0.y, -r0.y
    temp1.y = (temp0.y >= -temp0.y) ? 1 : 0;
    // lrp r2.z, r1.y, r0.w, -r0.w
    temp2.z = lerp(-temp0.w, temp0.w, temp1.y);
    // mul r0.x, r2.z, c54.x
    temp0.x = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r1.yz, r0.xxyw
    temp1.yz = frac(temp0.xy);
    // add r0.xy, r0, -r1.yzzw
    temp0.xy = temp0.xy + -temp1.yz;
    // add r0.xy, r2, r0
    temp0.xy = temp2.xy + temp0.xy;
    // mul r0.xy, r0, c46.x
    temp0.xy = temp0.xy * expr46.xx;
    // frc r1.y, r1.x
    temp1.y = frac(temp1.x);
    // add r1.z, r1.x, -r1.y
    temp1.z = temp1.x + -temp1.y;
    // slt r1.y, -r1.y, r1.y
    temp1.y = (-temp1.y < temp1.y) ? 1 : 0;
    // slt r1.x, r1.x, -r1.x
    temp1.x = (temp1.x < -temp1.x) ? 1 : 0;
    // mad r3.w, r1.x, r1.y, r1.z
    temp3.w = temp1.x * temp1.y + temp1.z;
    // mov r1.w, c27.z
    temp1.w = float1(0);
    // mul r2.z, r0.z, c63.x
    temp2.z = temp0.z * Draw.SpeedMultiplier.x;
    // min r3.y, r2.z, c40.x
    temp3.y = min(temp2.z, expr40.x);
    // frc r1.xyz, r3.yxxw
    temp1.xyz = frac(temp3.yxx);
    // add r1.zw, r3.xyxw, -r1
    temp1.zw = temp3.xw + -temp1.zw;
    // add r4.xz, r3.yyxw, -r1.xyyw
    temp4.xz = temp3.yx + -temp1.xy;
    // add r1.xy, r2, r1.zwzw
    temp1.xy = temp2.xy + temp1.zw;
    // mul r1.xy, r1, c46.x
    temp1.xy = temp1.xy * expr46.xx;
    // frc r0.w, r2.z
    temp0.w = frac(temp2.z);
    // mul r2.z, r2.z, c50.x
    temp2.z = temp2.z * expr50.x;
    // frc r1.z, r3.y
    temp1.z = frac(temp3.y);
    // lrp r5.xyz, c51.x, r1, r0.xyww
    temp5.xyz = lerp(temp0.xyw, temp1.xyz, expr51.xxx);
    // mad r0.xy, v2.x, c38.x, c38.yzzw
    temp0.xy = i.texcoord1.xx * float2(0.1875, 0.1875) + float2(4.8125, 2.75);
    // frc r0.xy, r0
    temp0.xy = frac(temp0.xy);
    // mul r0.xy, r0, c28.z
    temp0.xy = temp0.xy * float2(16, 16);
    // frc r1.xy, r0
    temp1.xy = frac(temp0.xy);
    // add r0.xy, r0, -r1
    temp0.xy = temp0.xy + -temp1.xy;
    // mova a0.xy, r0
    addr0.xy = temp0.xy;
    // mov r0.x, c54.x
    temp0.x = Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // mul r0.x, r0.x, c11[a0.x].x
    temp0.x = temp0.x * float1(0.957897);
    // mov r1.xy, c64
    temp1.xy = Draw.ColorScaleRange.xy;
    // mad r0.y, c11[a0.y].x, r1.y, r1.x
    temp0.y = float1(0.957897) * temp1.y + temp1.x;
    // frc r0.w, r0.x
    temp0.w = frac(temp0.x);
    // add r1.x, r0.x, -r0.w
    temp1.x = temp0.x + -temp0.w;
    // slt r0.x, r0.x, -r0.x
    temp0.x = (temp0.x < -temp0.x) ? 1 : 0;
    // slt r0.w, -r0.w, r0.w
    temp0.w = (-temp0.w < temp0.w) ? 1 : 0;
    // mad r3.z, r0.x, r0.w, r1.x
    temp3.z = temp0.x * temp0.w + temp1.x;
    // add r0.xw, r2.xyzy, r3.zyzw
    temp0.xw = temp2.xy + temp3.zw;
    // mul r6.xy, r0.xwzw, c46.x
    temp6.xy = temp0.xw * expr46.xx;
    // mov r6.z, c27.z
    temp6.z = float1(0);
    // lrp r7.xyz, c52.x, r6, r5
    temp7.xyz = lerp(temp5.xyz, temp6.xyz, expr52.xxx);
    // mov r4.w, c48.x
    temp4.w = expr48.x;
    // add r1.xy, r2, r4.zwzw
    temp1.xy = temp2.xy + temp4.zw;
    // mul r5.xy, r1, c46.x
    temp5.xy = temp1.xy * expr46.xx;
    // mov r5.z, r1.z
    temp5.z = temp1.z;
    // add r5.xyz, -r7, r5
    temp5.xyz = -temp7.xyz + temp5.xyz;
    // mad oT3.xyz, c53.x, r5, r7
    o.texcoord3 = expr53.x * temp5 + temp7;
    // mov r1.w, c27.z
    temp1.w = float1(0);
    // add r1.xy, r3.ywzw, -r1.zwzw
    temp1.xy = temp3.yw + -temp1.zw;
    // add r1.xy, r2, r1
    temp1.xy = temp2.xy + temp1.xy;
    // abs r1.z, r2.z
    temp1.z = abs(temp2.z);
    // sge r1.w, r2.z, -r2.z
    temp1.w = (temp2.z >= -temp2.z) ? 1 : 0;
    // frc r1.z, r1.z
    temp1.z = frac(temp1.z);
    // lrp r2.z, r1.w, r1.z, -r1.z
    temp2.z = lerp(-temp1.z, temp1.z, temp1.w);
    // mul r1.z, r2.z, c54.y
    temp1.z = temp2.z * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.y;
    // mul r1.w, r1.z, c46.x
    temp1.w = temp1.z * expr46.x;
    // abs r2.z, r1.w
    temp2.z = abs(temp1.w);
    // frc r2.z, r2.z
    temp2.z = frac(temp2.z);
    // sge r2.w, r1.w, -r1.w
    temp2.w = (temp1.w >= -temp1.w) ? 1 : 0;
    // lrp r3.x, r2.w, r2.z, -r2.z
    temp3.x = lerp(-temp2.z, temp2.z, temp2.w);
    // mul r1.z, r3.x, c54.x
    temp1.z = temp3.x * Draw.VideoTex_NumPerRow_LastFrame_SingleRow_isRand.x;
    // frc r2.zw, r1
    temp2.zw = frac(temp1.zw);
    // add r1.zw, r1, -r2
    temp1.zw = temp1.zw + -temp2.zw;
    // add r1.zw, r2.xyxy, r1
    temp1.zw = temp2.xy + temp1.zw;
    // mul r1.zw, r1, c46.x
    temp1.zw = temp1.zw * expr46.xx;
    // mad r1.xy, r1, c46.x, -r1.zwzw
    temp1.xy = temp1.xy * expr46.xx + -temp1.zw;
    // mad r1.xy, c51.x, r1, r1.zwzw
    temp1.xy = expr51.xx * temp1.xy + temp1.zw;
    // mad r0.xw, r0, c46.x, -r1.xyzy
    temp0.xw = temp0.xw * expr46.xx + -temp1.xy;
    // mad r0.xw, c52.x, r0, r1.xyzy
    temp0.xw = expr52.xx * temp0.xw + temp1.xy;
    // mov r4.y, c45.x
    temp4.y = expr45.x;
    // add r1.xy, r2, r4
    temp1.xy = temp2.xy + temp4.xy;
    // mad r1.xy, r1, c46.x, -r0.xwzw
    temp1.xy = temp1.xy * expr46.xx + -temp0.xw;
    // mad oT0.xy, c53.x, r1, r0.xwzw
    o.texcoord = expr53.x * temp1 + temp0.xwzw;
    // rcp r0.x, v0.w
    temp0.x = 1.0f / i.position.w;
    // mul r0.x, r0.z, r0.x
    temp0.x = temp0.z * temp0.x;
    // mov r1, c57
    temp1 = Draw.ColorAnimationFunctions[2];
    // mad r1, r1, r0.x, c58
    temp1 = temp1 * temp0.x + Draw.ColorAnimationFunctions[3];
    // mov r2, c59
    temp2 = Draw.ColorAnimationFunctions[4];
    // mad r2, r2, r0.x, c60
    temp2 = temp2 * temp0.x + Draw.ColorAnimationFunctions[5];
    // slt r0.zw, r0.x, c61.xyyz
    temp0.zw = (temp0.xx < Draw.TimeKeys.yz) ? 1 : 0;
    // mov r3, c55
    temp3 = Draw.ColorAnimationFunctions[0];
    // mad r3, r3, r0.x, c56
    temp3 = temp3 * temp0.x + Draw.ColorAnimationFunctions[1];
    // lrp r4, r0.w, r1, r2
    temp4 = lerp(temp2, temp1, temp0.w);
    // lrp r1, r0.z, r3, r4
    temp1 = lerp(temp4, temp3, temp0.z);
    // mul oD0, r0.y, r1
    o.color = temp0.y * temp1;
    // mov oT1.xyz, c27.z
    o.texcoord1 = float4(0, 0, 0, 0);
    // 

    return o;
}

// Default_L_PixelShader24 Pixel_2_0 Has PRES False
struct Default_L_PixelShader24_Input
{
    float2 texcoord : TEXCOORD;
    float4 color : COLOR;
};

float4 Default_L_PixelShader24(Default_L_PixelShader24_Input i) : COLOR
{
    float4 out_color;
    float4 temp0;
    // dcl t0.xy
    // dcl v0
    // dcl_2d s0
    // texld r0, t0, s0
    temp0 = tex2D(ParticleTextureSamplerSampler, i.texcoord.xy);
    // mul r0, r0, v0
    temp0 = temp0 * i.color;
    // mov oC0, r0
    out_color = temp0;
    // 

    return out_color;
}

// Default_L_Expression25 Expression_2_0 Has PRES False
float Default_L_Expression25()
{
    float1 expr0;
    // add c0.x, c11.x, (-1)
    expr0.x = GeometryUpdate.RotationType.x + (-1);
    return expr0;
}

// Default_Expression26 Expression_2_0 Has PRES False
float Default_Expression26()
{
    float4 temp0;
    float4 temp1;
    float4 temp2;
    float1 expr0;
    // add r0.x, c8.x, (-3)
    temp0.x = Draw.ShaderType.x + (-3);
    // mul r1.x, r0.x, r0.x
    temp1.x = temp0.x * temp0.x;
    // neg r0.x, r1.x
    temp0.x = -temp1.x;
    // ge r2.x, r0.x, r1.x
    temp2.x = temp0.x >= temp1.x;
    // add r0.x, r2.x, (-2)
    temp0.x = temp2.x + (-2);
    // mul r1.x, r0.x, c9.x
    temp1.x = temp0.x * ShouldDrawParticleSoft.x;
    // add r0.x, r1.x, (2)
    temp0.x = temp1.x + (2);
    // mul c0.x, r0.x, (3)
    expr0.x = temp0.x * (3);
    return expr0;
}

// Default_Expression27 Expression_2_0 Has PRES False
float Default_Expression27()
{
    float1 expr0;
    // add c0.x, c11.x, (-1)
    expr0.x = GeometryUpdate.RotationType.x + (-1);
    return expr0;
}

technique Default
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = VS_Array_H[Default_Expression27()]; // 47
        PixelShader = PS_Array_H[Default_Expression26()]; // 48
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique Default_L
{
    pass P0 <string ExpressionEvaluator = "Particle";>
    {
        VertexShader = VS_Array_L[Default_L_Expression25()]; // 50
        PixelShader = compile ps_2_0 Default_L_PixelShader24(); // 51
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 0;
        CullMode = 1;
        AlphaBlendEnable = 1;
        AlphaFunc = 7;
        AlphaRef = 96;
    }
}

technique _CreateShadowMap
{
    pass P0 <string ExpressionEvaluator = "GPUParticle_CreateShadowMap";>
    {
        VertexShader = compile vs_2_0 _CreateShadowMap_VertexShader23(); // 59
        PixelShader = PSCreateShadowMap_Array[_CreateShadowMap_Expression22()]; // 60
        ZEnable = 1;
        ZFunc = 4;
        ZWriteEnable = 1;
        CullMode = 1;
        AlphaBlendEnable = 0;
        AlphaTestEnable = 0;
    }
}

